unit ChartSel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls;

type
  TfmSelectGr = class(TForm)
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    StatusBar1: TStatusBar;
  private
    { Private declarations }
  public
    { Public declarations }
    MaxGr: Integer;
    SelectedCount: Integer;
    Procedure Enter;
  end;

var
  fmSelectGr: TfmSelectGr;

implementation

uses ChartMy;
{$R *.DFM}
Procedure TfmSelectGr.Enter;
  var I,J,K: integer;
begin
   ListBox1.Items.Clear;
   MaxGr:=fmChart.Chart.SeriesCount;
   J:= fmChart.Chart.SeriesCount;
   K:= fmChart.FileNames.Count;
   if J<>K then ShowMessage(': SeriesCount = '+ Inttostr(J)+#13+'FileNames.Count =  '+ Inttostr(K));
   for  I:=0 to J-1 do
      if  fmChart.Chart.Series[i].Tag=0  then
            ListBox1.Items.Add(fmChart.FileNames[I]+': ' +fmChart.Chart.Series[I].Title);
   ListBox1.Selected[fmChart.ActiveSesia]:=True;


  if ShowModal=mrOk then
    begin
     SelectedCount:=0;
     for I:=0 to ListBox1.Items.Count-1 do
            if ListBox1.Selected[I] then SelectedCount:=SelectedCount+1;
     if SelectedCount = 0
      then
       begin
       ShowMessage('  ');
       ModalResult:=mrNone;
       end;
    end;   
end;

end.
