unit D3OpenMain;

interface
uses
 Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OpenGL, StdCtrls, Menus, ExtCtrls, ComCtrls, Math, Buttons, N3dUtils,
  Spin, Grids;


type
    tRGB = array[1..4] of single;
    TLayerColor= array[1..8] of tRGB;
    tSpace = array[1..NX,1..NY,1..NZ] of byte;
    tLayer = record
              Color: tColor;
              visible: boolean;
              Sig,Eps,Mu : double;
              Comment: String;
             end;
    tLayers = array[1..254] of tLayer;
type tPoint3D = record
        X,Y,Z : double;
        end;
type
  TfmOpenGL = class(TForm)
    MainMenu1: TMainMenu;
    Panel1: TPanel;
    bScreen: TBevel;
    StatusBar1: TStatusBar;
    Panel4: TPanel;
    Timer1: TTimer;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    N1: TMenuItem;
    OpenCelFile: TOpenDialog;
    N2: TMenuItem;
    rbX: TMenuItem;
    rbY: TMenuItem;
    rbZ: TMenuItem;
    rbOff: TMenuItem;
    GroupBox2: TGroupBox;
    StringGrid1: TStringGrid;
    PopupMenu1: TPopupMenu;
    rbZ1: TMenuItem;
    rbY1: TMenuItem;
    rbX1: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N7: TMenuItem;
    mnDeleteAll: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    Panel2: TPanel;
    btnPen: TSpeedButton;
    btnFill: TSpeedButton;
    btnLine: TSpeedButton;
    Panel3: TPanel;
    SpinEdit2: TSpinEdit;
    SpinEdit1: TSpinEdit;
    SpinEdit3: TSpinEdit;
    lbCoord: TLabel;
    lb2: TLabel;
    Panel5: TPanel;
    lb1: TLabel;
    lbCoord2: TLabel;
    btnEraser: TSpeedButton;
    btnSelect: TSpeedButton;
    N5: TMenuItem;
    mnDelSelected: TMenuItem;
    mnCopy: TMenuItem;
    N6: TMenuItem;
    mnN11: TMenuItem;
    Ex1: TMenuItem;
    Ey1: TMenuItem;
    Ez1: TMenuItem;
    mnE1: TMenuItem;
    mnH1: TMenuItem;
    Hx1: TMenuItem;
    Hy1: TMenuItem;
    Hz1: TMenuItem;
    E2: TMenuItem;
    H2: TMenuItem;
    mnI1: TMenuItem;
    Ix1: TMenuItem;
    Iy1: TMenuItem;
    Iz1: TMenuItem;
    I2: TMenuItem;
    mnJ1: TMenuItem;
    Jx1: TMenuItem;
    Jy1: TMenuItem;
    Jz1: TMenuItem;
    J2: TMenuItem;
    Timer2: TTimer;
    btnX: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton4: TSpeedButton;
    btnY: TSpeedButton;
    btnZ: TSpeedButton;
    btnOutputPoints: TSpeedButton;
    N11: TMenuItem;
    mnMove: TMenuItem;
    N8: TMenuItem;
    N15: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    mnShapeRotate: TMenuItem;
    N901: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    lbSloy: TLabel;
    Shape1: TShape;
    Label2: TLabel;
    mnUndo: TMenuItem;
    N3: TMenuItem;
    lbSpeed: TLabel;
    N4: TMenuItem;
    mnGround: TMenuItem;
    N16: TMenuItem;
    mnCellParms: TMenuItem;
    Label1: TLabel;
    btnLine3D: TSpeedButton;
    N17: TMenuItem;
    btn3Dfill: TSpeedButton;
    btnLine3Dcontunue: TSpeedButton;
    Splitter1: TSplitter;
    N20: TMenuItem;
    mnShowCLines: TMenuItem;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpeedButton1Click(Sender: TObject);
    procedure btnResetClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure SpinEdit1Change(Sender: TObject);
    procedure rbXClick(Sender: TObject);
    procedure rbYClick(Sender: TObject);
    procedure rbZClick(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure StringGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure rbOffClick(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGrid1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
    procedure btnPenClick(Sender: TObject);
    procedure btnFillClick(Sender: TObject);
    procedure btnLineClick(Sender: TObject);
    procedure btnEraserClick(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure mnDelSelectedClick(Sender: TObject);
    procedure mnCopyClick(Sender: TObject);
    procedure E2Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure mnMoveClick(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnShapeRotateClick(Sender: TObject);
    procedure X2Click(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnUndoClick(Sender: TObject);
    procedure mnGroundClick(Sender: TObject);
    procedure mnCellParmsClick(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure N17Click(Sender: TObject);
    procedure btn3DfillClick(Sender: TObject);
    procedure Panel4Resize(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnShowCLinesClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     hrc: HGLRC;
     DC : hdc ;
     DrawX,DrawY: Integer; //     
     DrawWidth:  Integer;//  
     DrawHeight: Integer;
     IPF: Integer;//      ()
     Xo, Yo, Zo: Single;//   
     Xv, Yv, Zv: Single;//   
     Color1: tRGB;
     Step: single; //  
     StepAlfa: single; //  , 
     Layers,UndoLayers: tLayers;
     LayerCount,UndoLayerCount: Integer;
//     LayerSelected: Integer;
     LayerColor: TLayerColor;
     LayerCurrent: Integer;
     Space, UndoSpace : tSpace;
     Sx,Sy,Sz: Integer;
     MouseDown: boolean;
     LastRow, LastCol  : Integer;
     StartPoint, EndPoint: TPoint;
     Selected: boolean;
     StartSelect, EndSelect: TPoint;
     OtputPoint: array[1..50] of t3DPoint;
     StepX,StepY,StepZ: double;
     Koef : integer;//    DXF
     Row_Selected,Col_Selected: Integer;
     X_Selected,Y_Selected,Z_Selected: Integer;
     X_Current,Y_Current,Z_Current: Integer;
     dalfa: double;
    procedure InitViewport;
    procedure SetDCPixelFormat;
    procedure DrawAxies;
    procedure DrawOutPoint;
    procedure GetOutPoint;
    function  IsOutPoint(X,Y,Z: Integer): Boolean;
    procedure Draw;
    procedure LookAt;
    procedure Povorot;
    procedure Sechenie;
    procedure SetCel(Row, Col: Integer);
    procedure Eraser(Row, Col: Integer);
    procedure SetLine;
    procedure SetFill;
    procedure Set3DFill;
    procedure DrawBox(X,Y,Z: glFloat;// 
                      Xw,Yw,Zw : glFloat; //
                      BaseColor: tRGB
                      );

    procedure SaveUndo;
    procedure RestoreUndo;
    procedure Line3D(P1, P2 :tPoint3D;
                            StepX, StepY,StepZ: double; NLayer: Integer;
                            SdvigX, SdvigY, SdvigZ: Integer);

    procedure Triangle3D(P1, P2, P3 :tPoint3D;
                            StepX, StepY, StepZ: double; NLayer: Integer;
                            SdvigX, SdvigY, SdvigZ: Integer);
    procedure DXF_Parser(FileName: string);
    Procedure D3Face(P1, P2, P3, P4:tPoint3D;
                 StepX,StepY,StepZ: Double;
                 Layer, SdvigX, SdvigY, SdvigZ : Integer);
    Function GetLayerByName(Name: String):Integer;
    Procedure SetLine3d;
    procedure  SetCurrentSell(Col,Row: Integer);
    end;

var
  fmOpenGL: TfmOpenGL;
 type tFace = record
              P1, P2, P3, P4 : tPoint3D;
              Layer: Integer;
              end;
  var Faces: array of tFace;

const
  DEG2RAD = Pi / 180.0;
  DIST = 20.0;
  cyan : tRGB = (0.0, 1.0, 1.0, 1.0);
  green: tRGB = (0, 1.0, 0, 1.0);
  red: tRGB = (1, 0, 0, 1.0);
  blue: tRGB = (0, 0, 1, 1.0);
  black: tRGB = (0, 0, 0, 1.0);
  yellow: tRGB = (1, 1, 0, 1.0);
  fuchsia: tRGB = (1, 0, 1, 1.0);
  white: tRGB = (1, 1, 1, 1.0);


implementation

uses D3Layers, Utillits, N3dMain, D3Obj, D3Copy, N3Move, D3Rotate, D3Param,
  D3Triangle, D3CellParms;

{$R *.DFM}
procedure TfmOpenGL.SaveUndo;
  var i,j,k : Integer;
begin
  fmNew3dMain. ProjectEdited:=True;
 mnUndo.Enabled:=True;
 for I:=1 to xsize do
   for j:=1 to ysize do
      for k:=1 to zsize do begin
        UndoSpace[i,j,k]:= Space[i,j,k];
        end;
 UndoLayerCount:=LayerCount;
 for i:=1 to 254 do
           begin
           UndoLayers[i].Color:=  Layers[i].Color;
           UndoLayers[i].visible:=Layers[i].visible;
           UndoLayers[i].Sig:=    Layers[i].Sig;
           UndoLayers[i].Eps:=    Layers[i].Eps;
           UndoLayers[i].Mu:=     Layers[i].Mu;
           UndoLayers[i].Comment:=Layers[i].Comment;
           end;

end;
procedure TfmOpenGL.RestoreUndo;
  var i,j,k : Integer;
begin
 fmNew3dMain. ProjectEdited:=True;
 mnUndo.Enabled:=False;
 for I:=1 to xsize do
   for j:=1 to ysize do
      for k:=1 to zsize do begin
        Space[i,j,k]:= UndoSpace[i,j,k];
        end;
 LayerCount:=UndoLayerCount;
 for i:=1 to 254 do
           begin
           Layers[i].Color:=  UndoLayers[i].Color;
           Layers[i].visible:=UndoLayers[i].visible;
           Layers[i].Sig:=    UndoLayers[i].Sig;
           Layers[i].Eps:=    UndoLayers[i].Eps;
           Layers[i].Mu:=     UndoLayers[i].Mu;
           Layers[i].Comment:=UndoLayers[i].Comment;
           end;
end;

procedure TfmOpenGL.GetOutPoint;
 var I,X,Y,Z: Integer;
begin

       for I:=2 to fmNew3dMain.StringGrid1.RowCount-1 do
             begin
                 OtputPoint[I-1].X:=0;
                 OtputPoint[I-1].Y:=0;
                 OtputPoint[I-1].Z:=0;
               try
               if fmNew3dMain.StringGrid1.Cells[0,I]<>'' then begin
                  x:=StrToInt(fmNew3dMain.StringGrid1.Cells[2,I]);
                  y:=StrToInt(fmNew3dMain.StringGrid1.Cells[3,I]);
                  z:=StrToInt(fmNew3dMain.StringGrid1.Cells[4,I]);
                  OtputPoint[I-1].X:=x;
                  OtputPoint[I-1].Y:=y;
                  OtputPoint[I-1].Z:=z;
                  end;
               except
                 OtputPoint[I-1].X:=0;
                 OtputPoint[I-1].Y:=0;
                 OtputPoint[I-1].Z:=0;
               end;
             end;

end;

procedure TfmOpenGL.Sechenie;
begin

  glPolygonMode(GL_FRONT{_AND_BACK},GL_FILL);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_ALPHA_TEST);
  glEnable(GL_BLEND);
   glBlendFunc(GL_SRC_ALPHA_SATURATE,GL_SRC_COLOR);
   glAlphaFunc(GL_ALWAYS,0.1);
//   glBlendFunc(GL_SRC_ALPHA_SATURATE,GL_SRC_COLOR);
//   glAlphaFunc(GL_ALWAYS,0.5);
      glColor4f(0.6,0.6,0.6,0.2);
   if rbY.Checked then begin
      glBegin(GL_QUADS);
      glVertex3f(StepX,(SpinEdit2.Value+0.5)*StepY,StepZ);
      glVertex3f((XSize+1)*StepX,(SpinEdit2.Value+0.5)*StepY,StepZ);
      glVertex3f((XSize+1)*StepX,(SpinEdit2.Value+0.5)*StepY,(ZSize+1)*StepZ);
      glVertex3f(StepX,(SpinEdit2.Value+0.5)*StepY,(ZSize+1)*StepZ);
      glEnd();
      end;
   if rbX.Checked then begin
      glBegin(GL_QUADS);
      glVertex3f((SpinEdit1.Value+0.5)*StepX,StepY,StepZ);
      glVertex3f((SpinEdit1.Value+0.5)*StepX,(YSize+1)*StepY,StepZ);
      glVertex3f((SpinEdit1.Value+0.5)*StepX,(YSize+1)*StepY,(ZSize+1)*StepZ);
      glVertex3f((SpinEdit1.Value+0.5)*StepX,StepY,(ZSize+1)*StepZ);
      glEnd();
      end;
   if rbZ.Checked then begin
      glBegin(GL_QUADS);
      glVertex3f(StepX,StepY,(SpinEdit3.Value+0.5)*StepZ);
      glVertex3f(StepX,(YSize+1)*StepY,(SpinEdit3.Value+0.5)*StepZ);
      glVertex3f((XSize+1)*StepX,(YSize+1)*StepY,(SpinEdit3.Value+0.5)*StepZ);
      glVertex3f((XSize+1)*StepX,StepY,(SpinEdit3.Value+0.5)*StepZ);
      glEnd();
      end;
  glDisable(GL_ALPHA_TEST);
  glDisable(GL_BLEND);
end;

procedure TfmOpenGL.FormCreate(Sender: TObject);
 var i,j,k: integer;
begin
     dalfa:=0.2;

     StatusBar1.Panels[0].Width:=bScreen.Width;
     X_Selected:=1;
     Y_Selected:=1;
     Z_Selected:=1;
     StatusBar1.Panels[1].Text:='  '+
           IntToStr(X_Selected)+', '+IntToStr(Y_Selected)+', '+IntToStr(Z_Selected);
 Koef:=10;
 mnUndo.Enabled:=False;
 LayerCurrent:=1;
 Sx:=SpinEdit1.Value;
 Sy:=SpinEdit2.Value;
 Sz:=SpinEdit3.Value;
  for i:=1 to nx do for j:=1 to ny do for k:=1 to nz do
        Space[i,j,k]:=0;
  LayerCount:=1;
  for i:=1 to 254 do
        begin
        Layers[i].Visible:=True;//   
        Layers[i].Eps:=1;//   
        Layers[i].Sig:=1e7;// , /
        Layers[i].Mu:=1;//   
        Layers[i].Color:=clRed;//   
        case i of
            1:  Layers[i].Color:=clRed ;
            2:  Layers[i].Color:=clBlue ;
            3:  Layers[i].Color:=clGreen;
            4:  Layers[i].Color:=clYellow;
            5:  Layers[i].Color:=clAqua;
            6:  Layers[i].Color:=clFuchsia;
            7:  Layers[i].Color:=clTeal;
            8:  Layers[i].Color:=clGray;
            9:  Layers[i].Color:=clLime;
            10:  Layers[i].Color:=clLtGray;
            11:  Layers[i].Color:=clMaroon;
            12:  Layers[i].Color:=clNavy;
            13:  Layers[i].Color:=clOlive;
            14:  Layers[i].Color:=clPurple;
            15:  Layers[i].Color:=clSilver;
            17:  Layers[i].Color:=clBlack;

          end;
        Layers[i].Comment:=' ';
        end;

  DC := GetDC(Handle);
  SetDCPixelFormat;
  hrc := wglCreateContext(DC);
  wglMakeCurrent(DC, hrc);
  InitViewport;
  glEnable(GL_DEPTH_TEST);

Step:=1;
StepAlfa:=5;

LayerColor[1] := cyan;
LayerColor[2] := green;
LayerColor[3] := fuchsia;
LayerColor[4] := red;
LayerColor[5] := blue;
LayerColor[6] := yellow;
LayerColor[7] := white;
LayerColor[8] := black;
 Sx:=1;
 Sy:=1;
 Sz:=1;
LayerCurrent:=1;
lb1.Caption:='';
lb2.Caption:='';
SpinEdit1.MaxValue:=Nx;
SpinEdit2.MaxValue:=Ny;
SpinEdit3.MaxValue:=Nz;
end;

procedure TfmOpenGL.FormDestroy(Sender: TObject);
begin
  wglMakeCurrent(0, 0);
  wglDeleteContext(hrc);
  ReleaseDC(Handle, DC);
end;

//    Viewporta
procedure TfmOpenGL.InitViewport;
begin
   //   
   bScreen.Width:=fmOpenGL.ClientWidth-Panel4.Width;
   bScreen.Height:=fmOpenGL.ClientHeight-bScreen.Top-StatusBar1.Height;
   Xo:=NX /2;
   Yo:=NY /2;
   Zo:=NZ *2;
   Xv:=NX /2;
   Yv:=NY /2;
   Zv:=NZ /2;
  //      
  glViewport( bScreen.Left+3,
              fmOpenGL.ClientHeight-(bScreen.Top+bScreen.Height)+3,
              bScreen.Width-6,
              bScreen.Height-6);

  //   
  glDepthRange(-100,100);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60,bScreen.Width/bScreen.Height,1,1000);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(Xo,Yo,Zo,Xv,Yv,Zv,0,1000,0);
end;

procedure TfmOpenGL.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  var R: single;
      dX,dY,dZ: single;
      Alfa: double;
begin
  //  
 if (ssShift in Shift) then begin
     Step:=1;
     StepAlfa:=1;
     dalfa:=0.1;
 StatusBar1.Panels[0].Text:=' ';
     end
     else begin
     Step:=10;
     StepAlfa:=10;
     dalfa:=0.2;
 StatusBar1.Panels[0].Text:=' ';
     end;
 if (ssCtrl in Shift) then begin
     Step:=100;
     StepAlfa:=20;
     dalfa:=0.5;
 StatusBar1.Panels[0].Text:=' ';
     end;

 if   (Key= ord('V'))or(Key= ord('v')) then
   begin
  //  
        Yo:=Yo+Step;
        Yv:=Yv+Step;
     Key:=0;
        LookAt;
  end;

 if   (Key= ord('C'))or(Key= ord('c')) then
   begin
  //  
        Yo:=Yo-Step;
        Yv:=Yv-Step;
     Key:=0;
        LookAt;
  end;

 if   Key=VK_End then begin
  //     
    Yv:=Yo;
     Key:=0;
        LookAt;
     end;

 if   Key=VK_Delete then
   begin
  //  
   R:=SQRT(SQR(Xv-Xo)+SQR(Zv-Zo));
   Alfa:=ArcTan2((Yv-Yo),R);
   Alfa:=Alfa-StepAlfa*Pi/180;
        Yv:=Yo+R*Tan(Alfa);
     Key:=0;
        LookAt;
  end;

 if   Key=VK_Next {Page Down} then
  begin
  //  
   R:=SQRT(SQR(Xv-Xo)+SQR(Zv-Zo));
   Alfa:=ArcTan2((Yv-Yo),R);
   Alfa:=Alfa+StepAlfa*Pi/180;
        Yv:=Yo+R*Tan(Alfa);
     Key:=0;
        LookAt;
   end;

 if   Key=VK_UP then
  begin
   //  
    R:=SQRT(SQR(Xo-Xv)+SQR(Yo-Yv)+SQR(Zo-Zv));
    dX:=(Xv-Xo)*Step/R;
    dY:=(Yv-Yo)*Step/R;
    dZ:=(Zv-Zo)*Step/R;
    Xv:=Xv+dX;
    Yv:=Yv+dY;
    Zv:=Zv+dZ;
    Xo:=Xo+dX;
    Yo:=Yo+dY;
    Zo:=Zo+dZ;
     Key:=0;
        LookAt;
  end;

 if   Key=VK_Down then
  begin
   //  
    R:=SQRT(SQR(Xo-Xv)+SQR(Yo-Yv)+SQR(Zo-Zv));
    dX:=(Xv-Xo)*Step/R;
    dY:=(Yv-Yo)*Step/R;
    dZ:=(Zv-Zo)*Step/R;
    Xv:=Xv-dX;
    Yv:=Yv-dY;
    Zv:=Zv-dZ;
    Xo:=Xo-dX;
    Yo:=Yo-dY;
    Zo:=Zo-dZ;
     Key:=0;
    LookAt;
  end;

 if   Key=VK_Left then
 if not (ssAlt in Shift) then
  begin
  //  
   R:=SQRT(SQR(Xv-Xo)+SQR(Zv-Zo));
   Alfa:=ArcCos((Xv-Xo)/R);
   if (Zv-Zo)>0 then Alfa:=-Alfa;
   R:=10;
   Alfa:=Alfa+StepAlfa*Pi/180;
   Xv:=Cos(Alfa)*R+Xo;
   Zv:=-Sin(Alfa)*R+Zo;
     Key:=0;
   LookAt;
  end
  else begin
  //  
   R:=SQRT(SQR(Xv-Xo)+SQR(Zv-Zo));
   Alfa:=ArcCos((Xv-Xo)/R);
   if (Zv-Zo)>0 then Alfa:=-Alfa;
        Xo:=Xo-Step*Cos(Pi/2-Alfa);
        Xv:=Xv-Step*Cos(Pi/2-Alfa);
        Zo:=Zo-Step*Sin(Pi/2-Alfa);
        Zv:=Zv-Step*Sin(Pi/2-Alfa);
     Key:=0;
    LookAt;
  end;

 if   Key=VK_Right then
 if not (ssAlt in Shift) then
  begin
  //  
   R:=SQRT(SQR(Xv-Xo)+SQR(Zv-Zo));
   Alfa:=ArcCos((Xv-Xo)/R);
   if (Zv-Zo)>0 then Alfa:=-Alfa;
   Alfa:=Alfa-StepAlfa*Pi/180;
   R:=10;
   Xv:=Cos(Alfa)*R+Xo;
   Zv:=-Sin(Alfa)*R+Zo;
     Key:=0;
   LookAt;
  end
  else begin
  //  
   R:=SQRT(SQR(Xv-Xo)+SQR(Zv-Zo));
   Alfa:=ArcCos((Xv-Xo)/R);
   if (Zv-Zo)>0 then Alfa:=-Alfa;
        Xo:=Xo+Step*Cos(Pi/2-Alfa);
        Xv:=Xv+Step*Cos(Pi/2-Alfa);
        Zo:=Zo+Step*Sin(Pi/2-Alfa);
        Zv:=Zv+Step*Sin(Pi/2-Alfa);
     Key:=0;
    LookAt;
  end;
end;


procedure TfmOpenGL.DrawAxies;
begin
//    StepX,StepY,StepZ: double;
 //  
  glColor3f(0, 0, 0);
//  glPushMatrix();
    glBegin(GL_LINES);
         //  
      glColor3f(1, 0, 0);
        glVertex3f(1,1,1);
        glVertex3f((XSize+1)*StepX,1,1);
      glColor3f(0, 1, 0);
        glVertex3f(1,1,1);
        glVertex3f(1,(YSize+1)*StepY,1);
      glColor3f(0, 0, 1);
        glVertex3f(1,1,1);
        glVertex3f(1,1,(ZSize+1)*StepZ);
         //  
      glColor3f( 0.75,  0.75, 0.75);
        glVertex3f((XSize+1)*StepX,1,1);
        glVertex3f((XSize+1)*StepX,(YSize+1)*StepY,1);
        glVertex3f((XSize+1)*StepX,1,1);
        glVertex3f((XSize+1)*StepX,1,(ZSize+1)*StepZ);

        glVertex3f(1,(YSize+1)*StepY,1);
        glVertex3f((XSize+1)*StepX,(YSize+1)*StepY,1);
        glVertex3f(1,(YSize+1)*StepY,1);
        glVertex3f(1,(YSize+1)*StepY,(ZSize+1)*StepZ);

        glVertex3f(1,1,(ZSize+1)*StepZ);
        glVertex3f((XSize+1)*StepX,1,(ZSize+1)*StepZ);

        glVertex3f(1,1,(ZSize+1)*StepZ);
        glVertex3f(1,(YSize+1)*StepY,(ZSize+1)*StepZ);

        glVertex3f((XSize+1)*StepX,(YSize+1)*StepY,(ZSize+1)*StepZ);
        glVertex3f(1,(YSize+1)*StepY,(ZSize+1)*StepZ);
        glVertex3f((XSize+1)*StepX,(YSize+1)*StepY,(ZSize+1)*StepZ);
        glVertex3f((XSize+1)*StepX,1,(ZSize+1)*StepZ);
        glVertex3f((XSize+1)*StepX,(YSize+1)*StepY,(ZSize+1)*StepZ);
        glVertex3f((XSize+1)*StepX,(YSize+1)*StepY,1);
    glEnd();
 //  
 if   mnGround.Checked then begin
   glEnable(GL_ALPHA_TEST);
  glEnable(GL_BLEND);
   glBlendFunc(GL_SRC_ALPHA_SATURATE,GL_SRC_COLOR);
   glAlphaFunc(GL_ALWAYS,0.1);
      glPolygonMode(GL_FRONT{_AND_BACK},GL_FILL);
      glBegin(GL_QUADS);
      glColor4f(0,1,0,0.5);
      glVertex3f(1,1,1);
      glVertex3f((XSize+1)*StepX,1,1);
      glVertex3f((XSize+1)*StepX,1,(ZSize+1)*StepZ);
      glVertex3f(1,1,(ZSize+1)*StepZ);
      glEnd();
  glDisable(GL_ALPHA_TEST);
  glDisable(GL_BLEND);
  end;
//  glPopMatrix();
end;

function TfmOpenGL.IsOutPoint(X,Y,Z: Integer): Boolean;
 var I: Integer;
begin
  result:= false;
       for I:=1 to 50 do
             begin
               if OtputPoint[I].X<>0 then
                  if x=OtputPoint[I].X then
                    if y=OtputPoint[I].Y then
                     if z=OtputPoint[I].Z then
                       begin
                       result:= true;
                       exit;
                       end;
             end;
end;

procedure TfmOpenGL.DrawOutPoint;
 var I: Integer;
     X,Y,Z: Integer;
begin
         //  
       for I:=1 to 50 do
             begin
               try
                 x:=OtputPoint[I].X;
                 y:=OtputPoint[I].Y;
                 z:=OtputPoint[I].Z;
                 if (x<1) or (y<1) or(z<1) then continue;
                 DrawBox((X+0.25)*StepX,(Y+0.25)*StepY,(Z+0.25)*StepZ,
                        0.5*StepX,0.5*StepY,0.5*StepZ,LayerColor[5]);
               except
               end;
             end;
                 if fmNew3dMain.rbNoInput.Checked then
                     begin
                     //      
                     x:=fmParam.spX.Value;
                     y:=fmParam.spY.Value;
                     z:=fmParam.spZ.Value;

//                 glDisable(GL_DEPTH_TEST);
                     glColor4f(1,1,1,0);
                 glBegin(GL_TRIANGLES);
                   glVertex3f((X-0.1)*StepX,Y*StepY,Z*StepZ);
                   glVertex3f((X-0.1)*StepX,(Y+1)*StepY,Z*StepZ);
                   glVertex3f((X-0.1)*StepX,(Y+1)*StepY,(Z+1)*StepZ);

                   glVertex3f((X+1.1)*StepX,Y*StepY,Z*StepZ);
                   glVertex3f((X+1.1)*StepX,Y*StepY,(Z+1)*StepZ);
                   glVertex3f((X+1.1)*StepX,(Y+1)*StepY,(Z+1)*StepZ);

                   glVertex3f(X*StepX,Y*StepY,(Z+1.1)*StepZ);
                   glVertex3f(X*StepX,(Y+1)*StepY,(Z+1.1)*StepZ);
                   glVertex3f((X+1)*StepX,(Y+1)*StepY,(Z+1.1)*StepZ);

                   glVertex3f(X*StepX,Y*StepY,(Z-1.1)*StepZ);
                   glVertex3f(X*StepX,(Y+1)*StepY,(Z-1.1)*StepZ);
                   glVertex3f((X+1)*StepX,(Y+1)*StepY,(Z-1.1)*StepZ);
                 glEnd;

                     end;
end;
procedure TfmOpenGL.Draw;
var I,j,k: integer;
    k1: integer;
    CurrentLayer, OldLayer: Integer;
    X1,Y1,Z1: Integer;
    CurrentColor: tRGB;
begin
StepX:=1;
StepY:=StrToFloat(fmNew3dMain.edY.Text)/StrToFloat(fmNew3dMain.edX.Text);
StepZ:=StrToFloat(fmNew3dMain.edZ.Text)/StrToFloat(fmNew3dMain.edX.Text);
// 
  glClearColor(1, 1, 1, 1.0);
//  glClearColor(0.5,0.5,0.5,1.0);
//  glClearColor(0.25,0.25,0.25,1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
   glPolygonMode(GL_FRONT{_AND_BACK},GL_FILL);
  glEnable(GL_DEPTH_TEST);

//     Y
  K1:=0;
  CurrentLayer:=Space[1,1,1];
  OldLayer:=CurrentLayer;
  X1:=1; Y1:=1; Z1:=1;
 for I:=1 to nx do
    for k:=1 to nz do begin
      for j:=1 to ny do begin
        CurrentLayer:=Space[i,j,k];
        if (CurrentLayer = OldLayer) then
             begin
               inc(K1);
               if (j<ny) then  Continue;
               end;
        if  OldLayer<>0 then
             begin
               if Layers[OldLayer].Visible  then
                    begin
                    CurrentColor[1]:=GetRValue(Layers[OldLayer].Color)/255;
                    CurrentColor[2]:=GetGValue(Layers[OldLayer].Color)/255;
                    CurrentColor[3]:=GetBValue(Layers[OldLayer].Color)/255;
                    CurrentColor[4]:=1;
                    DrawBox(X1*StepX,Y1*StepY,Z1*StepZ,StepX,K1*StepY,StepZ,CurrentColor);
                    end;
               end;
             X1:=I; Y1:=J; Z1:=K;
             if Y1=nY then Y1:=1;
             OldLayer:=CurrentLayer;
             K1:=1;
        end;
       end;


 //   
  if not  mnShowCLines.Checked then DrawAxies;
 //      
  DrawOutPoint;

 //  
  if not rbOff.Checked then Sechenie;

  glDisable(GL_DEPTH_TEST);

  glFinish;
  SwapBuffers(DC);
end;

procedure TfmOpenGL.FormPaint(Sender: TObject);
begin

LookAt;

end;

procedure TfmOpenGL.DrawBox(X,Y,Z: glFloat;// 
                      Xw,Yw,Zw : glFloat;  //
                      BaseColor: tRGB );
begin
  // 
//   glPolygonMode(GL_FRONT{_AND_BACK},Mode);
    glBegin(GL_QUADS);
    glEnable(GL_POLYGON_SMOOTH);
      //1 ,   Z
    glColor4f(BaseColor[1],BaseColor[2],BaseColor[3],BaseColor[4]);
      glVertex3f(X,Y,Z);
      glVertex3f(X+Xw,Y,Z);
      glVertex3f(X+Xw,Y+Yw,Z);
      glVertex3f(X,Y+Yw,Z);
      //2 ,   X
    glColor4f(BaseColor[1]*0.75,BaseColor[2]*0.75,BaseColor[3]*0.75,BaseColor[4]);
      glVertex3f(X,Y,Z);
      glVertex3f(X,Y+Yw,Z);
      glVertex3f(X,Y+Yw,Z+Zw);
      glVertex3f(X,Y,Z+Zw);
      //3 ,   Y
    glColor4f(BaseColor[1]/2,BaseColor[2]/2,BaseColor[3]/2,BaseColor[4]);
      glVertex3f(X,Y,Z);
      glVertex3f(X+Xw,Y,Z);
      glVertex3f(X+Xw,Y,Z+Zw);
      glVertex3f(X,Y,Z+Zw);
      //4 ,   Z
    glColor4f(BaseColor[1],BaseColor[2],BaseColor[3],BaseColor[4]);
      glVertex3f(X,Y,Z+Zw);
      glVertex3f(X+Xw,Y,Z+Zw);
      glVertex3f(X+Xw,Y+Yw,Z+Zw);
      glVertex3f(X,Y+Yw,Z+Zw);
      //5 ,   X
    glColor4f(BaseColor[1]*0.75,BaseColor[2]*0.75,BaseColor[3]*0.75,BaseColor[4]);
      glVertex3f(X+Xw,Y,Z);
      glVertex3f(X+Xw,Y+Yw,Z);
      glVertex3f(X+Xw,Y+Yw,Z+Zw);
      glVertex3f(X+Xw,Y,Z+Zw);
      //6 ,   Y
    glColor4f(BaseColor[1]/2,BaseColor[2]/2,BaseColor[3]/2,BaseColor[4]);
      glVertex3f(X,Y+Yw,Z);
      glVertex3f(X+Xw,Y+Yw,Z);
      glVertex3f(X+Xw,Y+Yw,Z+Zw);
      glVertex3f(X,Y+Yw,Z+Zw);
      glDisable(GL_POLYGON_SMOOTH);
    glEnd();

end;

procedure TfmOpenGL.SpeedButton1Click(Sender: TObject);
begin
Timer1.Enabled:= not Timer1.Enabled;
if Timer1.Enabled
    then SpeedButton1.Caption:=''
    else SpeedButton1.Caption:='';

end;

procedure TfmOpenGL.LookAt;
var ticks: dword;
begin
  ticks:=GetTickCount;
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
  gluLookAt(Xo,Yo,Zo,Xv,Yv,Zv,1,1000,1);
      Draw;
  ticks:=GetTickCount-ticks;
  lbSpeed.Caption:=IntToStr(ticks)+ ' c';
end;

procedure TfmOpenGL.btnResetClick(Sender: TObject);
begin
 InitViewport;
 LookAt;
end;
//======================================================================
//  
procedure TfmOpenGL.SetDCPixelFormat;
var
  nPixelFormat: Integer;
  pfd: TPixelFormatDescriptor;
begin
  FillChar(pfd, SizeOf(pfd), 0);

  with pfd do begin
    nSize     := sizeof(pfd);
    nVersion  := 1;
    dwFlags   := PFD_DRAW_TO_WINDOW or
                 PFD_SUPPORT_OPENGL or
                 PFD_DOUBLEBUFFER;
    iPixelType:= PFD_TYPE_RGBA;
    cColorBits:= 24;
    cDepthBits:= 32;
    iLayerType:= PFD_MAIN_PLANE;
  end;

  nPixelFormat := ChoosePixelFormat(DC, @pfd);
  SetPixelFormat(DC, nPixelFormat, @pfd);
end;

procedure TfmOpenGL.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=False;
  Povorot;
  Timer1.Enabled:=True;
end;
procedure TfmOpenGL.Povorot;
 var  R,alfa: double;
begin
  xv:=XSize/2;
  zv:=ZSize/2;
   R:= sqrt(sqr(Xv-Xo)+sqr(Zv-Zo));
   alfa:= ArcTan2((Zo-Zv),(Xo-Xv));
   alfa:=alfa+dalfa;
  Xo:=R*cos(alfa)+Xv;
  Zo:=R*sin(alfa)+Zv;
 LookAt;
end;

procedure TfmOpenGL.FormResize(Sender: TObject);
begin
FormDestroy(nil);
  DC := GetDC(Handle);
  SetDCPixelFormat;
  hrc := wglCreateContext(DC);
  wglMakeCurrent(DC, hrc);
//  InitViewport;
   //   
   bScreen.Width:=fmOpenGL.ClientWidth-Panel4.Width;
   bScreen.Height:=fmOpenGL.ClientHeight-bScreen.Top-StatusBar1.Height;
  //      
  glViewport( bScreen.Left+3,
              fmOpenGL.ClientHeight-(bScreen.Top+bScreen.Height)+3,
              bScreen.Width-6,
              bScreen.Height-6);

  //   
  glDepthRange(-100,100);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60,bScreen.Width/bScreen.Height,1,2000);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(Xo,Yo,Zo,Xv,Yv,Zv,0,100,0);
  glEnable(GL_DEPTH_TEST);
  LookAt;
//   InitViewport;
//    Panel4.Width:=fmOpenGL.ClientWidth-bScreen.Width;
end;

procedure TfmOpenGL.SpeedButton3Click(Sender: TObject);
begin
fmLayers.ShowModal;
   lbSloy.Caption:=Layers[LayerCurrent].Comment;
   Shape1.Brush.Color:=Layers[LayerCurrent].Color;
end;

procedure TfmOpenGL.N1Click(Sender: TObject);
 var F: TextFile;
     St: String;
     I, NLayer: Integer;
     X,Y,Z: Integer;
     dX,dY,dZ: Integer;
     Xo,Yo,Zo: Integer;
     Nall,Nxo,Nyo,Nzo: Integer;
     NL,NE,Nuc : Integer;
     NCell: Cardinal;
     Sig: double;
begin
 if not OpenCelFile.Execute then exit;
// Caption:=UpperCase(ExtractFileExt(OpenCelFile.FileName));

 if UpperCase(ExtractFileExt(OpenCelFile.FileName))='.DXF'
   then begin
    SaveUndo;
    DXF_Parser(OpenCelFile.FileName);
    exit;
   end;

 AssignFile(F,OpenCelFile.FileName);
 if UpperCase(ExtractFileExt(OpenCelFile.FileName))='.CEL'
   then begin
  SaveUndo;
   Reset(F);
 try
   ReadLn(F,St);//CELL file
       if St<>'CELL file' then begin ShowMessage('-');Abort;End;
   ReadLn(F,St);//Egual Rectangular Box
   ReadLn(F,St);//Base point of Rated Area (Xo,Yo,Zo):
   ReadLn(F,St);// 0 0 0
     St:=Trim(St);
     Xo:=Round(StrToFloat(SelectWord(St,1)));
     Yo:=Round(StrToFloat(SelectWord(St,2)));
     Zo:=Round(StrToFloat(SelectWord(St,3)));
   ReadLn(F,St);//Size of Rated Area (X,Y,Z):
   ReadLn(F,St);// 12 7 6
     St:=Trim(St);
     X:=Round(StrToFloat(SelectWord(St,1)));
     Y:=Round(StrToFloat(SelectWord(St,2)));
     Z:=Round(StrToFloat(SelectWord(St,3)));
   ReadLn(F,St);//Cell size (dX,dY,dZ):
   ReadLn(F,St);// 1 1 1
     St:=Trim(St);
     dX:=Round(StrToFloat(SelectWord(St,1)));
     dY:=Round(StrToFloat(SelectWord(St,2)));
     dZ:=Round(StrToFloat(SelectWord(St,3)));
   ReadLn(F,St);//All cells amount & Explode amount(Nx,Ny,Nz):
   ReadLn(F,St);//504     12 7 6
     St:=Trim(St);
     St:=MinProbel(St);
     Nall:=StrToInt(SelectWord(St,1));
     Nxo:=StrToInt(SelectWord(St,2));
     Nyo:=StrToInt(SelectWord(St,3));
     Nzo:=StrToInt(SelectWord(St,4));
   ReadLn(F,St);//Layers,  Edges,  Unempty cells:
   ReadLn(F,St);//4          152      392
     St:=Trim(St);
     St:=MinProbel(St);
     NL:=StrToInt(SelectWord(St,1));
     NE:=StrToInt(SelectWord(St,2));
     Nuc:=StrToInt(SelectWord(St,3));
   ReadLn(F,St);//Listing of layers (,name,edge,cell):
   for  I:=1 to NL do
         begin
         ReadLn(F,St);//1      4       34   392
         St:=Trim(St);
         St:=MinProbel(St);
         end;
   ReadLn(F,St);//Consistent(XYZ) listing (layer & amount of repetitions):
   fmObject.Memo1.Lines.Clear;
   fmObject.Memo1.Lines.Add('Base point of Rated Area (Xo,Yo,Zo): '+IntToStr(Xo)+','+IntToStr(Yo)+','+IntToStr(Zo));
   fmObject.Memo1.Lines.Add('Size of Rated Area (X,Y,Z): '+IntToStr(X)+''+IntToStr(Y)+''+IntToStr(Z));
   fmObject.Memo1.Lines.Add('Cell size (dX,dY,dZ): '+IntToStr(dX)+','+IntToStr(dY)+','+IntToStr(dZ));
   fmObject.Memo1.Lines.Add('All cells amount & Explode amount(Nx,Ny,Nz): '+IntToStr(NXo)+','+IntToStr(NYo)+','+IntToStr(NZo));
   fmObject.Memo1.Lines.Add('Layers,  Edges,  Unempty cells: '+IntToStr(NL)+','+IntToStr(Nall)+','+IntToStr(NE)+','+IntToStr(Nuc));
   fmObject.Memo1.Lines.Add('');
   fmObject.spXo.Value:=Xo;
   fmObject.spYo.Value:=Yo;
   fmObject.spZo.Value:=Zo;

   if fmObject.ShowModal<>mrOk then Exit;
   Xo:=fmObject.spXo.Value;
   Yo:=fmObject.spYo.Value;
   Zo:=fmObject.spZo.Value;

    X:=Xo; Y:=Yo; Z:=Zo;
    repeat

         ReadLn(F,St);
         if St='end of CELL file' then break;
         NLayer:=StrToInt(St)+LayerCount;
         ReadLn(F,St);
         if St='end of CELL file' then break;
         NCell:=StrToInt(St);
         while NCell>0 do begin
           if  (X<NX)and(Y<NY)and(X<NZ) then if (NLayer-LayerCount)>0 then Space[X,Y,Z]:=NLayer;
           inc(X);
           if X>=(Xo+Nxo) then begin X:=Xo; Inc(Y); end;
           if Y>=(Yo+Nyo) then begin Y:=Yo; Inc(Z); end;
           Dec(NCell);
           end;

     until EOF(F);

  LayerCount:=fmOpenGL.LayerCount+NL;
 finally
  CloseFile(F);
 end;
end;

 if UpperCase(ExtractFileExt(OpenCelFile.FileName))='.3D'
        then begin
  SaveUndo;
          Reset(F);

          try
            ReadLn(F,St);
          while not eof(F) do
            begin
              ReadLn(F, x, y, z, Sig{, Eps});
              if  Sig > 0.00001 then
                    Space[X,Y,Z]:=1
                    else
                     Space[X,Y,Z]:=0;
            end;
        finally
        CloseFile(F);
        end;

          end;


end;

procedure TfmOpenGL.SpeedButton4Click(Sender: TObject);
 var i,j,k: integer;
begin
 if MessageDLG(' ,  ?',mtConfirmation,mbOKCancel,0)<>
     mrOk then Exit;
  for i:=1 to nx do for j:=1 to ny do for k:=1 to nz do
        Space[i,j,k]:=0;
  LookAt;
  StringGrid1.Repaint;
end;

procedure TfmOpenGL.SpeedButton5Click(Sender: TObject);
begin
  LookAt;
end;
procedure TfmOpenGL.SpinEdit1Change(Sender: TObject);
begin
  fmNew3dMain. ProjectEdited:=True;
  Timer2.Enabled:=False;
 if (Sender as TSpinEdit).Value < 1 then (Sender as TSpinEdit).Value:=1;
 if SpinEdit1.Value> XSize then SpinEdit1.Value := XSize;
 if SpinEdit2.Value> YSize then SpinEdit2.Value := YSize;
 if SpinEdit3.Value> ZSize then SpinEdit3.Value := ZSize;
 Sx:=SpinEdit1.Value;
 Sy:=SpinEdit2.Value;
 Sz:=SpinEdit3.Value;
  Timer2.Enabled:=True;
end;

procedure TfmOpenGL.StringGrid1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var      S: Integer;
      Rect1: TRect;
begin
// if rbOff.Checked then exit;
 Rect1.Left:=Rect.Left+1;
 Rect1.Top:=Rect.Top+1;
 Rect1.Bottom:=Rect.Bottom-1;
 Rect1.Right:=Rect.Right-1;
 if rbX.Checked then
    with StringGrid1.Canvas do begin
      S:=Space[Sx,StringGrid1.RowCount-ARow,ACol+1];
      if S>0 then
        begin
          if Layers[Space[Sx,StringGrid1.RowCount-ARow,ACol+1]].Visible then
                               Brush.Color:=Layers[S].Color;
          if Selected then begin
              if ((StartSelect.X>=ACol)and(ACol>=EndSelect.X)or
                 (StartSelect.X<=ACol)and(ACol<=EndSelect.X))and
                 ((StartSelect.Y>=ARow)and(ARow>=EndSelect.Y)or
                 (StartSelect.Y<=ARow)and(ARow<=EndSelect.Y))
                 and((StartSelect.X=ACol) or(ACol=EndSelect.X) or (StartSelect.Y=ARow)or(ARow>=EndSelect.Y))
                  then Brush.Color:= clGray;
             end;
          FillRect(Rect);
          end;
      if S=0 then
          if Selected then begin
              if ((StartSelect.X>=ACol)and(ACol>=EndSelect.X)or
                 (StartSelect.X<=ACol)and(ACol<=EndSelect.X))and
                 ((StartSelect.Y>=ARow)and(ARow>=EndSelect.Y)or
                 (StartSelect.Y<=ARow)and(ARow<=EndSelect.Y))
                 and((StartSelect.X=ACol) or(ACol=EndSelect.X) or (StartSelect.Y=ARow)or(ARow>=EndSelect.Y))
                  then Brush.Color:= clGray;
             end;
          FillRect(Rect);
        if IsOutPoint(Sx,StringGrid1.RowCount-ARow,ACol+1)
            then
             begin
             Brush.Color:=clNavy;
             Pen.Color:=clBlack;
             StringGrid1.Canvas.Ellipse(Rect1);
             end;
        end;

 if rbY.Checked then
    with StringGrid1.Canvas do begin
     S:=Space[ACol+1,Sy,StringGrid1.RowCount-ARow];
     if S>0 then
        begin
          if Layers[Space[ACol+1,Sy,StringGrid1.RowCount-ARow]].Visible then
                          Brush.Color:=Layers[S].Color;
          if Selected then begin
              if ((StartSelect.X>=ACol)and(ACol>=EndSelect.X)or
                 (StartSelect.X<=ACol)and(ACol<=EndSelect.X))and
                 ((StartSelect.Y>=ARow)and(ARow>=EndSelect.Y)or
                 (StartSelect.Y<=ARow)and(ARow<=EndSelect.Y))
                 and((StartSelect.X=ACol) or(ACol=EndSelect.X) or (StartSelect.Y=ARow)or(ARow>=EndSelect.Y))
                  then Brush.Color:= clGray;
             end;
          FillRect(Rect);
          end;

      if S=0 then
          if Selected then begin
              if ((StartSelect.X>=ACol)and(ACol>=EndSelect.X)or
                 (StartSelect.X<=ACol)and(ACol<=EndSelect.X))and
                 ((StartSelect.Y>=ARow)and(ARow>=EndSelect.Y)or
                 (StartSelect.Y<=ARow)and(ARow<=EndSelect.Y))
                 and((StartSelect.X=ACol) or(ACol=EndSelect.X) or (StartSelect.Y=ARow)or(ARow>=EndSelect.Y))
                  then Brush.Color:= clGray;
             end;
          FillRect(Rect);

          if IsOutPoint(ACol+1,Sy,StringGrid1.RowCount-ARow)
            then
             begin
             Brush.Color:=clNavy;
             Pen.Color:=clBlack;
             StringGrid1.Canvas.Ellipse(Rect1);
             end;
          exit;
        end;

 if rbZ.Checked then
    with StringGrid1.Canvas do begin
      S:=Space[ACol+1,StringGrid1.RowCount-ARow,Sz];
      if S>0 then
        begin
          if Layers[Space[ACol+1,StringGrid1.RowCount-ARow,Sz]].Visible then
                            Brush.Color:=Layers[S].Color;
          if Selected then begin
              if ((StartSelect.X>=ACol)and(ACol>=EndSelect.X)or
                 (StartSelect.X<=ACol)and(ACol<=EndSelect.X))and
                 ((StartSelect.Y>=ARow)and(ARow>=EndSelect.Y)or
                 (StartSelect.Y<=ARow)and(ARow<=EndSelect.Y))
                 and((StartSelect.X=ACol) or(ACol=EndSelect.X) or (StartSelect.Y=ARow)or(ARow>=EndSelect.Y))
                  then Brush.Color:= clGray;
             end;
          FillRect(Rect);
          end;
      if S=0 then
          if Selected then begin
              if ((StartSelect.X>=ACol)and(ACol>=EndSelect.X)or
                 (StartSelect.X<=ACol)and(ACol<=EndSelect.X))and
                 ((StartSelect.Y>=ARow)and(ARow>=EndSelect.Y)or
                 (StartSelect.Y<=ARow)and(ARow<=EndSelect.Y))
                 and((StartSelect.X=ACol) or(ACol=EndSelect.X) or (StartSelect.Y=ARow)or(ARow>=EndSelect.Y))
                  then Brush.Color:= clGray;
             end;
          FillRect(Rect);
          if IsOutPoint(ACol+1,StringGrid1.RowCount-ARow,Sz)
            then
             begin
             Brush.Color:=clNavy;
             Pen.Color:=clBlack;
             StringGrid1.Canvas.Ellipse(Rect1);
             end;
          exit;
        end;

end;


procedure TfmOpenGL.rbXClick(Sender: TObject);
begin
  Selected:=False;
  rbX.Checked:= true;
  rbX1.Checked:= true;
  btnX.Down:= True;
  GroupBox2.Visible:= True;
  lb1.Caption:='Y';
  lb2.Caption:='Z';
  lbCoord2.Caption:='X=';
  StringGrid1.RowCount:=YSize;
  StringGrid1.ColCount:=ZSize;
  SpinEdit1.BringToFront;
  LookAt;
  StringGrid1.DefaultRowHeight:=min(StringGrid1.DefaultRowHeight,StringGrid1.DefaultColWidth);
  StringGrid1.DefaultColWidth:=min(StringGrid1.DefaultRowHeight,StringGrid1.DefaultColWidth);
  SpeedButton7Click(nil);
  SpeedButton6Click(nil);
end;

procedure TfmOpenGL.rbYClick(Sender: TObject);
begin
  Selected:=False;
  rbY.Checked:= true;
  rbY1.Checked:= true;
  btnY.Down:= True;
  GroupBox2.Visible:= True;
  lb1.Caption:='Z';
  lb2.Caption:='X';
  lbCoord2.Caption:='Y=';
  StringGrid1.RowCount:=ZSize;
  StringGrid1.ColCount:=XSize;
  SpinEdit2.BringToFront;
  LookAt;
  StringGrid1.DefaultRowHeight:=min(StringGrid1.DefaultRowHeight,StringGrid1.DefaultColWidth);
  StringGrid1.DefaultColWidth:=min(StringGrid1.DefaultRowHeight,StringGrid1.DefaultColWidth);
  SpeedButton7Click(nil);
  SpeedButton6Click(nil);

end;

procedure TfmOpenGL.rbZClick(Sender: TObject);
begin
  Selected:=False;
  rbZ.Checked:= true;
  rbZ1.Checked:= true;
  btnZ.Down:= True;
 GroupBox2.Visible:= True;
  lb1.Caption:='Y';
  lb2.Caption:='X';
  lbCoord2.Caption:='Z=';
  StringGrid1.RowCount:=YSize;
  StringGrid1.ColCount:=XSize;
  SpinEdit3.BringToFront;
  LookAt;
  StringGrid1.DefaultRowHeight:=min(StringGrid1.DefaultRowHeight,StringGrid1.DefaultColWidth);
  StringGrid1.DefaultColWidth:=min(StringGrid1.DefaultRowHeight,StringGrid1.DefaultColWidth);
  SpeedButton7Click(nil);
  SpeedButton6Click(nil);

end;
procedure TfmOpenGL.SetCel(Row, Col: Integer);
begin
  if not Layers[LayerCurrent].visible then exit;
 if rbX.Checked then Space[Sx,StringGrid1.RowCount-Row,Col+1]:=LayerCurrent;
 if rbY.Checked then Space[Col+1,Sy,StringGrid1.RowCount-Row]:=LayerCurrent;
 if rbZ.Checked then Space[Col+1,StringGrid1.RowCount-Row,Sz]:=LayerCurrent;
//  LookAt;
  StringGrid1.Repaint;
end;

procedure TfmOpenGL.Eraser(Row, Col: Integer);
begin

 if rbX.Checked then Space[Sx,StringGrid1.RowCount-Row,Col+1]:=0;
 if rbY.Checked then Space[Col+1,Sy,StringGrid1.RowCount-Row]:=0;
 if rbZ.Checked then Space[Col+1,StringGrid1.RowCount-Row,Sz]:=0;
//  LookAt;
  StringGrid1.Repaint;
end;

procedure TfmOpenGL.SpeedButton6Click(Sender: TObject);
 var    StepX,StepY,StepZ: double;
begin
 StepX:=1;
 StepY:=StrToFloat(fmNew3dMain.edY.Text)/StrToFloat(fmNew3dMain.edX.Text);
 StepZ:=StrToFloat(fmNew3dMain.edZ.Text)/StrToFloat(fmNew3dMain.edX.Text);
  if rbX.Checked then begin
      if StepY<StepZ then begin
         StepY:=1;
         StepZ:=StrToFloat(fmNew3dMain.edZ.Text)/StrToFloat(fmNew3dMain.edY.Text);
         StringGrid1.DefaultRowHeight:=StringGrid1.DefaultRowHeight-1;
         StringGrid1.DefaultColWidth:=Round(StringGrid1.DefaultRowHeight*StepZ);
         end else begin
         StepZ:=1;
         StepY:=StrToFloat(fmNew3dMain.edY.Text)/StrToFloat(fmNew3dMain.edZ.Text);
         StringGrid1.DefaultColWidth:=StringGrid1.DefaultColWidth-1;
         StringGrid1.DefaultRowHeight:=Round(StringGrid1.DefaultColWidth*StepY);
         end;
      end;
  if rbY.Checked then begin
      if StepX<StepZ then begin
         StepX:=1;
         StepZ:=StrToFloat(fmNew3dMain.edZ.Text)/StrToFloat(fmNew3dMain.edX.Text);
         StringGrid1.DefaultColWidth:=StringGrid1.DefaultColWidth-1;
         StringGrid1.DefaultRowHeight:=Round(StringGrid1.DefaultColWidth*StepZ);
         end else begin
         StepX:=StrToFloat(fmNew3dMain.edX.Text)/StrToFloat(fmNew3dMain.edZ.Text);
         StringGrid1.DefaultRowHeight:=StringGrid1.DefaultRowHeight-1;
         StringGrid1.DefaultColWidth:=Round(StringGrid1.DefaultRowHeight*StepX);
         end;
      end;
  if rbZ.Checked then begin
      if StepX<StepY then begin
         StepY:=StrToFloat(fmNew3dMain.edY.Text)/StrToFloat(fmNew3dMain.edX.Text);
         StringGrid1.DefaultColWidth:=StringGrid1.DefaultColWidth-1;
         StringGrid1.DefaultRowHeight:=Round(StringGrid1.DefaultColWidth*StepY);
         end else begin
         StepX:=StrToFloat(fmNew3dMain.edX.Text)/StrToFloat(fmNew3dMain.edY.Text);
         StringGrid1.DefaultRowHeight:=StringGrid1.DefaultRowHeight-1;
         StringGrid1.DefaultColWidth:=Round(StringGrid1.DefaultRowHeight*StepX);
         end;
      end;

  if StringGrid1.DefaultColWidth<1 then begin
      StringGrid1.DefaultColWidth:=1;
//      StringGrid1.Options:=StringGrid1.Options - [goVertLine];
//      SpeedButton5.Enabled:=False;
      end;
  if StringGrid1.DefaultRowHeight<1 then begin
       StringGrid1.DefaultRowHeight:=1;
//       StringGrid1.Options:=StringGrid1.Options - [goHorzLine];
//       SpeedButton5.Enabled:=False;
       end;
  if (StringGrid1.DefaultColWidth=1) or
     (StringGrid1.DefaultRowHeight=1) then
     SpeedButton5.Enabled:=False else SpeedButton5.Enabled:=True;

 //  StringGrid1.DefaultColWidth:=StringGrid1.DefaultColWidth-1;
//  StringGrid1.DefaultRowHeight:=StringGrid1.DefaultColWidth;
end;

procedure TfmOpenGL.SpeedButton7Click(Sender: TObject);
 var    StepX,StepY,StepZ: double;
begin
 StepX:=1;
 StepY:=StrToFloat(fmNew3dMain.edY.Text)/StrToFloat(fmNew3dMain.edX.Text);
 StepZ:=StrToFloat(fmNew3dMain.edZ.Text)/StrToFloat(fmNew3dMain.edX.Text);
  SpeedButton5.Enabled:=True;
  if rbX.Checked then begin
      if StepY<StepZ then begin
         StepY:=1;
         StepZ:=StrToFloat(fmNew3dMain.edZ.Text)/StrToFloat(fmNew3dMain.edY.Text);
         StringGrid1.DefaultRowHeight:=StringGrid1.DefaultRowHeight+1;
         StringGrid1.DefaultColWidth:=Round(StringGrid1.DefaultRowHeight*StepZ);
         end else begin
         StepZ:=1;
         StepY:=StrToFloat(fmNew3dMain.edY.Text)/StrToFloat(fmNew3dMain.edZ.Text);
         StringGrid1.DefaultColWidth:=StringGrid1.DefaultColWidth+1;
         StringGrid1.DefaultRowHeight:=Round(StringGrid1.DefaultColWidth*StepY);
         end;
      end;
  if rbY.Checked then begin
      if StepX<StepZ then begin
         StepX:=1;
         StepZ:=StrToFloat(fmNew3dMain.edZ.Text)/StrToFloat(fmNew3dMain.edX.Text);
         StringGrid1.DefaultColWidth:=StringGrid1.DefaultColWidth+1;
         StringGrid1.DefaultRowHeight:=Round(StringGrid1.DefaultColWidth*StepZ);
         end else begin
         StepX:=StrToFloat(fmNew3dMain.edX.Text)/StrToFloat(fmNew3dMain.edZ.Text);
         StringGrid1.DefaultRowHeight:=StringGrid1.DefaultRowHeight+1;
         StringGrid1.DefaultColWidth:=Round(StringGrid1.DefaultRowHeight*StepX);
         end;
      end;
  if rbZ.Checked then begin
      if StepX<StepY then begin
         StepY:=StrToFloat(fmNew3dMain.edY.Text)/StrToFloat(fmNew3dMain.edX.Text);
         StringGrid1.DefaultColWidth:=StringGrid1.DefaultColWidth+1;
         StringGrid1.DefaultRowHeight:=Round(StringGrid1.DefaultColWidth*StepY);
         end else begin
         StepX:=StrToFloat(fmNew3dMain.edX.Text)/StrToFloat(fmNew3dMain.edY.Text);
         StringGrid1.DefaultRowHeight:=StringGrid1.DefaultRowHeight+1;
         StringGrid1.DefaultColWidth:=Round(StringGrid1.DefaultRowHeight*StepX);
         end;
      end;

//  StringGrid1.DefaultColWidth:=StringGrid1.DefaultColWidth+1;
//  StringGrid1.DefaultRowHeight:=StringGrid1.DefaultColWidth;
end;

procedure TfmOpenGL.StringGrid1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
 var Row, Col: Integer;
begin


   if ssRight in Shift then exit;
  StringGrid1.MouseToCell(X, Y, Col, Row);


  if Col>-1 then begin
 if rbX.Checked then begin
          X_Current:=Sx;
          Y_Current:=StringGrid1.RowCount-Row;
          Z_Current:=Col+1;
          end;
 if rbY.Checked then begin
          X_Current:=Col+1;
          Y_Current:=Sy;
          Z_Current:=StringGrid1.RowCount-Row;
          end;
 if rbZ.Checked then begin
          X_Current:=Col+1;
          Y_Current:=StringGrid1.RowCount-Row;
          Z_Current:=Sz;
          end;
    lbCoord.Caption:= {': '+}IntToStr(X_Current)
                       +', '+IntToStr(Y_Current)+', '+IntToStr(Z_Current);

     end
     else lbCoord.Caption:= '';
 StatusBar1.Panels[1].Text:='  '+
           IntToStr(X_Selected)+', '+IntToStr(Y_Selected)+', '+IntToStr(Z_Selected)
           +'.  '+
           IntToStr(X_Current-X_Selected)+', '+IntToStr(Y_Current-Y_Selected)+', '
           +IntToStr(Z_Current-Z_Selected);



  if MouseDown then begin
         if not((LastRow = Row)and(LastCol=Col)) then
                 if btnPen.Down then SetCel(Row, Col)
                 else if btnEraser.Down then Eraser(Row, Col);
         LastRow := Row;
         LastCol := Col;
         end;

end;

procedure TfmOpenGL.rbOffClick(Sender: TObject);
begin
  rbOff.Checked:= not rbOff.Checked;
  LookAt;
  StringGrid1.Repaint;
end;

procedure TfmOpenGL.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
 var Row, Col: Integer;
begin
  Col:= StringGrid1.Col;
  Row:= StringGrid1.Row;
  if ssRight in Shift then exit;

  if btnLine3D.Down then  begin
                       SetLine3d;
                       LookAt;
                       StringGrid1.Repaint;
                       Exit;
                       end;

  if btnLine3Dcontunue.Down then  begin
                       SetLine3d;
                       SetCurrentSell(Col,Row);
                       LookAt;
                       StringGrid1.Repaint;
                       Exit;
                       end;
//  
  SetCurrentSell(Col,Row);

  LastRow := Row;
  LastCol := Col;

  StartPoint.X:= Col;
  StartPoint.Y:= Row;

  if btnPen.Down then  begin
                       SaveUndo;
                       SetCel(Row, Col);
                       end;
  if btnFill.Down then SetFill;
  if btn3Dfill.Down then Set3DFill;
  if btnEraser.Down then  begin
                       SaveUndo;
                       Eraser(Row, Col);
                       end;
  MouseDown:=True;
end;

procedure TfmOpenGL.StringGrid1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ssRight in Shift then exit;
 if not MouseDown  then exit;
 MouseDown:=False;
 EndPoint.X:= LastCol;
 EndPoint.Y:= LastRow;
 LastRow := -1;
 LastCol := -1;
  if btnLine.Down then  begin
        SetLine;
        end;
  if btnSelect.Down then begin
      Selected:=False;
      if (StartPoint.X<>EndPoint.X) and (StartPoint.Y<>EndPoint.Y) then
        begin
         Selected:=True;
         StartSelect.X:=StartPoint.X;
         StartSelect.Y:=StartPoint.Y;
         EndSelect.X:=EndPoint.X;
         EndSelect.Y:=EndPoint.Y;
        end;
      end;
  StringGrid1.Repaint;
  LookAt;
end;
procedure TfmOpenGL.SetLine;
  var K: double;
      Mx,My: Integer;
      var P1, P2,P_1,P_2 :tPoint3D;
begin
  if not Layers[LayerCurrent].visible then exit;
   Mx:=StringGrid1.ColCount-1;
   My:=StringGrid1.RowCount-1;
   if  (StartPoint.X<0)or(StartPoint.Y<0)or(EndPoint.X<0)or(EndPoint.Y<0)
     or(StartPoint.X>Mx)or(StartPoint.Y>My)or(EndPoint.X>Mx)or(EndPoint.Y>My)
     then exit;
  // 
  SaveUndo;

     if rbX.Checked then begin
             P1.X:=Sx;
             P1.Y:=StringGrid1.RowCount-StartPoint.Y;
             P1.Z:=StartPoint.X+1;
             P2.X:=Sx;
             P2.Y:=StringGrid1.RowCount-EndPoint.Y;
             P2.Z:=EndPoint.X+1;
             end;
     if rbY.Checked then begin
             P1.X:=StartPoint.X+1;
             P1.Y:=Sy;
             P1.Z:=StringGrid1.RowCount-StartPoint.Y;
             P2.X:=EndPoint.X+1;
             P2.Y:=Sy;
             P2.Z:=StringGrid1.RowCount-EndPoint.Y;
             end;
     if rbZ.Checked then begin
             P1.X:=StartPoint.X+1;
             P1.Y:=StringGrid1.RowCount-StartPoint.Y;
             P1.Z:=Sz;
             P2.X:=EndPoint.X+1;
             P2.Y:=StringGrid1.RowCount-EndPoint.Y;
             P2.Z:=Sz;
             end;
   Line3D(P1, P2, 1,1,1, LayerCurrent, 0, 0, 0);
   K:=0.1;
     P_1:=P1;
     P_2:=P2;
     P_1.X:=P_1.X+K;
     P_2.X:=P_2.X+K;
 if rbY.Checked then  Line3D(P_1, P_2, 1,1,1, LayerCurrent, 0, 0, 0);
     P_1:=P1;
     P_2:=P2;
     P_1.Y:=P_1.Y+K;
     P_2.Y:=P_2.Y+K;
 if rbZ.Checked then  Line3D(P_1, P_2, 1,1,1, LayerCurrent, 0, 0, 0);
     P_1:=P1;
     P_2:=P2;
     P_1.Z:=P_1.Z+K;
     P_2.Z:=P_2.Z+K;
 if rbX.Checked then  Line3D(P_1, P_2, 1,1,1, LayerCurrent, 0, 0, 0);

//  LookAt;
//  StringGrid1.Repaint;
end;

procedure TfmOpenGL.SetFill;
  var  X, Y,Rows,Cols, TempNo: Integer;
       Zero: boolean;
       OldLayer: Integer;
begin
  if not Layers[LayerCurrent].visible then exit;
  SaveUndo;
   X:=StartPoint.X;
   Y:=StartPoint.Y;
   Rows:=StringGrid1.RowCount;
   Cols:=StringGrid1.ColCount;
   TempNo:=255;

   OldLayer:=0;
   if rbX.Checked then  OldLayer:=Space[Sx,Rows-Y,X+1];
   if rbY.Checked then  OldLayer:=Space[X+1,Sy,Rows-Y];
   if rbZ.Checked then  OldLayer:=Space[X+1,Rows-Y,Sz];

   if rbX.Checked then  Space[Sx,Rows-Y,X+1]:=TempNo;
   if rbY.Checked then  Space[X+1,Sy,Rows-Y]:=TempNo;
   if rbZ.Checked then  Space[X+1,Rows-Y,Sz]:=TempNo;


  if rbX.Checked then begin
repeat
  Zero:= True;
   for X:=0 to Cols-1 do
     for Y:=0 to Rows-1 do
     begin
      if Space[Sx,Rows-Y,X+1]=TempNo then
        begin
          if X>=1 then
            if Space[Sx,Rows-Y,X+1-1]=OldLayer then begin
                   Space[Sx,Rows-Y,X+1-1]:=TempNo;
                   Zero:= False;
                   end;
          if X<(Cols-1) then
            if Space[Sx,Rows-Y,X+1+1]=OldLayer then  begin
                   Space[Sx,Rows-Y,X+1+1]:=TempNo;
                   Zero:= False;
                   end;
          if Y>=1 then
            if Space[Sx,Rows-Y+1,X+1]=OldLayer then  begin
                   Space[Sx,Rows-Y+1,X+1]:=TempNo;
                   Zero:= False;
                   end;
          if Y<(Rows-1) then
            if Space[Sx,Rows-Y-1,X+1]=OldLayer then  begin
                   Space[Sx,Rows-Y-1,X+1]:=TempNo;
                   Zero:= False;
                   end;
        end;
   end;
until Zero;
   for X:=0 to Cols-1 do
     for Y:=0 to Rows-1 do
      if Space[Sx,Rows-Y,X+1]=TempNo then Space[Sx,Rows-Y,X+1]:=LayerCurrent;
  end;


  if rbY.Checked then begin
repeat
  Zero:= True;
   for X:=0 to Cols-1 do
     for Y:=0 to Rows-1 do
     begin
      if Space[X+1,Sy,Rows-Y]=TempNo then
        begin
          if X>=1 then
            if Space[X+1-1,Sy,Rows-Y]=OldLayer then begin
                   Space[X+1-1,Sy,Rows-Y]:=TempNo;
                   Zero:= False;
                   end;
          if X<(Cols-1) then
            if Space[X+1+1,Sy,Rows-Y]=OldLayer then  begin
                   Space[X+1+1,Sy,Rows-Y]:=TempNo;
                   Zero:= False;
                   end;
          if Y>=1 then
            if Space[X+1,Sy,Rows-Y+1]=OldLayer then  begin
                   Space[X+1,Sy,Rows-Y+1]:=TempNo;
                   Zero:= False;
                   end;
          if Y<(Rows-1) then
            if Space[X+1,Sy,Rows-Y-1]=OldLayer then  begin
                   Space[X+1,Sy,Rows-Y-1]:=TempNo;
                   Zero:= False;
                   end;
        end;
     end;
until Zero;
   for X:=0 to Cols-1 do
     for Y:=0 to Rows-1 do
      if Space[X+1,Sy,Rows-Y]=TempNo then Space[X+1,Sy,Rows-Y]:=LayerCurrent;
   end;


  if rbZ.Checked then begin
repeat
  Zero:= True;
   for X:=0 to Cols-1 do
     for Y:=0 to Rows-1 do
     begin
      if Space[X+1,Rows-Y,Sz]=TempNo then
        begin
          if X>=1 then
            if Space[X+1-1,Rows-Y,Sz]=OldLayer then begin
                   Space[X+1-1,Rows-Y,Sz]:=TempNo;
                   Zero:= False;
                   end;
          if X<(Cols-1) then
            if Space[X+1+1,Rows-Y,Sz]=OldLayer then  begin
                   Space[X+1+1,Rows-Y,Sz]:=TempNo;
                   Zero:= False;
                   end;
          if Y>=1 then
            if Space[X+1,Rows-Y+1,Sz]=OldLayer then  begin
                   Space[X+1,Rows-Y+1,Sz]:=TempNo;
                   Zero:= False;
                   end;
          if Y<(Rows-1) then
            if Space[X+1,Rows-Y-1,Sz]=OldLayer then  begin
                   Space[X+1,Rows-Y-1,Sz]:=TempNo;
                   Zero:= False;
                   end;
        end;
     end;
until Zero;
   for X:=0 to Cols-1 do
     for Y:=0 to Rows-1 do
      if Space[X+1,Rows-Y,Sz]=TempNo then Space[X+1,Rows-Y,Sz]:=LayerCurrent;
   end;

  LookAt;
  StringGrid1.Repaint;
end;
procedure TfmOpenGL.FormActivate(Sender: TObject);
begin
   If rbY.Checked then   rbYClick(Nil);
   If rbX.Checked then   rbXClick(Nil);
   If rbZ.Checked then   rbZClick(Nil);
   GetOutPoint;
   lbSloy.Caption:=Layers[LayerCurrent].Comment;
   Shape1.Brush.Color:=Layers[LayerCurrent].Color;
   StringGrid1.Repaint;
end;

procedure TfmOpenGL.btnPenClick(Sender: TObject);
begin
  Selected:=False;
 StringGrid1.Repaint;
end;

procedure TfmOpenGL.btnFillClick(Sender: TObject);
begin
  Selected:=False;
 StringGrid1.Repaint;
end;

procedure TfmOpenGL.btnLineClick(Sender: TObject);
begin
  Selected:=False;
 StringGrid1.Repaint;
end;

procedure TfmOpenGL.btnEraserClick(Sender: TObject);
begin
  Selected:=False;
 StringGrid1.Repaint;
end;

procedure TfmOpenGL.PopupMenu1Popup(Sender: TObject);
 var  X, Y, Z: Integer;
     
begin
  x:=0; Y:=0; Z:=0;
  mnDelSelected.Enabled:=Selected;
  mnCopy.Enabled:=Selected;
  mnShapeRotate.Enabled:=Selected;
  mnE1.Enabled:=btnOutputPoints.Down;
  mnH1.Enabled:=btnOutputPoints.Down;
  mnI1.Enabled:=btnOutputPoints.Down;
  mnJ1.Enabled:=btnOutputPoints.Down;

    if rbX.Checked then
      begin
        X:=Sx;
        Y:=StringGrid1.RowCount-StringGrid1.Row;
        Z:=StringGrid1.Col+1;
      end;

  if rbY.Checked then
      begin
        X:=StringGrid1.Col+1;
        Y:=Sy;
        Z:=StringGrid1.RowCount-StringGrid1.Row;
      end;

  if rbZ.Checked then
      begin
        X:=StringGrid1.Col+1;
        Y:=StringGrid1.RowCount-StringGrid1.Row;
        Z:=Sz;
      end;
 mnN11.Caption:='---='+IntToStr(X)+' Y='+IntToStr(Y)+' Z='+IntToStr(Z)+'---';
end;

procedure TfmOpenGL.mnDelSelectedClick(Sender: TObject);
  var I,J: Integer;
begin
SaveUndo;
 for I:=0 to StringGrid1.ColCount do
   for  J:=0 to StringGrid1.RowCount do
   if ((StartSelect.X>=I)and(I>=EndSelect.X)or
       (StartSelect.X<=I)and(I<=EndSelect.X))and

       ((StartSelect.Y>=J)and(J>=EndSelect.Y)or
       (StartSelect.Y<=J)and(J<=EndSelect.Y)) then
        begin
          if rbX.Checked then Space[Sx,StringGrid1.RowCount-J,I+1]:=0;
          if rbY.Checked then Space[I+1,Sy,StringGrid1.RowCount-J]:=0;
          if rbZ.Checked then Space[I+1,StringGrid1.RowCount-J,Sz]:=0;
        end;
 Selected:=False;
 StringGrid1.Repaint;
 LookAt;
end;

procedure TfmOpenGL.mnCopyClick(Sender: TObject);
  var Lay,I,J, NumCop, NumLay: Integer;
begin
 if fmCopy.ShowModal<>mrOK then exit;
 NumCop:=fmCopy.seNumCop.Value;
 NumLay:=fmCopy.seNumLay.Value;


 //  
if fmCopy.RadioButton3.Checked then begin
  if rbX.Checked then if NumLay>XSize then exit;
  if rbY.Checked then if NumLay>YSize then exit;
  if rbZ.Checked then if NumLay>ZSize then exit;
SaveUndo;

  for I:=0 to StringGrid1.ColCount do
   for  J:=0 to StringGrid1.RowCount do
   if ((StartSelect.X>=I)and(I>=EndSelect.X)or
       (StartSelect.X<=I)and(I<=EndSelect.X))and

       ((StartSelect.Y>=J)and(J>=EndSelect.Y)or
       (StartSelect.Y<=J)and(J<=EndSelect.Y)) then
        begin
          if rbX.Checked then begin
                  if (not fmCopy.CheckBox1.Checked)and(Space[Sx,StringGrid1.RowCount-J,I+1]=0)
                          then continue;
                   if (Space[Sx,StringGrid1.RowCount-J,I+1]>0) then
                       if (not fmCopy.CheckBox2.Checked)and
                          (not Layers[Space[Sx,StringGrid1.RowCount-J,I+1]].Visible)
                          then continue;
                  Space[NumLay,StringGrid1.RowCount-J,I+1]:=Space[Sx,StringGrid1.RowCount-J,I+1];
                  end;
          if rbY.Checked then begin
                  if (not fmCopy.CheckBox1.Checked)and(Space[I+1,Sy,StringGrid1.RowCount-J]=0)
                          then continue;
                   if (Space[I+1,Sy,StringGrid1.RowCount-J]>0) then
                       if (not fmCopy.CheckBox2.Checked)and
                          (not Layers[Space[I+1,Sy,StringGrid1.RowCount-J]].Visible)
                          then continue;
                  Space[I+1,NumLay,StringGrid1.RowCount-J]:=Space[I+1,Sy,StringGrid1.RowCount-J];
                  end;
          if rbZ.Checked then begin
                  if (not fmCopy.CheckBox1.Checked)and(Space[I+1,StringGrid1.RowCount-J,Sz]=0)
                          then continue;
                   if (Space[I+1,StringGrid1.RowCount-J,Sz]>0) then
                       if (not fmCopy.CheckBox2.Checked)and
                          (not Layers[Space[I+1,StringGrid1.RowCount-J,Sz]].Visible)
                          then continue;
                  Space[I+1,StringGrid1.RowCount-J,NumLay]:=Space[I+1,StringGrid1.RowCount-J,Sz];
                  end;
        end;
    end;

 //
 if fmCopy.RadioButton1.Checked then begin
  if rbX.Checked then  if (Sx+NumCop)>Nx then NumCop:=Nx-Sx;
  if rbY.Checked then  if (Sy+NumCop)>Ny then NumCop:=Ny-Sy;
  if rbZ.Checked then  if (Sz+NumCop)>Nz then NumCop:=Nz-Sz;
SaveUndo;

for Lay:=1 to NumCop do
 for I:=0 to StringGrid1.ColCount do
   for  J:=0 to StringGrid1.RowCount do
   if ((StartSelect.X>=I)and(I>=EndSelect.X)or
       (StartSelect.X<=I)and(I<=EndSelect.X))and

       ((StartSelect.Y>=J)and(J>=EndSelect.Y)or
       (StartSelect.Y<=J)and(J<=EndSelect.Y)) then
        begin

          if rbX.Checked then begin
                  if (not fmCopy.CheckBox1.Checked)and(Space[Sx,StringGrid1.RowCount-J,I+1]=0)
                          then continue;
                   if (Space[Sx,StringGrid1.RowCount-J,I+1]>0) then
                       if (not fmCopy.CheckBox2.Checked)and
                          (not Layers[Space[Sx,StringGrid1.RowCount-J,I+1]].Visible)
                          then continue;
                    Space[Sx+Lay,StringGrid1.RowCount-J,I+1]:=Space[Sx,StringGrid1.RowCount-J,I+1];
                  end;
          if rbY.Checked then begin
                  if (not fmCopy.CheckBox1.Checked)and(Space[I+1,Sy,StringGrid1.RowCount-J]=0)
                          then continue;
                   if (Space[I+1,Sy,StringGrid1.RowCount-J]>0) then
                       if (not fmCopy.CheckBox2.Checked)and
                          (not Layers[Space[I+1,Sy,StringGrid1.RowCount-J]].Visible)
                          then continue;
                  Space[I+1,Sy+Lay,StringGrid1.RowCount-J]:=Space[I+1,Sy,StringGrid1.RowCount-J];
                  end;
          if rbZ.Checked then begin
                  if (not fmCopy.CheckBox1.Checked)and(Space[I+1,StringGrid1.RowCount-J,Sz]=0)
                          then continue;
                   if (Space[I+1,StringGrid1.RowCount-J,Sz]>0) then
                       if (not fmCopy.CheckBox2.Checked)and
                          (not Layers[Space[I+1,StringGrid1.RowCount-J,Sz]].Visible)
                          then continue;
                  Space[I+1,StringGrid1.RowCount-J,Sz+Lay]:=Space[I+1,StringGrid1.RowCount-J,Sz];
                  end;
        end;
    end;

 //
if fmCopy.RadioButton2.Checked then begin
  if rbX.Checked then  if (Sx-NumCop)<1 then NumCop:=Sx-1;
  if rbY.Checked then  if (Sy-NumCop)<1 then NumCop:=Sy-1;
  if rbZ.Checked then  if (Sz-NumCop)<1 then NumCop:=Sz-1;
SaveUndo;

 for Lay:=1 to NumCop do
  for I:=0 to StringGrid1.ColCount do
   for  J:=0 to StringGrid1.RowCount do
   if ((StartSelect.X>=I)and(I>=EndSelect.X)or
       (StartSelect.X<=I)and(I<=EndSelect.X))and

       ((StartSelect.Y>=J)and(J>=EndSelect.Y)or
       (StartSelect.Y<=J)and(J<=EndSelect.Y)) then
        begin
          if rbX.Checked then begin
                  if (not fmCopy.CheckBox1.Checked)and(Space[Sx,StringGrid1.RowCount-J,I+1]=0)
                          then continue;
                   if (Space[Sx,StringGrid1.RowCount-J,I+1]>0) then
                       if (not fmCopy.CheckBox2.Checked)and
                          (not Layers[Space[Sx,StringGrid1.RowCount-J,I+1]].Visible)
                          then continue;
                 Space[Sx-Lay,StringGrid1.RowCount-J,I+1]:=Space[Sx,StringGrid1.RowCount-J,I+1];
                 end;
          if rbY.Checked then begin
                  if (not fmCopy.CheckBox1.Checked)and(Space[I+1,Sy,StringGrid1.RowCount-J]=0)
                          then continue;
                   if (Space[I+1,Sy,StringGrid1.RowCount-J]>0) then
                       if (not fmCopy.CheckBox2.Checked)and
                          (not Layers[Space[I+1,Sy,StringGrid1.RowCount-J]].Visible)
                          then continue;
                 Space[I+1,Sy-Lay,StringGrid1.RowCount-J]:=Space[I+1,Sy,StringGrid1.RowCount-J];
                 end;
          if rbZ.Checked then begin
                  if (not fmCopy.CheckBox1.Checked)and(Space[I+1,StringGrid1.RowCount-J,Sz]=0)
                          then continue;
                   if (Space[I+1,StringGrid1.RowCount-J,Sz]>0) then
                       if (not fmCopy.CheckBox2.Checked)and
                          (not Layers[Space[I+1,StringGrid1.RowCount-J,Sz]].Visible)
                          then continue;
                 Space[I+1,StringGrid1.RowCount-J,Sz-Lay]:=Space[I+1,StringGrid1.RowCount-J,Sz];
                 end;
        end;
    end;

 Selected:=False;
 StringGrid1.Repaint;
end;

procedure TfmOpenGL.E2Click(Sender: TObject);
 var I, X, Y, Z: Integer;
     NRow: Integer;
begin
//  
  x:=0; Y:=0; Z:=0;
  NRow:=0;
  for I:=2 to fmNew3dMain.StringGrid1.RowCount-1 do
       if fmNew3dMain.StringGrid1.Cells[0,I] = ''
         then begin
           NRow:=I;
           break;
           end;
  if NRow=0 then begin ShowMessage('  .  .'); exit;
                 end;

  if rbX.Checked then
      begin
        X:=Sx;
        Y:=StringGrid1.RowCount-StringGrid1.Row;
        Z:=StringGrid1.Col+1;
      end;

  if rbY.Checked then
      begin
        X:=StringGrid1.Col+1;
        Y:=Sy;
        Z:=StringGrid1.RowCount-StringGrid1.Row;
      end;

  if rbZ.Checked then
      begin
        X:=StringGrid1.Col+1;
        Y:=StringGrid1.RowCount-StringGrid1.Row;
        Z:=Sz;
      end;


  Case (Sender as tComponent).Tag of
   11: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='E';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='x';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Ex('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   12: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='E';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='y';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Ey('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   13: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='E';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='z';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Ez('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   14: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='E';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='E('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
// H
   21: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='H';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='x';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Hx('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   22: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='H';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='y';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Hy('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   23: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='H';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='z';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Hz('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   24: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='H';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='H('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
// i
   31: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='I';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='x';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Ix('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   32: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='I';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='y';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Iy('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   33: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='I';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='z';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Iz('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   34: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='I';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='I('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
//   J
   41: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='J';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='x';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Jx('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   42: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='J';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='y';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Jy('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   43: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='J';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='z';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='Jz('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   44: begin
       fmNew3dMain.StringGrid1.Cells[0,NRow]:='J';
       fmNew3dMain.StringGrid1.Cells[1,NRow]:='';
       fmNew3dMain.StringGrid1.Cells[2,NRow]:=IntToStr(X);
       fmNew3dMain.StringGrid1.Cells[3,NRow]:=IntToStr(Y);
       fmNew3dMain.StringGrid1.Cells[4,NRow]:=IntToStr(Z);
       fmNew3dMain.StringGrid1.Cells[5,NRow]:='J('+IntToStr(X)+' '+IntToStr(Y)+' '+IntToStr(Z)+')';
       end;
   end;

 GetOutPoint;
 LookAt;
 StringGrid1.Repaint;
end;

procedure TfmOpenGL.Timer2Timer(Sender: TObject);
begin
 Timer2.Enabled:= False;
 LookAt;
 StringGrid1.Repaint;
end;

procedure TfmOpenGL.mnMoveClick(Sender: TObject);
  var I,J,K,
      X,Y,Z: Integer;
      SpaceTemp: tSpace;

begin
  if fmMove.ShowModal <> mrOk then Exit;
  SaveUndo;
  X:= fmMove.seX.Value;
  Y:= fmMove.seY.Value;
  Z:= fmMove.seZ.Value;

 for I:=1 to nx do
   for j:=1 to ny do
      for k:=1 to nz do begin
        SpaceTemp[i,j,k]:= Space[i,j,k];
        Space[i,j,k]:=0;
        end;

 for I:=1 to nx do
   for j:=1 to ny do
      for k:=1 to nz do begin
         if  ((i+X)>0)and((j+Y)>0)and((k+Z)>0)and
             ((i+X)<NX)and((j+Y)<NY)and((k+Z)<NZ)
                then Space[i+X,j+Y,k+Z]:=SpaceTemp[i,j,k];
         end;

 LookAt;
 StringGrid1.Repaint;
end;

procedure TfmOpenGL.N8Click(Sender: TObject);
  var I,J,K,X1,X2,Y1,Y2,Z1,Z2: Integer;
      F: TextFile;
      Layer, NCell: Integer;
      Label 1,2,3,4,5,6;
begin
 Y1:=0;Y2:=0; Z1:=0;Z2:=0;
 if not SaveDialog1.Execute then exit;
 if FileExists(SaveDialog1.FileName)
          then if MessageDLG(' '+SaveDialog1.FileName+#10+' . ?',
                  mtConfirmation,[mbOK,mbCancel],0 )<>mrOk then Exit;
 SaveDialog1.InitialDir:=ExtractFilePath(SaveDialog1.FileName);
 OpenDialog1.InitialDir:=ExtractFilePath(SaveDialog1.FileName);
 //  
  X1:=0;
   for I:=1 to XSize do
    for J:=1 to YSize do
     for K:=1 to ZSize do begin
        if Space[I,J,K]<>0 then
          begin
          X1:=I;
          goto 1;
          end;
        end;
1:
    if X1=0 then begin
             ShowMessage('  ');
             exit;
             end;
   X2:=X1;
   for I:=XSize downto X1 do
    for J:=1 to YSize do
     for K:=1 to ZSize do begin
        if Space[I,J,K]<>0 then
          begin
          X2:=I;
          goto 2;
          end;
        end;
2:
   for J:=1 to YSize do
   for I:=1 to XSize do
     for K:=1 to ZSize do begin
        if Space[I,J,K]<>0 then
          begin
          Y1:=J;
          goto 3;
          end;
        end;
3:
   for J:=YSize downto Y1 do
    for I:=1 to XSize do
     for K:=1 to ZSize do begin
        if Space[I,J,K]<>0 then
          begin
          Y2:=J;
          goto 4;
          end;
        end;
4:
   for K:=1 to ZSize do
    for J:=1 to YSize do
     for I:=1 to XSize do begin
        if Space[I,J,K]<>0 then
          begin
          Z1:=K;
          goto 5;
          end;

        end;
5:
    for K:=ZSize downto Z1 do
    for J:=1 to YSize do
     for I:=1 to XSize do begin
        if Space[I,J,K]<>0 then
          begin
          Z2:=K;
          goto 6;
          end;
        end;
6:
 AssignFile(F,SaveDialog1.FileName);
 Rewrite(F);
 try
   Writeln(F,'  (X,Y,Z)');
   Writeln(F,X1);
   Writeln(F,Y1);
   Writeln(F,Z1);
   Writeln(F,' (X,Y,Z)');
   Writeln(F,X2-X1+1);
   Writeln(F,Y2-Y1+1);
   Writeln(F,Z2-Z1+1);
   Writeln(F,'  (Epsilon, Sigma, Mu)');
   Writeln(F,LayerCount);
    for i:=1 to LayerCount do begin
           Writeln(F,FloatToStr(fmOpenGL.Layers[I].Eps));
           Writeln(F,FloatToStr(fmOpenGL.Layers[I].Sig));
           Writeln(F,FloatToStr(fmOpenGL.Layers[I].Mu));
           Writeln(F,IntToStr(Integer(fmOpenGL.Layers[I].Visible)));
           Writeln(F,IntToStr(fmOpenGL.Layers[I].Color));
           Writeln(F,fmOpenGL.Layers[I].Comment);
           end;
   Writeln(F,'');

   Layer:=fmOpenGL.Space[X1,Y1,Z1];
   NCell:=0;
      for k:=Z1 to Z2 do for j:=Y1 to Y2 do for i:=X1 to X2 do
        begin
        if  fmOpenGL.Space[i,j,k] = Layer
            then begin inc(NCell); Continue; end
            else begin
                 Writeln(F,Layer);
                 Writeln(F,NCell);
                 Layer:=fmOpenGL.Space[i,j,k];
                 NCell:=1;
                 end;
        end;
      Writeln(F,Layer);
      Writeln(F,NCell);

      Writeln(F,' ');
 finally
   CloseFile(F);
 end;
end;

procedure TfmOpenGL.N15Click(Sender: TObject);
 var F: TextFile;
     St: String;
     I, NLayer: Integer;
     X,Y,Z: Integer;
     Xo,Yo,Zo: Integer;
     Nxo,Nyo,Nzo,NL: Integer;
     NCell: Cardinal;
     TempBool, No: Integer;
     Eps, Sig, Mu: double;
     Color: tColor;
     Comment: String;
     IsVisible: boolean;

 var   LayersTmp : array[1..255] of String;

begin
 if not OpenDialog1.Execute then exit;
 SaveDialog1.InitialDir:=ExtractFilePath(OpenDialog1.FileName);
 OpenDialog1.InitialDir:=ExtractFilePath(OpenDialog1.FileName);
 SaveUndo;
 AssignFile(F,OpenDialog1.FileName);
 Reset(F);
 try
   ReadLn(F,St);//CELL file
       if St<>'  (X,Y,Z)' then begin ShowMessage('-');Abort;End;
   ReadLn(F,Xo);
   ReadLn(F,Yo);
   ReadLn(F,Zo);

   ReadLn(F,St);
       if St<>' (X,Y,Z)' then begin ShowMessage('-');Abort;End;

   ReadLn(F,NXo);
   ReadLn(F,NYo);
   ReadLn(F,NZo);

   ReadLn(F,St);
       if St<>'  (Epsilon, Sigma, Mu)' then begin ShowMessage('-');Abort;End;
   ReadLn(F,NL);
{    for i:=LayerCount+1 to LayerCount+NL do begin
           ReadLn(F,fmOpenGL.Layers[I].Eps);
           ReadLn(F,fmOpenGL.Layers[I].Sig);
           ReadLn(F,fmOpenGL.Layers[I].Mu);
           ReadLn(F,TempBool);
           fmOpenGL.Layers[I].Visible:=bool(TempBool);
           ReadLn(F,fmOpenGL.Layers[I].Color);
           ReadLn(F,fmOpenGL.Layers[I].Comment);
           end;}
     for i:=1 to NL do begin
           ReadLn(F,Eps);
           ReadLn(F,Sig);
           ReadLn(F,Mu);
           ReadLn(F,TempBool);
           IsVisible:=bool(TempBool);
           ReadLn(F,Color);
           ReadLn(F,Comment);

           LayersTmp[I]:=Comment;
           No:=GetLayerByName(Comment);
             if No=0 then begin
                        inc(LayerCount);
                        fmOpenGL.Layers[LayerCount].Eps:=Eps;
                        fmOpenGL.Layers[LayerCount].Sig:=Sig;
                        fmOpenGL.Layers[LayerCount].Mu:=Mu;
                        fmOpenGL.Layers[LayerCount].Visible:=IsVisible;
                        fmOpenGL.Layers[LayerCount].Color:=Color;
                        fmOpenGL.Layers[LayerCount].Comment:=Comment;
                         end;
           end;

   ReadLn(F,St);
       if St<>'' then begin ShowMessage('-');Abort;End;

   fmObject.Memo1.Lines.Clear;
   fmObject.Memo1.Lines.Add(' : '+IntToStr(Xo)+','+IntToStr(Yo)+','+IntToStr(Zo));
   fmObject.Memo1.Lines.Add('  X, Y, Z: '+IntToStr(NXo)+','+IntToStr(NYo)+','+IntToStr(NZo));
   fmObject.Memo1.Lines.Add('');
   fmObject.spXo.Value:=Xo;
   fmObject.spYo.Value:=Yo;
   fmObject.spZo.Value:=Zo;
   if fmObject.ShowModal<>mrOk then Exit;
   Xo:=fmObject.spXo.Value;
   Yo:=fmObject.spYo.Value;
   Zo:=fmObject.spZo.Value;

    X:=Xo; Y:=Yo; Z:=Zo;
    repeat

         ReadLn(F,St);
         if St=' ' then break;
         NLayer:=StrToInt(St);
         if NLayer > 0 then   NLayer:=GetLayerByName(LayersTmp[NLayer]);
         ReadLn(F,St);
         if St=' ' then break;
         NCell:=StrToInt(St);
         while NCell>0 do begin
           if  (X<XSize)and(Y<YSize)and(Z<ZSize)and(NLayer>0) then Space[X,Y,Z]:=NLayer;
           inc(X);
           if X>=(Xo+Nxo) then begin X:=Xo; Inc(Y); end;
           if Y>=(Yo+Nyo) then begin Y:=Yo; Inc(Z); end;
           Dec(NCell);
           end;

     until EOF(F);

//LayerCount:=LayerCount+NL;
 finally
  CloseFile(F);
 end;

end;

procedure TfmOpenGL.FormShow(Sender: TObject);
begin
 GetOutPoint;
end;

procedure TfmOpenGL.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Timer1.Enabled:= false;
SpeedButton1.Caption:='';

end;


procedure TfmOpenGL.X2Click(Sender: TObject);
  var I,J,K: Integer;
    SpaceTemp: tSpace;
    nx, ny, nz: Integer;
    Xo, Yo, Zo: Integer;
    Fi, Alpha :  double;
    X2,Y2,Z2 :  Integer;
    R :  double;
 var    StepX,StepY,StepZ: double;
begin
 StepX:=1;
 StepY:=StrToFloat(fmNew3dMain.edY.Text)/StrToFloat(fmNew3dMain.edX.Text);
 StepZ:=StrToFloat(fmNew3dMain.edZ.Text)/StrToFloat(fmNew3dMain.edX.Text);
 fmRotate.Caption:=' ';
 fmRotate.GroupBox2.Visible:=True;
 fmRotate.RadioGroup1.Visible:=True;
 if fmRotate.ShowModal<>mrOK then exit;
  SaveUndo;
 nx:=XSize;
 ny:=YSize;
 nz:=ZSize;
 Xo:=0; Yo:=0; Zo:=0;
 if fmRotate.RadioGroup1.ItemIndex=0 then
           begin
            Yo:=fmRotate.SpinEdit1.Value;
            Zo:=fmRotate.SpinEdit2.Value;
            end;
 if fmRotate.RadioGroup1.ItemIndex=1 then
           begin
            Xo:=fmRotate.SpinEdit1.Value;
            Zo:=fmRotate.SpinEdit2.Value;
            end;
 if fmRotate.RadioGroup1.ItemIndex=2 then
           begin
            Xo:=fmRotate.SpinEdit1.Value;
            Yo:=fmRotate.SpinEdit2.Value;
            end;

Fi:=0;
 if fmRotate.RadioButton1.Checked then Fi:=Pi;
 if fmRotate.RadioButton2.Checked then Fi:=Pi/2;
 if fmRotate.RadioButton3.Checked then Fi:=Pi/4;
 if fmRotate.RadioButton4.Checked then Fi:=Pi/180*fmRotate.SpinEdit3.Value;
 for I:=1 to nx do
   for j:=1 to ny do
      for k:=1 to nz do begin
        SpaceTemp[i,j,k]:= Space[i,j,k];
        Space[i,j,k]:=0;
        end;
//   
if fmRotate.RadioGroup1.ItemIndex=0 then
 begin
 for I:=1 to nx do
   for j:=1 to ny do
      for k:=1 to nz do begin
         if SpaceTemp[I,J,K]=0 then continue;
         Alpha := ArcTan2((k-Zo)*StepZ,(j-Yo)*StepY);
         R:=sqrt(sqr((j-Yo)*StepY)+sqr((k-Zo)*StepZ));
         Y2:=Round((R*Cos(Alpha+Fi)/StepY+Yo));
         Z2:=Round((R*Sin(Alpha+Fi)/StepZ+Zo));
         if (Y2>0)and(Z2>0)and(Y2<nY)and(Z2<nz)
             then  Space[I,Y2,Z2]:=SpaceTemp[I,J,K];
         end;
   end; // 

//   Y
if fmRotate.RadioGroup1.ItemIndex=1 then
 begin
 for I:=1 to nx do
   for j:=1 to ny do
      for k:=1 to nz do begin
         if SpaceTemp[I,J,K]=0 then continue;
         Alpha := ArcTan2((k-Zo)*StepZ,(i-Xo)*StepX);
         R:=sqrt(sqr(i-Xo)*StepX+sqr(k-Zo)*StepZ);
         X2:=Round((R*Cos(Alpha+Fi)/StepX+Xo));
         Z2:=Round((R*Sin(Alpha+Fi)/StepZ+Zo));
         if (X2>0)and(Z2>0)and(X2<nX)and(Z2<nz)
             then  Space[X2,j,Z2]:=SpaceTemp[I,J,K];
         end;
   end; // Y

//   Z
if fmRotate.RadioGroup1.ItemIndex=2 then
 begin
 for I:=1 to nx do
   for j:=1 to ny do
      for k:=1 to nz do begin
         if SpaceTemp[I,J,K]=0 then continue;
         Alpha := ArcTan2((i-Xo)*StepX,(j-Yo)*StepY);
         R:=sqrt(sqr(j-Yo)*StepY+sqr(i-Xo)*StepX);
         Y2:=Round((R*Cos(Alpha+Fi)/StepY+Yo));
         X2:=Round((R*Sin(Alpha+Fi)/StepX+Xo));
         if (Y2>0)and(X2>0)and(Y2<nY)and(X2<nX)
             then  Space[X2,Y2,K]:=SpaceTemp[I,J,K];
         end;
   end; // Z
 LookAt;
 StringGrid1.Repaint;
end;


procedure TfmOpenGL.mnShapeRotateClick(Sender: TObject);
  var I,J,K: Integer;
    SpaceTemp: tSpace;
    nx, ny, nz: Integer;
    Fi, Xo, Yo, Zo: Integer;
     Alpha :  double;
    X2,Y2,Z2 :  Integer;
    MinX, MaxX,MinY, MaxY :  Integer;
    R :  double;
    fromX, toX, fromY, toY, fromZ, toZ : Integer;
 var    StepX,StepY,StepZ: double;
    label 1;
begin
1: fmRotate.Caption:='    ';
 fmRotate.GroupBox2.Visible:=False;
 if fmRotate.ShowModal<>mrOK then exit;

 if    (btnX.Down and (fmRotate.RadioGroup1.ItemIndex=0))
    or (btnY.Down and (fmRotate.RadioGroup1.ItemIndex=1))
    or (btnZ.Down and (fmRotate.RadioGroup1.ItemIndex=2))
                 then begin
                 ShowMessage('      ');
                 Goto 1;
                 end;

 for I:=1 to xsize do
   for j:=1 to ysize do
      for k:=1 to zsize do begin
        SpaceTemp[i,j,k]:= Space[i,j,k];
        end;


   MinX:=Min(StartSelect.X,EndSelect.X);
   MaxX:=Max(StartSelect.X,EndSelect.X);
   MinY:=Max(StartSelect.Y,EndSelect.Y);
   MaxY:=Min(StartSelect.Y,EndSelect.Y);
   MinX:=MinX+1;
   MaxX:=MaxX+1;
   MinY:=StringGrid1.RowCount-MinY;
   MaxY:=StringGrid1.RowCount-MaxY;
SaveUndo;
 StepX:=1;
 StepY:=StrToFloat(fmNew3dMain.edY.Text)/StrToFloat(fmNew3dMain.edX.Text);
 StepZ:=StrToFloat(fmNew3dMain.edZ.Text)/StrToFloat(fmNew3dMain.edX.Text);
   fromX:=MinX; // 
   toX:=MaxX;   // 
   fromY:=SpinEdit2.Value;// 
   toY:=SpinEdit2.Value;   // 
   fromZ:=MinY;          // 
   toZ:=MaxY;           // 
//    
if fmRotate.RadioGroup1.ItemIndex=0 then
 begin
   Yo:=fmRotate.SpinEdit1.Value;
   Zo:=fmRotate.SpinEdit2.Value;
   if btnY.Down then begin
                fromX:=MinX;
                toX:=MaxX;
                fromY:=SpinEdit2.Value;
                toY:=SpinEdit2.Value;
                fromZ:=MinY;
                toZ:=MaxY;
                end;

   if btnZ.Down then begin
                fromX:=MinX;
                toX:=MaxX;
                fromY:=MinY;
                toY:=MaxY;
                fromZ:=SpinEdit3.Value;
                toZ:=SpinEdit3.Value;
                end;
for Fi:=0 to 359 do
 for I:=fromX to toX do
   for j:=fromY to toY do
      for k:=fromZ to toZ do begin
         if SpaceTemp[I,J,K]=0 then continue;
         if not Layers[SpaceTemp[I,J,K]].Visible then continue;
         Alpha := ArcTan2((k-Zo)*StepZ,(j-Yo)*StepY);
         R:=sqrt(sqr((j-Yo)*StepY)+sqr((k-Zo)*StepZ));
         Y2:=Round(R*Cos(Alpha+Fi)/StepY)+Yo;
         Z2:=Round(R*Sin(Alpha+Fi)/StepZ)+Zo;
         if (Y2>0)and(Z2>0)and(Y2<=Ysize)and(Z2<=Zsize)
             then  Space[I,Y2,Z2]:=SpaceTemp[I,J,K];
         end;
   end; //e 

//    Y
if fmRotate.RadioGroup1.ItemIndex=1 then
 begin
   Xo:=fmRotate.SpinEdit1.Value;
   Zo:=fmRotate.SpinEdit2.Value;
   if btnX.Down then begin
                fromX:=SpinEdit1.Value;
                toX:=SpinEdit1.Value;
                fromY:=MinY;
                toY:=MaxY;
                fromZ:=MinX;
                toZ:=MaxX;
                end;

   if btnZ.Down then begin
                fromX:=MinX;
                toX:=MaxX;
                fromY:=MinY;
                toY:=MaxY;
                fromZ:=SpinEdit3.Value;
                toZ:=SpinEdit3.Value;
                end;
for Fi:=0 to 359 do
 for I:=fromX to toX do
   for j:=fromY to toY do
      for k:=fromZ to toZ do begin
         if SpaceTemp[I,J,K]=0 then continue;
         if not Layers[SpaceTemp[I,J,K]].Visible then continue;
         Alpha := ArcTan2((k-Zo)*StepZ,(i-Xo)*StepX);
         R:=sqrt(sqr((i-Xo)*StepX)+sqr((k-Zo)*StepZ));
         X2:=Round(R*Cos(Alpha+Fi)/StepX)+Xo;
         Z2:=Round(R*Sin(Alpha+Fi)/StepZ)+Zo;
         if (X2>0)and(Z2>0)and(X2<=Xsize)and(Z2<=Zsize)
             then  Space[X2,J,Z2]:=SpaceTemp[I,J,K];
         end;
   end; //e Y

//    Z
if fmRotate.RadioGroup1.ItemIndex=2 then
 begin
   Xo:=fmRotate.SpinEdit1.Value;
   Yo:=fmRotate.SpinEdit2.Value;
   if btnX.Down then begin
                fromX:=SpinEdit1.Value;
                toX:=SpinEdit1.Value;
                fromY:=MinY;
                toY:=MaxY;
                fromZ:=MinX;
                toZ:=MaxX;
                end;

   if btnY.Down then begin
                fromX:=MinX;
                toX:=MaxX;
                fromY:=SpinEdit2.Value;
                toY:=SpinEdit2.Value;
                fromZ:=MinY;
                toZ:=MaxY;
                end;
for Fi:=0 to 359 do
 for I:=fromX to toX do
   for j:=fromY to toY do
      for k:=fromZ to toZ do begin
         if SpaceTemp[I,J,K]=0 then continue;
         if not Layers[SpaceTemp[I,J,K]].Visible then continue;
         Alpha := ArcTan2((i-Xo)*StepX,(j-Yo)*StepY);
         R:=sqrt(sqr((j-Yo)*StepY)+sqr((i-Xo)*StepX));
         Y2:=Round(R*Cos(Alpha+Fi)/StepY)+Yo;
         X2:=Round(R*Sin(Alpha+Fi)/StepX)+Xo;
         if (Y2>0)and(X2>0)and(Y2<=Ysize)and(X2<=Xsize)
             then  Space[X2,Y2,K]:=SpaceTemp[I,J,K];
         end;
   end; //e Z

 LookAt;
 StringGrid1.Repaint;
end;

procedure TfmOpenGL.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 SpeedButton3Click(nil);
end;

procedure TfmOpenGL.mnUndoClick(Sender: TObject);
begin
  RestoreUndo;
 LookAt;
 StringGrid1.Repaint;
end;

procedure TfmOpenGL.Line3D(P1, P2 :tPoint3D;
                            StepX, StepY,StepZ: double; NLayer: Integer;
                            SdvigX, SdvigY, SdvigZ: Integer);
 var I: Integer;
     MinX, MaxX,
     MinY, MaxY,
     MinZ, MaxZ : double;
     X,Y,Z: Double;
     IX,IY,IZ: Integer;
     ms: DWord;
     Step: single;
       Debug: boolean;
     dX,dY,dZ: Double;
 procedure delay(ms: DWord);
   var d: DWord;
 begin
    if ms=0 then exit;
    d:=GetTickCount;
    LookAt;
    repeat until (GetTickCount-d)>=ms;
 end;
begin    // Line3D

   dX:=Abs(P1.X-P2.X);
   dY:=Abs(P1.Y-P2.Y);
   dZ:=Abs(P1.Z-P2.Z);
 if (dX=0) and (dY=0) and (dZ=0) then exit;

//  Debug:=True;
  Debug:=false;
   ms:=0;
if  Debug then  ms:=1;
if  Debug then  Application.ProcessMessages;
if Debug then NLayer:=1;

 Step:=StepX/Koef;
   MinX:=Min(P1.X,P2.X);
   MaxX:=Max(P1.X,P2.X);
   MinY:=Min(P1.Y,P2.Y);
   MaxY:=Max(P1.Y,P2.Y);
   MinZ:=Min(P1.Z,P2.Z);
   MaxZ:=Max(P1.Z,P2.Z);
// if (MaxX-MinX)> 0 then
 if (dX>=dY)and(dX>=dZ) then
   for I:= Trunc(MinX/Step) to Trunc(MaxX/Step) do
     begin
       X:=I*Step;
       Y:=(X-P1.X)*(P2.Y-P1.Y)/(P2.X-P1.X)+P1.Y;
       Z:=(X-P1.X)*(P2.Z-P1.Z)/(P2.X-P1.X)+P1.Z;
       if (X<MinX)or(X>MaxX) then Continue;
       if (Y<MinY)or(Y>MaxY) then Continue;
       if (Z<MinZ)or(Z>MaxZ) then Continue;
       IX:=Round(X/StepX)+SdvigX;
       IY:=Round(Y/StepY)+SdvigY;
       IZ:=Round(Z/StepZ)+SdvigZ;
       if ((IX>=1)and(IX<NX)) then
       if ((IY>=1)and(IY<NY)) then
       if ((IZ>=1)and(IZ<NZ))
       then
       Space[IX,IY,IZ]:=NLayer;
     end;
delay(ms);
Step:=StepY/Koef;
if Debug then NLayer:=2;
// if (MaxY-MinY)> 0 then
 if (dY>=dX)and(dY>=dZ) then
   for I:= Trunc(MinY/Step) to Trunc(MaxY/Step) do
     begin
       Y:=I*Step;
       X:=(Y-P1.Y)*(P2.X-P1.X)/(P2.Y-P1.Y)+P1.X;
       Z:=(Y-P1.Y)*(P2.Z-P1.Z)/(P2.Y-P1.Y)+P1.Z;
       if (X<MinX)or(X>MaxX) then Continue;
       if (Y<MinY)or(Y>MaxY) then Continue;
       if (Z<MinZ)or(Z>MaxZ) then Continue;
       IX:=Round(X/StepX)+SdvigX;
       IY:=Round(Y/StepY)+SdvigY;
       IZ:=Round(Z/StepZ)+SdvigZ;
       if ((IX>=1)and(IX<NX)) then
       if ((IY>=1)and(IY<NY)) then
       if ((IZ>=1)and(IZ<NZ))
       then
       Space[IX,IY,IZ]:=NLayer;
     end;

 delay(ms);
Step:=StepZ/Koef;
if Debug then NLayer:=3;

// if (MaxZ-MinZ)> 0 then
 if (dZ>=dX)and(dZ>=dY) then
   for I:= Trunc(MinZ/Step) to Trunc(MaxZ/Step) do
     begin
       Z:=I*Step;
       X:=(Z-P1.Z)*(P2.X-P1.X)/(P2.Z-P1.Z)+P1.X;
       Y:=(Z-P1.Z)*(P2.Y-P1.Y)/(P2.Z-P1.Z)+P1.Y;
       if (X<MinX)or(X>MaxX) then Continue;
       if (Y<MinY)or(Y>MaxY) then Continue;
       if (Z<MinZ)or(Z>MaxZ) then Continue;
       IX:=Round(X/StepX)+SdvigX;
       IY:=Round(Y/StepY)+SdvigY;
       IZ:=Round(Z/StepZ)+SdvigZ;
       if ((IX>=1)and(IX<NX)) then
       if ((IY>=1)and(IY<NY)) then
       if ((IZ>=1)and(IZ<NZ))
       then
       Space[IX,IY,IZ]:=NLayer;
     end;
 delay(ms);
end;

procedure TfmOpenGL.Triangle3D(P1, P2, P3 :tPoint3D;
                            StepX, StepY,StepZ: double; NLayer: Integer;
                            SdvigX, SdvigY, SdvigZ: Integer);
var P4, P5, P6, P7 :tPoint3D;

function GetNextPoint(P1,P2:tPoint3D) :tPoint3D;
 var MinX, MaxX, MinY, MaxY,MinZ, MaxZ: double;
     X,Y,Z: Double;
     dX,dY,dZ: Double;
     Step: double;
 begin
   dX:=Abs(P1.X-P2.X);
   dY:=Abs(P1.Y-P2.Y);
   dZ:=Abs(P1.Z-P2.Z);

       Result.X:=P1.X;
       Result.Y:=P1.Y;
       Result.Z:=P1.Z;

 if (dX>=dY)and(dX>=dZ) then begin
   Step:=StepX/Koef;
   MinX:=Min(P1.X,P2.X);
   MaxX:=Max(P1.X,P2.X);
   if (MaxX-MinX)>=Step then
     begin
       if P1.X=MinX then    X:=P1.X+Step
                    else    X:=P1.X-Step;
       Y:=(X-P1.X)*(P2.Y-P1.Y)/(P2.X-P1.X)+P1.Y;
       Z:=(X-P1.X)*(P2.Z-P1.Z)/(P2.X-P1.X)+P1.Z;
       Result.X:=X;
       Result.Y:=Y;
       Result.Z:=Z;
     end;
    exit;
    end;//if (dX>=dY)and(dX>=dZ)

 if (dY>=dX)and(dY>=dZ) then begin
   Step:=StepY/Koef;
   MinY:=Min(P1.Y,P2.Y);
   MaxY:=Max(P1.Y,P2.Y);
   if (MaxY-MinY)>=Step then
     begin
       if P1.Y=MinY then    Y:=P1.Y+Step
                    else    Y:=P1.Y-Step;
       X:=(Y-P1.Y)*(P2.X-P1.X)/(P2.Y-P1.Y)+P1.X;
       Z:=(Y-P1.Y)*(P2.Z-P1.Z)/(P2.Y-P1.Y)+P1.Z;
       Result.X:=X;
       Result.Y:=Y;
       Result.Z:=Z;
     end;
    exit;
    end;// if (dY>=dX)and(dY>=dZ)

 if (dZ>=dX)and(dZ>=dY) then begin
   Step:=StepZ/Koef;
   MinZ:=Min(P1.Z,P2.Z);
   MaxZ:=Max(P1.Z,P2.Z);
   if (MaxZ-MinZ)>=Step then
     begin
       if P1.Z=MinZ then    Z:=P1.Z+Step
                    else    Z:=P1.Z-Step;
       X:=(Z-P1.Z)*(P2.X-P1.X)/(P2.Z-P1.Z)+P1.X;
       Y:=(Z-P1.Z)*(P2.Y-P1.Y)/(P2.Z-P1.Z)+P1.Y;
       Result.X:=X;
       Result.Y:=Y;
       Result.Z:=Z;
     end;
    exit;
    end;// if (dY>=dX)and(dY>=dZ)
 end;

function Eq(P1,P2:tPoint3D):boolean;
   begin
    Result:=(P1.X=P2.X)and(P1.Y=P2.Y)and(P1.Z=P2.Z);
   end;
begin   {Triangle3D}

 Line3D(P1, P2, StepX, StepY, StepZ, NLayer,SdvigX, SdvigY, SdvigZ);
 Line3D(P1, P3, StepX, StepY, StepZ, NLayer,SdvigX, SdvigY, SdvigZ);
 Line3D(P2, P3, StepX, StepY, StepZ, NLayer,SdvigX, SdvigY, SdvigZ);
//exit;
 P6:=P1;
 P7:=P1;
 repeat
 P4:=P6;
 P5:=P7;
 P6:= GetNextPoint(P4,P2);
 P7:= GetNextPoint(P5,P3);
 Line3D(P6, P7, StepX, StepY, StepZ, NLayer, SdvigX, SdvigY, SdvigZ);
 until (Eq(P6,P4))and(Eq(P7,P5));

 P6:=P2;
 P7:=P2;
 repeat
 P4:=P6;
 P5:=P7;
 P6:= GetNextPoint(P4,P1);
 P7:= GetNextPoint(P5,P3);
 Line3D(P6, P7, StepX, StepY, StepZ, NLayer, SdvigX, SdvigY, SdvigZ);
 until (Eq(P6,P4))and(Eq(P7,P5));

 P6:=P3;
 P7:=P3;
 repeat
 P4:=P6;
 P5:=P7;
 P6:= GetNextPoint(P4,P1);
 P7:= GetNextPoint(P5,P2);
 Line3D(P6, P7, StepX, StepY, StepZ, NLayer, SdvigX, SdvigY, SdvigZ);
 until (Eq(P6,P4))and(Eq(P7,P5));

end;

Procedure TfmOpenGL.D3Face(P1, P2, P3, P4:tPoint3D;
                 StepX,StepY,StepZ: Double;
                 Layer, SdvigX, SdvigY, SdvigZ : Integer);
  var  R1,R2: double;
       P_1, P_2,P_3, P_4 :tPoint3D;
begin
  R1:= SQRT(SQR(P1.X-P3.X)+SQR(P1.Y-P3.Y)+SQR(P1.Z-P3.Z));
  R2:= SQRT(SQR(P2.X-P4.X)+SQR(P2.Y-P4.Y)+SQR(P2.Z-P4.Z));
  if R1<R2 then begin
                P_1 := P1;
                P_2 := P3;
                P_3 := P2;
                P_4 := P4;
                end
            else begin
                P_1 := P2;
                P_2 := P4;
                P_3 := P1;
                P_4 := P3;
                end;

  Triangle3D(P_1, P_2, P_3, StepX,StepY,StepZ,
         Layer, SdvigX, SdvigY, SdvigZ);
  Triangle3D(P_1, P_2, P_4, StepX,StepY,StepZ,
         Layer, SdvigX, SdvigY, SdvigZ);
end;

procedure TfmOpenGL.DXF_Parser(FileName: string);
 var F: TextFile;
     St: String;

  var P1, P2, P3, P4 :tPoint3D;
        SdvigX, SdvigY, SdvigZ: Integer;
 var    StepX,StepY,StepZ: double;
        Cancel, FindLayer,Find3DFACE, FindLayerNo : Boolean;
        StCount: Integer;
 type  tLayersTmp = record
                    Name: String;
                    No: Integer;
                    end;
 var   LayersTmp : array[1..255] of tLayersTmp;
       CountTmp: Integer;
       I, CurrentTmpLayer: Integer;
       CoordYes : array[1..12] of boolean;
       AllCoord: boolean;
       FaceCount, FindFaces: Integer;
       MinX, MaxX, MinY, MaxY, MinZ, MaxZ, dopX, dopY, dopZ : double;
       CountX,CountY,CountZ: Integer;
       No: Integer;
begin
 StepX:=StrToFloat(fmNew3dMain.edX.Text);
 StepY:=StrToFloat(fmNew3dMain.edY.Text);
 StepZ:=StrToFloat(fmNew3dMain.edZ.Text);
 SdvigX:=1;
 SdvigY:=1;
 SdvigZ:=1;
 fmTriangle.Memo1.Lines.Clear;
 fmTriangle.Show;
 fmTriangle.Refresh;
 //  
 Cancel:=True;
 FindLayer:=False;
 StCount:=0;
 CountTmp:=0;
 AssignFile(F,OpenCelFile.FileName);
 Reset(F);
 FaceCount:=0;
 //  
 fmTriangle.Memo1.Lines.Add(': ');
 while not eof(F) do begin
     ReadLn(F,St);
     if St='3DFACE' then inc(FaceCount);
     if st='EOF' then break;;
     inc(StCount);
     if (StCount mod 200)=0 then begin
        fmTriangle.Label1.Caption:='  '+ IntToStr(StCount);
        Application.ProcessMessages;
        end;

     if Cancel and (St<>'  0') then continue;
     if Cancel then begin
                     Cancel:=False;
                     Continue;
                    end;
     if not FindLayer then if St='LAYER' then begin
                            FindLayer:=True;
                            Continue;
                            end
                       else  begin
                            Cancel:=True;
                            Continue;
                            end;
     if st = '  0' then begin
                       FindLayer:=False;
                       Continue;
                      end;
     if st = '  2' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       inc(CountTmp);
                       LayersTmp[CountTmp].Name:=St;
                       LayersTmp[CountTmp].No:=CountTmp;
                       Cancel:=True;
                       FindLayer:=False;
                       fmTriangle.Memo1.Lines.Add(St);
                       Continue;
                      end;

     end;
     if CountTmp=0 then begin
                        CloseFile(F);
                        fmTriangle.Memo1.Lines.Add('   ');
                        Abort;
                        end;
  //  
    fmLayers.StringGrid1.RowCount:=fmLayers.StringGrid1.RowCount+CountTmp;
    for i:=1 to CountTmp do begin
          No:=GetLayerByName(LayersTmp[I].Name);
           if No = 0 then begin
               inc(LayerCount);
               Layers[LayerCount].Comment :=LayersTmp[I].Name;
               end;
         end;

 //  
 Cancel:=True;
 Find3DFACE:=False;
 FindLayerNo:=False;
 StCount:=0;
 CurrentTmpLayer:=0;
  if FaceCount = 0 then begin
                        fmTriangle.Memo1.Lines.Add ('***** !!!');
                        Abort;
                        end;
 fmTriangle.Memo1.Lines.Add(' :' +IntToStr(FaceCount));
FaceCount:=FaceCount+1;
 SetLength(Faces,sizeOf(tFace)*FaceCount);
 Reset(F);
 try
 for I:=1 to 12 do  CoordYes[I]:= False;
 //  
 fmTriangle.Memo1.Lines.Add(': ');
 FindFaces:=0;
 FaceCount:=0;
 while not eof(F) do begin
     ReadLn(F,St);
     if st='EOF' then break;;
     inc(StCount);
     if (StCount mod 100)=0 then begin
        fmTriangle.Label1.Caption:='  '+ IntToStr(StCount);
        Application.ProcessMessages;
        end;
     if Cancel and (St<>'  0') then continue;
     if Cancel then begin
                     Cancel:=False;
                     Continue;
                    end;
     if not Find3DFACE then if St='3DFACE' then begin
                            Find3DFACE:=True;
                            inc(FaceCount);
                            Continue;
                            end
                       else  begin
                            Cancel:=True;
                            Continue;
                            end;
     if st = '  0' then begin
                       // 
                       AllCoord:=True;
                       for I:=1 to 12 do
                            if CoordYes[I]= False then AllCoord:=False;
                       if not AllCoord then fmTriangle.Memo1.Lines.Add(' ');
                       if not FindLayerNo then fmTriangle.Memo1.Lines.Add('  ');
                       if  (not FindLayerNo) or (not AllCoord) then continue;

                       Faces[FindFaces].P1:=P1;
                       Faces[FindFaces].P2:=P2;
                       Faces[FindFaces].P3:=P3;
                       Faces[FindFaces].P4:=P4;
                       No:=GetLayerByName(LayersTmp[CurrentTmpLayer].Name);

                       Faces[FindFaces].Layer:=No;
                       inc(FindFaces);

                       Find3DFACE:=False;
                       FindLayerNo:=False;
                       for I:=1 to 12 do  CoordYes[I]:= False;
                       Continue;
                      end;
     if st = '  8' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       CurrentTmpLayer:=0;
                       FindLayerNo:=False;
                       for I:=1 to CountTmp do begin
                         if  St = LayersTmp[I].Name   
                           then  CurrentTmpLayer:=LayersTmp[I].No;
                       end;
                       if CurrentTmpLayer>0 then FindLayerNo:=True
                          else  fmTriangle.Memo1.Lines.Add(St);
                       Continue;
                      end;

     if st = ' 10' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P1.X:= StrToFloat(St);
                       CoordYes[1]:= True;
                      // fmTriangle.Memo1.Lines.Add('10 '+St);
                       Continue;
                       end;
     if st = ' 11' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P2.X:= StrToFloat(St);
                       CoordYes[2]:= True;
                       //fmTriangle.Memo1.Lines.Add('11 '+St);
                       Continue;
                       end;
     if st = ' 12' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P3.X:= StrToFloat(St);
                       CoordYes[3]:= True;
                       //fmTriangle.Memo1.Lines.Add('12 '+St);
                       Continue;
                       end;
     if st = ' 13' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P4.X:= StrToFloat(St);
                       CoordYes[10]:= True;
                       //fmTriangle.Memo1.Lines.Add('12 '+St);
                       Continue;
                       end;
     if st = ' 20' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P1.Y:= StrToFloat(St);
                       CoordYes[4]:= True;
                       //fmTriangle.Memo1.Lines.Add('20 '+St);
                       Continue;
                       end;
     if st = ' 21' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P2.Y:= StrToFloat(St);
                       CoordYes[5]:= True;
                       //fmTriangle.Memo1.Lines.Add('21 '+St);
                       Continue;
                       end;
     if st = ' 22' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P3.Y:= StrToFloat(St);
                       CoordYes[6]:= True;
                       //fmTriangle.Memo1.Lines.Add('22 '+St);
                       Continue;
                       end;
     if st = ' 23' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P4.Y:= StrToFloat(St);
                       CoordYes[11]:= True;
                       //fmTriangle.Memo1.Lines.Add('22 '+St);
                       Continue;
                       end;

     if st = ' 30' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P1.Z:= StrToFloat(St);
                       CoordYes[7]:= True;
                       //fmTriangle.Memo1.Lines.Add('30 '+St);
                       Continue;
                       end;
     if st = ' 31' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P2.Z:= StrToFloat(St);
                       CoordYes[8]:= True;
                       //fmTriangle.Memo1.Lines.Add('31 '+St);
                       Continue;
                       end;
     if st = ' 32' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P3.Z:= StrToFloat(St);
                       CoordYes[9]:= True;
                       //fmTriangle.Memo1.Lines.Add('32 '+St);
                       Continue;
                       end;
     if st = ' 33' then begin
                       ReadLn(F,St);
                       inc(StCount);
                       P4.Z:= StrToFloat(St);
                       CoordYes[12]:= True;
                       //fmTriangle.Memo1.Lines.Add('32 '+St);
                       Continue;
                       end;

     end;

 fmTriangle.Memo1.Lines.Add(': ');

     MinX:=Faces[0].P1.X;
     MaxX:=Faces[0].P1.X;
     MinY:=Faces[0].P1.Y;
     MaxY:=Faces[0].P1.Y;
     MinZ:=Faces[0].P1.Z;
     MaxZ:=Faces[0].P1.Z;
 for i:=0 to FindFaces-1 do
   begin
     if MinX>Faces[I].P1.X  then MinX:=Faces[I].P1.X;
     if MinX>Faces[I].P2.X  then MinX:=Faces[I].P2.X;
     if MinX>Faces[I].P3.X  then MinX:=Faces[I].P3.X;
     if MinX>Faces[I].P4.X  then MinX:=Faces[I].P4.X;
     if MaxX<Faces[I].P1.X  then MaxX:=Faces[I].P1.X;
     if MaxX<Faces[I].P2.X  then MaxX:=Faces[I].P2.X;
     if MaxX<Faces[I].P3.X  then MaxX:=Faces[I].P3.X;
     if MaxX<Faces[I].P4.X  then MaxX:=Faces[I].P4.X;

     if MinY>Faces[I].P1.Y  then MinY:=Faces[I].P1.Y;
     if MinY>Faces[I].P2.Y  then MinY:=Faces[I].P2.Y;
     if MinY>Faces[I].P3.Y  then MinY:=Faces[I].P3.Y;
     if MinY>Faces[I].P4.Y  then MinY:=Faces[I].P4.Y;
     if MaxY<Faces[I].P1.Y  then MaxY:=Faces[I].P1.Y;
     if MaxY<Faces[I].P2.Y  then MaxY:=Faces[I].P2.Y;
     if MaxY<Faces[I].P3.Y  then MaxY:=Faces[I].P3.Y;
     if MaxY<Faces[I].P4.Y  then MaxY:=Faces[I].P4.Y;

     if MinZ>Faces[I].P1.Z  then MinZ:=Faces[I].P1.Z;
     if MinZ>Faces[I].P2.Z  then MinZ:=Faces[I].P2.Z;
     if MinZ>Faces[I].P3.Z  then MinZ:=Faces[I].P3.Z;
     if MinZ>Faces[I].P4.Z  then MinZ:=Faces[I].P4.Z;
     if MaxZ<Faces[I].P1.Z  then MaxZ:=Faces[I].P1.Z;
     if MaxZ<Faces[I].P2.Z  then MaxZ:=Faces[I].P2.Z;
     if MaxZ<Faces[I].P3.Z  then MaxZ:=Faces[I].P3.Z;
     if MaxZ<Faces[I].P4.Z  then MaxZ:=Faces[I].P4.Z;
   end;

    dopX:= 0-MinX;
    dopY:= 0-MinY;
    dopZ:= 0-MinZ;
    CountX:= trunc((MaxX-MinX)/StepX)+2;
    CountY:= trunc((MaxY-MinY)/StepY)+2;
    CountZ:= trunc((MaxZ-MinZ)/StepZ)+2;

    fmTriangle.Memo1.Lines.Add('  : '+
                  FloatToStr(StepX)+'x'+FloatToStr(StepY)+'x'+FloatToStr(StepZ)+' ');
    fmTriangle.Memo1.Lines.Add(' : '+
                  FloatToStr(MaxX-MinX)+'x'+FloatToStr(MaxY-MinY)+'x'+FloatToStr(MaxZ-MinZ)+' ');
    fmTriangle.Memo1.Lines.Add(' : '+
                  FloatToStr(XSize)+'x'+FloatToStr(YSize)+'x'+FloatToStr(ZSize)+' ');
    fmTriangle.Memo1.Lines.Add(' : '+
                  IntToStr(CountX)+'x'+IntToStr(CountY)+'x'+IntToStr(CountZ)+' ');
       If (CountX>XSize)or(CountY>YSize)or(CountZ>ZSize)
          then begin
               ShowMessage('    '+#13+'   ');
               Abort;
           end;
    fmTriangle.Memo1.Lines.Add(' ... ');

 for i:=0 to FaceCount-1 do
   begin
        Faces[I].P1.X:=Faces[I].P1.X+dopX;
        Faces[I].P1.Y:=Faces[I].P1.Y+dopY;
        Faces[I].P1.Z:=Faces[I].P1.Z+dopZ;
        Faces[I].P2.X:=Faces[I].P2.X+dopX;
        Faces[I].P2.Y:=Faces[I].P2.Y+dopY;
        Faces[I].P2.Z:=Faces[I].P2.Z+dopZ;
        Faces[I].P3.X:=Faces[I].P3.X+dopX;
        Faces[I].P3.Y:=Faces[I].P3.Y+dopY;
        Faces[I].P3.Z:=Faces[I].P3.Z+dopZ;
        Faces[I].P4.X:=Faces[I].P4.X+dopX;
        Faces[I].P4.Y:=Faces[I].P4.Y+dopY;
        Faces[I].P4.Z:=Faces[I].P4.Z+dopZ;
        D3Face(Faces[I].P1, Faces[I].P2, Faces[I].P3, Faces[I].P4, StepX,StepY,StepZ,
                           Faces[I].Layer, SdvigX, SdvigY, SdvigZ);
     fmTriangle.Label1.Caption:=' ... '+IntToStr(i+1);
     fmTriangle.Label1.Refresh;
   end;

  fmTriangle.Memo1.Lines.Add(',  ');
 fmTriangle.Label1.Caption:=' ';
 if fmTriangle.Visible then fmTriangle.Close;
 fmTriangle.ShowModal;
 finally
 CloseFile(F);
 SetLength(Faces,0);
 end;


end;
Function TfmOpenGL.GetLayerByName(Name: String):Integer;
  var I: Integer;
begin
    Result:=0;
    for i:=1 to LayerCount do begin
          if AnsiUpperCase(Layers[I].Comment) = AnsiUpperCase(Name)
             then begin
                   Result:=I;
                   exit;
                  end;
         end;

end;

procedure TfmOpenGL.mnGroundClick(Sender: TObject);
begin
  mnGround.Checked:= not   mnGround.Checked;
 LookAt;
end;

procedure TfmOpenGL.mnCellParmsClick(Sender: TObject);
begin
     fmSellParms.ShowParams(X_Selected,Y_Selected,Z_Selected);
end;

procedure TfmOpenGL.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
exit;
if MouseDown then exit;

  if btnLine3D.Down then  begin
                       SetLine3d;
                       Exit;
                       end;


 Row_Selected:=ARow;
 Col_Selected:=ACol;
 if rbX.Checked then begin
          X_Selected:=Sx;
          Y_Selected:=StringGrid1.RowCount-Row_Selected;
          Z_Selected:=Col_Selected+1;
          end;
 if rbY.Checked then begin
          X_Selected:=Col_Selected+1;
          Y_Selected:=Sy;
          Z_Selected:=StringGrid1.RowCount-Row_Selected;
          end;
 if rbZ.Checked then begin
          X_Selected:=Col_Selected+1;
          Y_Selected:=StringGrid1.RowCount-Row_Selected;
          Z_Selected:=Sz;
          end;
 StatusBar1.Panels[1].Text:='  '+
           IntToStr(X_Selected)+', '+IntToStr(Y_Selected)+', '+IntToStr(Z_Selected);
end;

Procedure TfmOpenGL.SetLine3d;
  var K: double;
      var P1, P2,P_1,P_2 :tPoint3D;
begin
  if not Layers[LayerCurrent].visible then exit;
    P1.X:=X_Selected;
    P1.Y:=Y_Selected;
    P1.Z:=Z_Selected;
    P2.X:=X_Current;
    P2.Y:=Y_Current;
    P2.Z:=Z_Current;
  SaveUndo;
    Line3D(P1, P2, 1,1,1, LayerCurrent, 0, 0, 0);
   K:=0.1;
     P_1:=P1;
     P_2:=P2;
     P_1.X:=P_1.X+K;
     P_2.X:=P_2.X+K;
// if rbY.Checked then
      Line3D(P_1, P_2, 1,1,1, LayerCurrent, 0, 0, 0);
     P_1:=P1;
     P_2:=P2;
     P_1.Y:=P_1.Y+K;
     P_2.Y:=P_2.Y+K;
// if rbZ.Checked then
       Line3D(P_1, P_2, 1,1,1, LayerCurrent, 0, 0, 0);
     P_1:=P1;
     P_2:=P2;
     P_1.Z:=P_1.Z+K;
     P_2.Z:=P_2.Z+K;
// if rbX.Checked then
     Line3D(P_1, P_2, 1,1,1, LayerCurrent, 0, 0, 0);

end;
procedure TfmOpenGL.N17Click(Sender: TObject);
begin
     fmParam.spX.Value:=X_Selected;
     fmParam.spY.Value:=Y_Selected;
     fmParam.spZ.Value:=Z_Selected;
     fmParam.ShowModal;
     fmNew3dMain.rbNoInput.Checked:=true;

end;

procedure TfmOpenGL.btn3DfillClick(Sender: TObject);
begin
  Selected:=False;
 StringGrid1.Repaint;
end;

procedure TfmOpenGL.Set3DFill;
  var  X, Y, Z, Rows, TempNo: Integer;
       Zero: boolean;
       OldLayer: Integer;
       Xc,Yc,Zc: Integer;
begin
  if not Layers[LayerCurrent].visible then exit;
  SaveUndo;
   X:=StartPoint.X;
   Y:=StartPoint.Y;
   Rows:=StringGrid1.RowCount;

   Xc:=1;Yc:=1;Zc:=1;
   if rbX.Checked then  begin
          Xc:=Sx;
          Yc:=Rows-Y;
          Zc:=X+1;
          end;
   if rbY.Checked then  begin
          Xc:=X+1;
          Yc:=Sy;
          Zc:=Rows-Y;
          end;
   if rbZ.Checked then  begin
          Xc:=X+1;
          Yc:=Rows-Y;
          Zc:=Sz;
          end;

   TempNo:=255;
   OldLayer:=Space[Xc,Yc,Zc];
   Space[Xc,Yc,Zc]:=TempNo;

repeat
  Zero:= True;
   for X:=1 to XSize do
     for Y:=1 to YSize do
       for Z:=1 to ZSize do
     begin
      if Space[X,Y,Z]=TempNo then
        begin
          if X>1 then
            if Space[X-1,Y,Z]=OldLayer then begin
                   Space[X-1,Y,Z]:=TempNo;
                   Zero:= False;
                   end;
          if X<XSize then
            if Space[X+1,Y,Z]=OldLayer then  begin
                   Space[X+1,Y,Z]:=TempNo;
                   Zero:= False;
                   end;
          if Y>1 then
            if Space[X,Y-1,Z]=OldLayer then  begin
                   Space[X,Y-1,Z]:=TempNo;
                   Zero:= False;
                   end;
          if Y< YSize then
            if Space[X,Y+1,Z]=OldLayer then  begin
                   Space[X,Y+1,Z]:=TempNo;
                   Zero:= False;
                   end;
          if Z>1 then
            if Space[X,Y,Z-1]=OldLayer then  begin
                   Space[X,Y,Z-1]:=TempNo;
                   Zero:= False;
                   end;
          if Z< ZSize then
            if Space[X,Y,Z+1]=OldLayer then  begin
                   Space[X,Y,Z+1]:=TempNo;
                   Zero:= False;
                   end;
        end;
   end;
until Zero;

   for X:=1 to XSize do
     for Y:=1 to YSize do
       for Z:=1 to ZSize do
      if Space[X,Y,Z]=TempNo then Space[X,Y,Z]:=LayerCurrent;

  LookAt;
  StringGrid1.Repaint;
end;
procedure  TfmOpenGL.SetCurrentSell(Col,Row: Integer);
//  
begin
 Row_Selected:=Row;
 Col_Selected:=Col;
 if rbX.Checked then begin
          X_Selected:=Sx;
          Y_Selected:=StringGrid1.RowCount-Row_Selected;
          Z_Selected:=Col_Selected+1;
          end;
 if rbY.Checked then begin
          X_Selected:=Col_Selected+1;
          Y_Selected:=Sy;
          Z_Selected:=StringGrid1.RowCount-Row_Selected;
          end;
 if rbZ.Checked then begin
          X_Selected:=Col_Selected+1;
          Y_Selected:=StringGrid1.RowCount-Row_Selected;
          Z_Selected:=Sz;
          end;
 StatusBar1.Panels[1].Text:='  '+
           IntToStr(X_Selected)+', '+IntToStr(Y_Selected)+', '+IntToStr(Z_Selected);
//   
end;
procedure TfmOpenGL.Panel4Resize(Sender: TObject);
begin
  FormResize(nil);
end;

procedure TfmOpenGL.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (ssShift in Shift) then begin
 StatusBar1.Panels[0].Text:=' ';
 dalfa:=0.1;

     end
     else begin
 StatusBar1.Panels[0].Text:=' ';
 dalfa:=0.2;
     end;
 if (ssCtrl in Shift) then begin
 StatusBar1.Panels[0].Text:=' ';
 dalfa:=0.5;
     end;

end;

procedure TfmOpenGL.mnShowCLinesClick(Sender: TObject);
begin
  mnShowCLines.Checked:= not mnShowCLines.Checked;
  LookAt;
  StringGrid1.Repaint;
end;

end.


