program ZFDTD;

uses
  Forms,
  Windows,
  SysUtils,
  N3dMain in 'N3dMain.pas' {fmNew3dMain},
  N3dUtils in 'N3dUtils.pas',
  Utillits in 'Utillits.pas',
  S_About in 'S_About.pas' {fmAbout},
  ChartVal in 'ChartVal.pas' {fmValue},
  ChartLeg in 'ChartLeg.pas' {fmLegend},
  ChartLin in 'ChartLin.pas' {fmLines},
  ChartMy in 'ChartMy.pas' {fmChart},
  ChartOfo in 'ChartOfo.pas' {fmEditComments},
  ChartPrO in 'ChartPrO.pas' {fmPrinOptions},
  ChartSel in 'ChartSel.pas' {fmSelectGr},
  ChartAbt in 'ChartAbt.pas' {fmAboutChart},
  D3OpenMain in 'D3OpenMain.pas' {fmOpenGL},
  D3Layers in 'D3Layers.pas' {fmLayers},
  D3Obj in 'D3Obj.pas' {fmObject},
  D3Copy in 'D3Copy.pas' {fmCopy},
  N3Move in 'N3Move.pas' {fmMove},
  D3Visual in 'D3Visual.pas' {fmVisual},
  ChartSpectr in 'ChartSpectr.pas' {fmSpectr},
  ChartBackSpectr in 'ChartBackSpectr.pas' {fmBackSpectr},
  ChartRC in 'ChartRC.pas' {fmChartRC},
  D3Rotate in 'D3Rotate.pas' {fmRotate},
  D3Param in 'D3Param.pas' {fmParam},
  d3Start in 'd3Start.pas' {fmStart},
  D3Triangle in 'D3Triangle.pas' {fmTriangle},
  Protect in 'Protect.pas' {fmProtect},
  D3CellParms in 'D3CellParms.pas' {fmSellParms};

{$R *.RES}
var I: Dword;
//    path : String;
begin
  Application.Initialize;
  Application.ShowMainForm:=False;
  Application. UpdateFormatSettings:= False;
  DecimalSeparator:='.';
  I:=GetTickCount;

  Application.CreateForm(TfmNew3dMain, fmNew3dMain);
  Application.CreateForm(TfmStart, fmStart);
  Application.CreateForm(TfmTriangle, fmTriangle);
  Application.CreateForm(TfmProtect, fmProtect);
  Application.CreateForm(TfmSellParms, fmSellParms);
  fmStart.Show;
  fmStart.Refresh;
  repeat
  until (GetTickCount-I)>500;
  Application.CreateForm(TfmAbout, fmAbout);
  Application.CreateForm(TfmValue, fmValue);
  Application.CreateForm(TfmLegend, fmLegend);
  Application.CreateForm(TfmLines, fmLines);
  Application.CreateForm(TfmChart, fmChart);
  Application.CreateForm(TfmEditComments, fmEditComments);
  Application.CreateForm(TfmPrinOptions, fmPrinOptions);
  Application.CreateForm(TfmSelectGr, fmSelectGr);
  Application.CreateForm(TfmAboutChart, fmAboutChart);
  Application.CreateForm(TfmOpenGL, fmOpenGL);
  Application.CreateForm(TfmLayers, fmLayers);
  Application.CreateForm(TfmObject, fmObject);
  Application.CreateForm(TfmCopy, fmCopy);
  Application.CreateForm(TfmMove, fmMove);
  Application.CreateForm(TfmVisual, fmVisual);
  Application.CreateForm(TfmSpectr, fmSpectr);
  Application.CreateForm(TfmBackSpectr, fmBackSpectr);
  Application.CreateForm(TfmChartRC, fmChartRC);
  Application.CreateForm(TfmRotate, fmRotate);
  Application.CreateForm(TfmParam, fmParam);

  Application.Hint:=' ZFDTD';
  Application.Title:='ZFDTD V 3.x';

//  Application.HelpFile := 'Zfdtd.hlp';
  Application.ShowMainForm:=True;
  fmStart.Close;

  Application.Run;
end.
