unit ChartMy;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, vcf1, chartfx3, TeEngine, Series, ExtCtrls, TeeProcs,
  Chart, StdCtrls, Buttons, Menus, Printers,IniFiles, ComCtrls;

type
  TfmChart = class(TForm)
    Panel3: TPanel;
    Chart: TChart;
    Panel1: TPanel;
    Panel2: TPanel;
    btnOpen: TSpeedButton;
    OpenD: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    CloseAll1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    SaveaBitmap1: TMenuItem;
    N3: TMenuItem;
    SaveaMetafile1: TMenuItem;
    CopytoClipboard1: TMenuItem;
    SaveD: TSaveDialog;
    CopytoClipboardBMP1: TMenuItem;
    Titles1: TMenuItem;
    Legend1: TMenuItem;
    Print1: TMenuItem;
    PrintOption1: TMenuItem;
    SpeedButton1: TSpeedButton;
    Fon1: TMenuItem;
    ColorD: TColorDialog;
    SpeedButton2: TSpeedButton;
    X: TMenuItem;
    CdvigX: TMenuItem;
    MulX: TMenuItem;
    Y1: TMenuItem;
    SdvigY: TMenuItem;
    MulY: TMenuItem;
    KorY: TMenuItem;
    KvadratY: TMenuItem;
    Modul: TMenuItem;
    Summa: TMenuItem;
    N6: TMenuItem;
    LogX1: TMenuItem;
    LogY1: TMenuItem;
    Save1: TMenuItem;
    N8: TMenuItem;
    Legengs1: TMenuItem;
    lbCoopd: TLabel;
    btnEdit: TSpeedButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Lines1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    N9: TMenuItem;
    mnSelectActive: TMenuItem;
    Label1: TLabel;
    mnExport: TMenuItem;
    mnN: TMenuItem;
    StatusBar1: TStatusBar;
    SpeedButton3: TSpeedButton;
    N10: TMenuItem;
    mnIzmerit: TMenuItem;
    SpeedButton4: TSpeedButton;
    N11: TMenuItem;
    SpeedButton5: TSpeedButton;
    SaveBMP: TSaveDialog;
    SaveWMF: TSaveDialog;
    N12: TMenuItem;
    N13: TMenuItem;
    mnVid: TMenuItem;
    N2: TMenuItem;
    mnDiffer: TMenuItem;
    N5: TMenuItem;
    N1: TMenuItem;
    RC1: TMenuItem;
    N7: TMenuItem;
    RC2: TMenuItem;
    RC3: TMenuItem;
    N14: TMenuItem;
    ImpRect: TMenuItem;
    btnExit: TSpeedButton;
    N15: TMenuItem;
    N16: TMenuItem;
    mnSpectr: TMenuItem;
    N4: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    Y1Y1: TMenuItem;
    N19: TMenuItem;
    SpeedButton6: TSpeedButton;
    N20: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure DeleteAll1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SaveaBitmap1Click(Sender: TObject);
    procedure CopytoClipboard1Click(Sender: TObject);
    procedure SaveaMetafile1Click(Sender: TObject);
    procedure CopytoClipboardBMP1Click(Sender: TObject);
    procedure Titles1Click(Sender: TObject);
    procedure Legend1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrintOption1Click(Sender: TObject);
    procedure Fon1Click(Sender: TObject);
    procedure CdvigXClick(Sender: TObject);
    procedure MulXClick(Sender: TObject);
    procedure SdvigYClick(Sender: TObject);
    procedure MulYClick(Sender: TObject);
    procedure KorYClick(Sender: TObject);
    procedure KvadratYClick(Sender: TObject);
    procedure ModulClick(Sender: TObject);
    procedure SummaClick(Sender: TObject);
    procedure LogX1Click(Sender: TObject);
    procedure LogY1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Legengs1Click(Sender: TObject);
    procedure ChartMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ChartMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ChartMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Lines1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure mnSelectActiveClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mnExportClick(Sender: TObject);
    procedure ChartClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure mnIzmeritClick(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure ChartGetLegendText(Sender: TCustomAxisPanel;
      LegendStyle: TLegendStyle; Index: Integer; var LegendText: String);
    procedure ChartClickLegend(Sender: TCustomChart; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
    procedure mnDifferClick(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure RC2Click(Sender: TObject);
    procedure RC1Click(Sender: TObject);
    procedure RC3Click(Sender: TObject);
    procedure ImpRectClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure ChartAfterDraw(Sender: TObject);
    procedure ChartGetAxisLabel(Sender: TChartAxis; Series: TChartSeries;
      ValueIndex: Integer; var LabelText: String);
    procedure mnSpectrClick(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N17Click(Sender: TObject);
    procedure Y1Y1Click(Sender: TObject);
    procedure N18Click(Sender: TObject);
    procedure N19Click(Sender: TObject);
    procedure N20Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    IniDir: String;
    GrNo,ActiveSesia: Integer;
    BeginEdit: boolean;
    NowSeries: TChartSeries;
    NewSeries: TFastLineSeries;
    FileNames: TStringList;
    Dragging:boolean;
    StartX, StopX: Double;
    StartY, StopY: Double;
    BeginX, BeginY: Integer;
    BeginXOld, BeginYOld: Integer;
    Izmerenie: boolean;
    R,C,Kt: double;
    procedure Approx(Seria : TChartSeries; var NewSeries : TFastLineSeries ; N: Integer; Max, Min: double);
    procedure ResizeLegend;
    procedure SaveGRF(FileName : string; Seria  : TChartSeries);
    procedure ShowSRG7(FileName: String);
    procedure OpenFileGRF(FileName: String);
    function CreateNewSerie(Name: string): integer;

  end;

var
  fmChart: TfmChart;

implementation

uses Utillits, ChartSel, ChartOfo, ChartPrO, ChartVal, ChartLeg, ChartLin,
  ChartAbt, ChartRC, ChartSpectr, ChartBackSpectr;

{$R *.DFM}
function TfmChart.CreateNewSerie(Name: string) : Integer;
 var       CurrentSeria: Integer;

begin
      NewSeries:=TFastLineSeries.Create(Self);

      NewSeries.LinePen.Style:=psSolid;
      NewSeries.LinePen.Width:= {Chart.SeriesCount+}1;
      Case Chart.SeriesCount of
            0:  NewSeries.SeriesColor:=clBlack;
            1:  NewSeries.SeriesColor:=clRed ;
            2:  NewSeries.SeriesColor:=clBlue ;
            3:  NewSeries.SeriesColor:=clGreen;
            4:  NewSeries.SeriesColor:=clYellow;
            5:  NewSeries.SeriesColor:=clAqua;
            6:  NewSeries.SeriesColor:=clFuchsia   ;
          end;

      NewSeries.ParentChart:=Chart;
      Chart.Repaint;
      CurrentSeria:=Chart.SeriesCount-1;
ActiveSesia:=CurrentSeria;
       Chart.Series[CurrentSeria].Clear;
       Chart.Series[CurrentSeria].Title:=Name;
       Chart.LeftAxis.Title.Caption :='I, A';
       Chart.BottomAxis.Title.Caption := 't, mc';
       Result:=CurrentSeria;
    FileNames.Add(Name);
    ResizeLegend;
end;
procedure TfmChart.SaveGRF(FileName : string; Seria  : TChartSeries);
 Var I,D,M: Integer;
     F: TextFile;
     St: String;
     X,Y: Double;
begin
      AssignFile(F,FileName);
      Rewrite(F);
      D:=0;
      for I:=0 to Seria.Count-1 do begin
           X:= Seria.XValue[I];
           St:= FloatToStrF(X,ffExponent,15,3);
           M:=StrToInt( Copy(St,Pos('E',St)+1,Length(St)- Pos('E',St)));
           If M>3 then D:=0;
           If M<=3 then D:=(3-M);
           Str(X:5:D,St);
           If X=0 then St:='0.0';
           Write(F, St,' ');

           Y:= Seria.YValue[I];
           St:= FloatToStrF(Y,ffExponent,15,3);
           M:=StrToInt( Copy(St,Pos('E',St)+1,Length(St)- Pos('E',St)));
           If M>3 then D:=0;
           If M<=3 then D:=(3-M);
           Str(Y:5:D,St);
           If Y=0 then St:='0.0';
           Write(F, St,' ');

            Case I+1 of
              1:Write(F,DosFont(Seria.Title));
              2:Write(F,DosFont(Chart.BottomAxis.Title.Caption));
              3:Write(F,DosFont(Chart.LeftAxis.Title.Caption));
              4:if Chart.Foot.Text.Count>0 then
                    Write(F,DosFont(Chart.Foot.Text[0]));
              5:if Chart.Foot.Text.Count>1 then
                     Write(F,DosFont(Chart.Foot.Text[1]));
            end;
           Writeln(F);
        end;
      CloseFile(F);
end;

procedure  TfmChart.ResizeLegend;
  var
      PosTop, HFoot, HLegend: Integer;
begin
     Chart.Legend.TopPos:=10;
     Chart.Repaint;

     HLegend:= (Chart.Legend.RectLegend.Bottom-Chart.Legend.RectLegend.Top);
     HFoot:= Chart.Foot.TitleRect.Bottom-Chart.Foot.TitleRect.Top;

     Chart.BottomAxis.TitleSize:= HLegend+20;

     PosTop:=((Chart.Height-HLegend-Hfoot)*100) div Chart.Height;

     Chart.Legend.TopPos:=PosTop-5;

     Chart.Foot.Visible:= Legend1.Checked ;
//     if not Legend1.Checked then Chart.BottomAxis.TitleSize:=0;

end;

procedure  TfmChart.Approx(Seria : TChartSeries; var NewSeries : TFastLineSeries; N: Integer; Max, Min: double );
var i,j,k: integer;
    Shag, X,Y: double;

begin
     Shag:= (Max-Min)/(N-1);
     K:=0;
     for i:=0 to N-1 do begin
         X:=i*Shag+Min;
         for j:=K to Seria.Count-2 do begin
             if (X < Seria.MinXValue)or(X > Seria.MaxXValue) then  begin
                                          NewSeries.AddXY(X,0,'',NewSeries.SeriesColor);
                                          break;
                                          end;
             if (X>=Seria.XValue[j])and
                (X<=Seria.XValue[j+1]) then begin
                   Y:=(Seria.YValue[j+1]-Seria.YValue[j])*(X-Seria.XValue[j])/
                      (Seria.XValue[j+1]-Seria.XValue[j])+Seria.YValue[j];
                   K:=j;
                   NewSeries.AddXY(X,Y,'',NewSeries.SeriesColor);
                   Break;
                end;
         end;
     end;
end;

procedure TfmChart.FormCreate(Sender: TObject);
   var I : Integer;
begin
   R:=50;
   C:=1e-9;
   GrNo:=1;
    ActiveSesia:=-1;

    for  I:=0 to Chart.SeriesCount-1 do Chart.Series[i].Tag:=1;
    Chart.CancelMouse:=False;

 with TIniFile.Create(ChangeFileExt(ExtractFileName(Application.ExeName),'.INI')) do
    try
     IniDir:=ReadString('Ini','IniDir','C:\');
     SaveD.InitialDir:=IniDir;
     OpenD.InitialDir:=IniDir;
    finally
      Free;
    end;
    FileNames:= TStringList.Create;
    Edit1.Enabled:=Chart.SeriesCount>0;
    mnVid.Enabled:=Edit1.Enabled;
    Label1.Caption:='';

    if ParamCount>0 then
      for I:=1 to ParamCount do begin
        OpenFileGRF(ParamStr(I));
        end;
end;

procedure TfmChart.FormResize(Sender: TObject);
begin
  ResizeLegend;

end;

procedure TfmChart.btnOpenClick(Sender: TObject);
  var F: TextFile;
      St,S, Name: String;
      I, CurrentSeria: Integer;
      X,Y : Double;
      J,Er: Integer;
      Error: boolean;
begin
  if not OpenD.Execute then exit;
   OpenD.InitialDir:=ExtractFilePath(OpenD.FileName);
   SaveD.InitialDir:=ExtractFilePath(OpenD.FileName);
   SaveD.FileName:=ExtractFileName(OpenD.FileName);

  with TIniFile.Create(ChangeFileExt(ExtractFileName(Application.ExeName),'.INI')) do
    try
     WriteString('Ini','IniDir',ExtractFilePath(OpenD.FileName));
    finally
      Free;
    end;
    for J:=0 to  OpenD.Files.Count-1 do begin
        Error:=False;
       AssignFile(F,OpenD.Files[J]);
       Name:= ExtractFileName(OpenD.Files[J]);
       try
         Reset(F);
         except
         MessageDlg('  :'+ Name,mtError,[],0);
         Continue;
         Exit;
         end;
      NewSeries:=TFastLineSeries.Create(Self);

      NewSeries.LinePen.Style:=psSolid;
      NewSeries.LinePen.Width:= {Chart.SeriesCount+}1;
      Case Chart.SeriesCount of
            0:  NewSeries.SeriesColor:=clBlack;
            1:  NewSeries.SeriesColor:=clRed ;
            2:  NewSeries.SeriesColor:=clBlue ;
            3:  NewSeries.SeriesColor:=clGreen;
            4:  NewSeries.SeriesColor:=clYellow;
            5:  NewSeries.SeriesColor:=clAqua;
            6:  NewSeries.SeriesColor:=clFuchsia   ;
          end;

      NewSeries.ParentChart:=Chart;
      Chart.Repaint;
      CurrentSeria:=Chart.SeriesCount-1;

       i:=1;
       Chart.Series[CurrentSeria].Clear;
       Chart.Series[CurrentSeria].Title:=Name;
       Chart.Foot.Text.Clear;
       while (not eof(F)) do  begin
            ReadLn(F,St);
            St:=MinProbel(St);
            if WordCount(St)<2 then continue;
            S:=SelectWord(St,1);
            Val(S,X,Er);
            if er<>0 then  begin
              MessageDlg(' '+S+'   '+inttostr(i)+ '   '+Name,mtError,[mbOk],0);
              Chart.Series[CurrentSeria].Free;
               Error:=True;
               Break;
              end;
            S:=SelectWord(St,2);
            val(S,Y,Er);
            if er<>0 then  begin
              MessageDlg(' '+S+'   '+inttostr(i)+ '   '+Name,mtError,[mbOk],0);
              Chart.Series[CurrentSeria].Free;
               Error:=True;
              Break;
              end;
            with Chart.Series[CurrentSeria] do begin
                AddXY(X,Y,'',Chart.Series[CurrentSeria].SeriesColor);

            end;
           if  i<6 then begin
             S:=SelectWord(St,3);
             if s<>'' then begin
                           delete(St,1,pos(s,st)-1);
                           Case I of
                             1: Chart.Series[CurrentSeria].Title:=WinFont(St);
                             3: Chart.LeftAxis.Title.Caption :=WinFont(St);
                             2: Chart.BottomAxis.Title.Caption :=WinFont(St);
                             4: begin
                                  Chart.Foot.Text.Add(WinFont(St));
                                end;
                             5: begin
                                  Chart.Foot.Text.Add(WinFont(St));
                                end;
                             end;
                           end ;
            end;
            inc(i);
             end;
       CloseFile(F);
        if not Error then FileNames.Add(Name);
       end; //     
    ActiveSesia:=Chart.SeriesCount-1;
    if ActiveSesia>=0 then begin
                    Label1.Caption:='   '+IntToStr(ActiveSesia+1);
                    Label1.Font.Color:=Chart.Series[ActiveSesia].SeriesColor;
                    if Panel2.Color<>Label1.Font.Color then
                     Label1.Color:=Panel2.Color else Label1.Color:=clWhite;
                    end
                      else Label1.Caption:='';
    Edit1.Enabled:=Chart.SeriesCount>0;
    mnVid.Enabled:=Edit1.Enabled;
//    Application.ProcessMessages;
    ResizeLegend;
end;

procedure TfmChart.Delete1Click(Sender: TObject);
begin
   NowSeries.tag:=1;

end;

procedure TfmChart.DeleteAll1Click(Sender: TObject);
begin
   while  Chart.SeriesCount > 0 do
     Chart.Series[0].Free;

     FileNames.Clear;
    Edit1.Enabled:=Chart.SeriesCount>0;
    mnVid.Enabled:=Edit1.Enabled;
   ActiveSesia:=-1;
  Label1.Caption:='';
  BitBtn3Click(nil);
end;

procedure TfmChart.Close1Click(Sender: TObject);
  var I,K : integer;
      Active: boolean;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if (Chart.Series[i].Tag=0) then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:=' ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  K:=0;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then Chart.Series[i].Tag:=1;
     Inc(K);
     end;
// 
  for  I:=0 to Chart.SeriesCount-1 do begin
     if Chart.Series[i].Tag=0 then continue;
     for  K:=I+1 to Chart.SeriesCount-1 do
        If Chart.Series[K].Tag=0 then begin
                                  Chart.Series[i].AssignValues(Chart.Series[K]);
                                  Chart.Series[K].Tag:=1;
                                  Chart.Series[I].Tag:=0;
                                  Chart.Series[I].Title:=Chart.Series[K].Title;
                                  FileNames[i]:=FileNames[K];
                                  if ActiveSesia=K then ActiveSesia:=I;
                                  break;
                                  end;
     end;
//   
   repeat
   for  I:=0 to Chart.SeriesCount-1 do begin
     k:=I;
     if Chart.Series[i].Tag=1 then begin
                                    Chart.Series[i].Free;
                                    FileNames.Delete(i);
                                    break;
                                   end;
   end;
   until K = Chart.SeriesCount;
    if ActiveSesia<0 then ActiveSesia:=Chart.SeriesCount-1;
    if ActiveSesia>(Chart.SeriesCount-1) then ActiveSesia:=Chart.SeriesCount-1;
    Chart.Repaint;
    Edit1.Enabled:=Chart.SeriesCount>0;
    mnVid.Enabled:=Edit1.Enabled;
 if  Chart.SeriesCount>0 then begin
        Label1.Caption:='   '+IntToStr(ActiveSesia+1);
                    Label1.Font.Color:=Chart.Series[ActiveSesia].SeriesColor;
                    if Panel2.Color<>Label1.Font.Color then
                     Label1.Color:=Panel2.Color else Label1.Color:=clWhite;
        end
        else begin
               ActiveSesia:=-1;
               Label1.Caption:='';
             end;
  BitBtn3Click(nil);
    ResizeLegend;
end;

procedure TfmChart.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfmChart.SaveaBitmap1Click(Sender: TObject);
begin
   if not SaveBMP.Execute then exit;
    SaveBMP.InitialDir:=ExtractFilePath(SaveBMP.FileName);
    With TBitmap.Create do begin
    try
      Width := Chart.Width;
      Height:= Chart.Height;
      Chart.Draw(Canvas,Rect(0,0,Chart.Width,Chart.Height));
      SaveToFile(SaveBMP.FileName);
    finally
      Free;
    end;
  end;

end;

procedure TfmChart.CopytoClipboard1Click(Sender: TObject);
begin
 Chart.CopyToClipboardMetafile(True);
end;

procedure TfmChart.SaveaMetafile1Click(Sender: TObject);
begin
  if SaveWMF.Execute then  { <-- ask for a filename first }
  SaveWMF.InitialDir:=ExtractFilePath(SaveWMF.FileName);

    { SAVE IT !! }

{    FORCE CLIPPING WITH METAFILES }
{    CLIPPING WORKS FINE BUT DO NOT ALLOW MOVEABLE OR RESIZEABLE METAFILES }
{    TeeClipWhenMetafiling:=True;}

    Chart.SaveToMetafile(SaveWMF.FileName);

   { THIS METHOD CAN BE USED TOO: }
(*
      Chart1.SaveToMetafileRect( SaveDialog1.FileName,
      Rect( 0,0, round(21{cm}*37.8), round(10{cm}*37.8)));
*)
{   ( this equals to 96 * 21 / 2.54 , 96 * 10 /2.54 )   }
end;

procedure TfmChart.CopytoClipboardBMP1Click(Sender: TObject);
begin
  Chart.CopyToClipboardBitmap;

end;

procedure TfmChart.Titles1Click(Sender: TObject);
begin
  with fmEditComments do begin
    edLeftAxis.Text:=Chart.LeftAxis.Title.Caption;
    edBottomAxis.Text:=Chart.BottomAxis.Title.Caption;
    edTopAxis.Text:=Chart.TopAxis.Title.Caption;
    edRightAxis.Text:=Chart.RightAxis.Title.Caption;
    MemoTitle.Lines.Clear;
    MemoTitle.Lines.Assign(Chart.Title.Text);
    MemoFoot.Lines.Clear;
    MemoFoot.Lines.Assign(Chart.Foot.Text);
    edLeftAngle.Text:=IntToStr(fmChart.Chart.LeftAxis.Title.Angle);
    edRightAngle.Text:=IntToStr(fmChart.Chart.RightAxis.Title.Angle);
    edTopAngle.Text:=IntToStr(fmChart.Chart.TopAxis.Title.Angle);
    edBottomAngle.Text:=IntToStr(fmChart.Chart.BottomAxis.Title.Angle);
  end;

  if fmEditComments.ShowModal <> mrOk then exit;

  with fmEditComments do begin
    Chart.LeftAxis.Title.Caption :=edLeftAxis.Text;
    Chart.BottomAxis.Title.Caption :=edBottomAxis.Text;
    Chart.TopAxis.Title.Caption :=edTopAxis.Text;
    Chart.RightAxis.Title.Caption :=edRightAxis.Text;
    Chart.Title.Text.Clear;
    Chart.Title.Text.Assign(MemoTitle.Lines);
    Chart.Foot.Text.Clear;
    Chart.Foot.Text.Assign(MemoFoot.Lines);
    Chart.LeftAxis.Title.Angle:=StrToInt(edLeftAngle.Text);
    Chart.TopAxis.Title.Angle:=StrToInt(edTopAngle.Text);
    Chart.RightAxis.Title.Angle:=StrToInt(edRightAngle.Text);
    Chart.BottomAxis.Title.Angle:=StrToInt(edBottomAngle.Text);
  end;
    ResizeLegend;

end;
procedure TfmChart.Legend1Click(Sender: TObject);
  var I: Integer;
begin
   Legend1.Checked:= not Legend1.Checked;
   for  I:=0 to Chart.SeriesCount-1 do Chart.Series[i].ShowInLegend:=Legend1.Checked;
   ResizeLegend;
end;

procedure TfmChart.Print1Click(Sender: TObject);
Var tmpH,tmpW,tmpWMargin,tmpHMargin:Longint; { margins }
    OldOrientation:TPrinterOrientation;
    var Divider: Integer;
    OldColor: Tcolor;
begin
  OldColor:= Chart.Legend.Color;
  Chart.Legend.Color:= clWhite;

  Screen.Cursor := crHourGlass;
  OldOrientation:=Printer.Orientation;  { <-- save paper orientation }
       Case fmPrinOptions.RadioGroup2.ItemIndex of
        0:  Printer.Orientation:=poPortrait;
        1:  Printer.Orientation:=poLandscape;
      end;
    try
    Printer.BeginDoc;       { <-- start printer job }
    try
      Printer.Title:=' ';
         Divider:= 1;
      Case fmPrinOptions.RadioGroup3.ItemIndex of
         0:  Divider:= 2;
         1:  Divider:= 1;
        end;
      Case fmPrinOptions.RadioGroup1.ItemIndex of
        0: { screen proportional }
             Chart.PrintResolution:= 0;
        1: { thin lines and small fonts }
             Chart.PrintResolution:= -100;
      end;

      { CALCULATE HORIZONTAL MARGIN }
      tmpW:=Printer.PageWidth;
      tmpWMargin:=Round(5.0*tmpW/100.0); { <-- 5% margins }
      tmpW:=tmpW-2*tmpWMargin;  { <-- left and right margins }

      { CALCULATE VERTICAL MARGIN }
      tmpH:=Printer.PageHeight;
      tmpHMargin:=Round(5.0*tmpH/100.0);  { <-- 5% margins }
      tmpH:=tmpH-2*tmpHMargin;  { <-- bottom and top margins }
      tmpH:=tmpH DIV Divider;  { <-- bottom and top margins }

      { }
      Chart.PrintPartial( Rect( tmpWMargin,tmpHMargin,
                                 tmpWMargin+tmpW,tmpHMargin+tmpH ) );

      Printer.EndDoc; { <-- end job and print !! }
    except
      on Exception do  { just in case an error happens... }
      Begin
        Printer.Abort;
        Printer.EndDoc;
        Raise;
      end;
    end;
  finally
    Printer.Orientation:=OldOrientation;  { <-- restore paper orientation }
    Screen.Cursor:=crDefault; { <-- restore cursor }
    Chart.Legend.Color:= OldColor;
  end;
end;

procedure TfmChart.PrintOption1Click(Sender: TObject);
begin
  fmPrinOptions.ShowModal;
end;

procedure TfmChart.Fon1Click(Sender: TObject);
begin
  If ColorD.Execute then Chart.Color:=ColorD.Color;
  Chart.Legend.Color:= Chart.Color;
end;

procedure TfmChart.CdvigXClick(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
      Value: Double;
  Label 1;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='   ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  fmValue.Caption:='  ';
1: if fmValue.ShowModal<>mrOk then exit;
  Value:=0;
  Active:=True;
  try  Value:=StrToFloat(fmValue.edValue.Text);
  except
     MessageDlg('   ',mtError,[mbOk],0);
     Active:=False;
  end;
   if not Active then   GoTo 1;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       // 
       For J:=0 to Chart.Series[i].Count-1 do
           Chart.Series[i].XValue[J]:=Chart.Series[i].XValue[J]+ Value;
     end;
       Inc(K);
   end;
end;

procedure TfmChart.MulXClick(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
      Value: Double;
  Label 1;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='   ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  fmValue.Caption:='  ';
1: if fmValue.ShowModal<>mrOk then exit;
  Value:=0;
  Active:=True;
  try  Value:=StrToFloat(fmValue.edValue.Text);
  except
     MessageDlg('   ',mtError,[mbOk],0);
     Active:=False;
  end;
   if not Active then   GoTo 1;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       // 
       For J:=0 to Chart.Series[i].Count-1 do
           Chart.Series[i].XValue[J]:=Chart.Series[i].XValue[J]*Value;
     end;
       Inc(K);
   end;

end;

procedure TfmChart.SdvigYClick(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
      Value: Double;
  Label 1;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='   ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  fmValue.Caption:='  ';
1: if fmValue.ShowModal<>mrOk then exit;
  Value:=0;
  Active:=True;
  try  Value:=StrToFloat(fmValue.edValue.Text);
  except
     MessageDlg('   ',mtError,[mbOk],0);
     Active:=False;
  end;
   if not Active then   GoTo 1;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       // 
       For J:=0 to Chart.Series[i].Count-1 do
           Chart.Series[i].YValue[J]:=Chart.Series[i].YValue[J]+ Value;
     end;
       Inc(K);
   end;

end;

procedure TfmChart.MulYClick(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
      Value: Double;
  Label 1;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='   ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  fmValue.Caption:='  ';
1: if fmValue.ShowModal<>mrOk then exit;
  Value:=0;
  Active:=True;
  try  Value:=StrToFloat(fmValue.edValue.Text);
  except
     MessageDlg('   ',mtError,[mbOk],0);
     Active:=False;
  end;
   if not Active then   GoTo 1;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       // 
       For J:=0 to Chart.Series[i].Count-1 do
           Chart.Series[i].YValue[J]:=Chart.Series[i].YValue[J]*Value;
     end;
       Inc(K);
   end;

end;

procedure TfmChart.KorYClick(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='    ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       //  
       For J:=0 to Chart.Series[i].Count-1 do begin
           Chart.Series[i].YValue[J]:= abs(Chart.Series[i].YValue[J]);
           Chart.Series[i].YValue[J]:=Sqrt(Chart.Series[i].YValue[J]);
           end;
     end;
       Inc(K);
   end;


end;

procedure TfmChart.KvadratYClick(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='    ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       // 
       For J:=0 to Chart.Series[i].Count-1 do begin
           Chart.Series[i].YValue[J]:=Sqr(Chart.Series[i].YValue[J]);
           end;
     end;
       Inc(K);
   end;

end;

procedure TfmChart.ModulClick(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='    ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       //
       For J:=0 to Chart.Series[i].Count-1 do begin
           Chart.Series[i].YValue[J]:= abs(Chart.Series[i].YValue[J]);
           end;
     end;
       Inc(K);
   end;

end;

procedure TfmChart.SummaClick(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
    Shag, X,Y: double;
    N: Integer;


begin
  Chart.UndoZoom;
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='   ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  //     
  K:=0;
  N:=0;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then
     begin
     If fmSelectGr.ListBox1.Selected[K] then
          if Chart.Series[i].Count > N then N:=Chart.Series[i].Count;
       Inc(K);
   end;

    //     
  K:=0;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
           NewSeries:=TFastLineSeries.Create(Self);
           NewSeries.ParentChart:=Chart;
           Approx(Chart.Series[i],NewSeries, N,Chart.MaxXValue(Chart.BottomAxis),Chart.MinXValue(Chart.BottomAxis));
           Chart.Series[Chart.SeriesCount-1].Title:='.';
           Chart.Series[Chart.SeriesCount-1].Tag:=1;
          Chart.Series[Chart.SeriesCount-1].Tag:=0;
     end;
       Inc(K);
   end;
   // 

     Shag:= (Chart.MaxXValue(Chart.BottomAxis)-Chart.MinXValue(Chart.BottomAxis))/(N-1);
      NewSeries:=TFastLineSeries.Create(Self);
    For J:=0 to N-1 do begin
      Y:=0;
      X:=J*Shag+Chart.MinXValue(Chart.BottomAxis);
      for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Title='.' then begin
           Y:=Y+ Chart.Series[i].YValue[J];
           end;
      NewSeries.AddXY(X,Y,'',NewSeries.SeriesColor);
      end;
    //  
     Repeat
      for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Title='.'
              then  begin Chart.Series[i].Free; break; end;
      until I>=Chart.SeriesCount;


    NewSeries.ParentChart:=Chart;
    Chart.Series[Chart.SeriesCount-1].Title:='';
    FileNames.Add(' -'+ IntToStr(GrNo));
    inc(GrNo);
    ResizeLegend;
end;

procedure TfmChart.LogX1Click(Sender: TObject);
begin
       LogX1.Checked:= not LogX1.Checked;
       try
         Chart.BottomAxis. Logarithmic :=  LogX1.Checked;
        except
         LogX1.Checked:= False;
        end;
end;

procedure TfmChart.LogY1Click(Sender: TObject);
begin
       LogY1.Checked:= not LogY1.Checked;
       try
         Chart.LeftAxis. Logarithmic :=  LogY1.Checked;
        except
         LogY1.Checked:= False;
        end;

end;

procedure TfmChart.Save1Click(Sender: TObject);
  var I,K : integer;
      Active: boolean;
      FName: String;
      label 1;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:=' ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  K:=0;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
        FName:= Chart.Series[I].Title;
//        If Length(FName)>30 then FName:=Copy(FName,1,30);
        SaveD.FileName := FileNames[I];
1:        If SaveD.Execute then  begin
             if FileExists(SaveD.FileName) then
               if MessageDlg(' '+SaveD.FileName+ '  . ?',
                  mtConfirmation, [mbYes,mbNo],0) <> mrYes then goto 1;

                  SaveD.InitialDir:=ExtractFilePath(SaveD.FileName);
                  SaveGRF(SaveD.FileName,Chart.Series[I]);
                  FileNames[I]:=SaveD.FileName;
                  with TIniFile.Create
                       (ChangeFileExt(ExtractFileName(Application.ExeName),
                       '.INI')) do
                   try
                    WriteString('Ini','IniDir',ExtractFilePath(SaveD.FileName));
                   finally
                   Free;
    end;
                  end;
       end;
     Inc(K);
     end;

end;

procedure TfmChart.Legengs1Click(Sender: TObject);
  var I,K : integer;
      Active: boolean;
begin
   if ActiveSesia<0 then exit;
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmLegend.Caption:=' ';
  fmLegend.Enter;
  if fmLegend.ModalResult<>mrOk then exit;
  K:=0;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
            Chart.Series[i].Title:=fmLegend.Memo1.Lines[K];
            Inc(K);
     end;
  ResizeLegend;

end;

procedure TfmChart.ChartMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var I: Integer;
      YValue: Double;
      ValueY, ValueX: Double;
begin
     Chart.CancelMouse:=btnEdit.Down;
   if ActiveSesia<0 then exit;
 //  
    If Dragging then
       begin
      // Chart.Canvas.Pen.Style:=psDash;
       Chart.Canvas.Pen.Mode:=pmNotXor;
       Chart.Canvas.MoveTo(BeginX,BeginY);
       Chart.Canvas.LineTo(BeginXOld,BeginYOld);
       Chart.Canvas.MoveTo(BeginX,BeginY);
       Chart.Canvas.LineTo(X, Y);
       BeginXOld:=X;
       BeginYOld:=Y;
       end;

   lbCoopd.Caption:= 'X: '+FloatToStrF(Chart.BottomAxis.CalcPosPoint(X),ffGeneral,3,2)
     +'  /  Y:  ' +FloatToStrF(Chart.LeftAxis.CalcPosPoint(Y),ffGeneral,3,2);

   if  BeginEdit then begin
      YValue:=Chart.LeftAxis.CalcPosPoint(Y);
      Chart.CancelMouse:=True;
    for I:=0 to Chart.Series[ActiveSesia].Count-1 do begin
           if Chart.Series[ActiveSesia].CalcXPosValue(Chart.Series[ActiveSesia].XValue[i]) = X
             then  Chart.Series[ActiveSesia].YValue[i]:=YValue;
           end;
   end;
   if Izmerenie then begin
       Chart.Canvas.Pen.Mode:=pmNotXor;
       Chart.Canvas.MoveTo(BeginX,BeginY);
       Chart.Canvas.LineTo(BeginXOld,BeginYOld);
       Chart.Canvas.MoveTo(BeginX,BeginY);
       Chart.Canvas.LineTo(X, Y);
       BeginXOld:=X;
       BeginYOld:=Y;
                      StopX:=Chart.BottomAxis.CalcPosPoint (X) ;
                      StopY:=Chart.LeftAxis.CalcPosPoint (Y) ;
                      ValueX:= StopX - StartX;
                      ValueY:= StopY - StartY;
         lbCoopd.Caption:= 'dX: '+FloatToStrF(ValueX,ffGeneral,3,2)
                   +'  /  dY:  ' +FloatToStrF(ValueY,ffGeneral,3,2);
       end;

end;

procedure TfmChart.ChartMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var I: Integer;
      YValue: Double;
begin
     BeginX:=X;
     BeginY:=Y;
     BeginXOld:=X;
     BeginYOld:=Y;
     Izmerenie:=False;
     Chart.CancelMouse:=btnEdit.Down;
     if ActiveSesia<0 then exit;

if PtInRect( Chart.Legend.RectLegend, Point( x,y ) ) then
   begin  //  
//     Messagebeep(0);
   end;

if not PtInRect( Chart.ChartRect, Point( x,y ) ) then exit;

     if  (btnEdit.Down)and(not ( ssCtrl in Shift)) then
        begin
         BeginEdit:=True;
         YValue:=Chart.LeftAxis.CalcPosPoint(Y);
          for I:=0 to Chart.Series[ActiveSesia].Count-1 do begin
             if Chart.Series[ActiveSesia].CalcXPosValue(Chart.Series[ActiveSesia].XValue[i]) = X
             then  Chart.Series[ActiveSesia].YValue[i]:=YValue;
              end;
        end else
         if ssShift in Shift then
          begin //    
            Chart.CancelMouse:=True;
            Dragging:=True;
            StartX:=Chart.BottomAxis.CalcPosPoint (X) ;
            StartY:=Chart.LeftAxis.CalcPosPoint (Y) ;
        end else
         if ssAlt in Shift then
          begin // 
            Chart.CancelMouse:=True;
            Izmerenie:=True;
            StartX:=Chart.BottomAxis.CalcPosPoint (X) ;
            StartY:=Chart.LeftAxis.CalcPosPoint (Y) ;
          end;
end;

procedure TfmChart.ChartMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var J: Integer;
      ValueX,ValueY: double;
begin
    if Izmerenie then begin
                      Izmerenie:=False;
                      Chart.Canvas.Pen.Mode:=pmNotXor;
                      Chart.Canvas.MoveTo(BeginX,BeginY);
                      Chart.Canvas.LineTo(BeginXOld,BeginYOld);
                      end;
     Chart.CancelMouse:= btnEdit.Down;
     if ActiveSesia<0 then exit;
    if Dragging then
        begin
        // 

           if ssShift in Shift then
             begin
             Chart.CancelMouse:=True;
             StopX:=Chart.BottomAxis.CalcPosPoint (X) ;
             StopY:=Chart.LeftAxis.CalcPosPoint (Y) ;
             ValueX:= StopX - StartX;
             ValueY:= StopY - StartY;
             For J:=0 to Chart.Series[ActiveSesia].Count-1 do
               begin
               Chart.Series[ActiveSesia].XValue[J]:=Chart.Series[ActiveSesia].XValue[J]+ ValueX;
               Chart.Series[ActiveSesia].YValue[J]:=Chart.Series[ActiveSesia].YValue[J]+ ValueY;
               end;
             end;
        end;

     BeginEdit:=False;
     Dragging:=False;
end;

procedure TfmChart.BitBtn1Click(Sender: TObject);
begin
  BitBtn1.Enabled:=False;
  BitBtn2.Enabled:=False;
  Chart.ZoomPercent(115);
  BitBtn1.Enabled:=True;
  BitBtn2.Enabled:=True;
end;

procedure TfmChart.BitBtn2Click(Sender: TObject);
begin
  BitBtn1.Enabled:=False;
  BitBtn2.Enabled:=False;
  Chart.ZoomPercent(85);
  BitBtn1.Enabled:=True;
  BitBtn2.Enabled:=True;
end;


procedure TfmChart.BitBtn3Click(Sender: TObject);
begin
  Chart.UndoZoom;
end;

procedure TfmChart.Lines1Click(Sender: TObject);
begin
  fmLines.Enter;
end;

procedure TfmChart.About1Click(Sender: TObject);
begin
  fmAboutChart.ShowModal;
end;

procedure TfmChart.File1Click(Sender: TObject);
begin
 if Chart.SeriesCount=0
   then
     begin
       Save1.Enabled:=False;
       Close1.Enabled:=Save1.Enabled;
       CloseAll1.Enabled:=Save1.Enabled;
       SaveaBitmap1.Enabled:=Save1.Enabled;
       CopytoClipboardBMP1.Enabled:=Save1.Enabled;
       SaveaMetafile1.Enabled:=Save1.Enabled;
       CopytoClipboard1.Enabled:=Save1.Enabled;
       Print1.Enabled:=Save1.Enabled;
     end
   else
     begin
       Save1.Enabled:=True;
       Close1.Enabled:=Save1.Enabled;
       CloseAll1.Enabled:=Save1.Enabled;
       SaveaBitmap1.Enabled:=Save1.Enabled;
       CopytoClipboardBMP1.Enabled:=Save1.Enabled;
       SaveaMetafile1.Enabled:=Save1.Enabled;
       CopytoClipboard1.Enabled:=Save1.Enabled;
       Print1.Enabled:=Save1.Enabled;
     end;
end;

procedure TfmChart.mnSelectActiveClick(Sender: TObject);
  var I: integer;
begin
  fmSelectGr.Caption:='  ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
     for I:=0 to fmSelectGr.ListBox1.Items.Count-1 do
            if fmSelectGr.ListBox1.Selected[I] then  ActiveSesia:=I;
  Label1.Caption:='   '+IntToStr(ActiveSesia+1);
                    Label1.Font.Color:=Chart.Series[ActiveSesia].SeriesColor;
                    if Panel2.Color<>Label1.Font.Color then
                     Label1.Color:=Panel2.Color else Label1.Color:=clWhite;
end;

procedure TfmChart.ShowSRG7(FileName: String);
  var F: TextFile;
      St,S, Name: String;
      I, CurrentSeria: Integer;
      X,Y : Double;
      Er: Integer;

begin
       AssignFile(F,FileName);
       Name:= ExtractFileName(FileName);
       try
         Reset(F);
         except
         MessageDlg('  :'+ Name,mtError,[],0);
         Exit;
         end;
      NewSeries:=TFastLineSeries.Create(Self);

      NewSeries.LinePen.Style:=psSolid;
      NewSeries.LinePen.Width:= {Chart.SeriesCount+}1;
      Case Chart.SeriesCount of
            0:  NewSeries.SeriesColor:=clBlack;
            1:  NewSeries.SeriesColor:=clRed ;
            2:  NewSeries.SeriesColor:=clBlue ;
            3:  NewSeries.SeriesColor:=clGreen;
            4:  NewSeries.SeriesColor:=clYellow;
            5:  NewSeries.SeriesColor:=clAqua;
            6:  NewSeries.SeriesColor:=clFuchsia   ;
          end;

      NewSeries.ParentChart:=Chart;
      CurrentSeria:=Chart.SeriesCount-1;

       i:=1;
       Chart.Series[CurrentSeria].Clear;
       Chart.Series[CurrentSeria].Title:=Name;
       Chart.Foot.Text.Clear;
       while (not eof(F)) do  begin
            ReadLn(F,St);
            St:=MinProbel(St);
            if WordCount(St)<2 then continue;
            S:=SelectWord(St,1);
            Val(S,X,Er);
            if er<>0 then  begin
              MessageDlg(' '+S+'   '+inttostr(i)+ '   '+Name,mtError,[mbOk],0);
              Chart.Series[CurrentSeria].Free;
              CloseFile(F);
              Exit;
              end;
            S:=SelectWord(St,2);
            val(S,Y,Er);
            if er<>0 then  begin
              MessageDlg(' '+S+'   '+inttostr(i)+ '   '+Name,mtError,[mbOk],0);
              Chart.Series[CurrentSeria].Free;
              CloseFile(F);
              Exit;
              end;
            with Chart.Series[CurrentSeria] do begin
                AddXY(X,Y,'',Chart.Series[CurrentSeria].SeriesColor);

            end;
           if  i<6 then begin
             S:=SelectWord(St,3);
             if s<>'' then begin
                           delete(St,1,pos(s,st)-1);
                           Case I of
                             1: Chart.Series[CurrentSeria].Title:=St;
                             3: Chart.LeftAxis.Title.Caption :=St;
                             2: Chart.BottomAxis.Title.Caption :=St;
                             4: begin
                                  Chart.Foot.Text.Add(St);
                                end;
                             5: begin
                                  Chart.Foot.Text.Add(St);
                                end;
                             end;
                           end ;
            end;
            inc(i);
             end;
       CloseFile(F);
       FileNames.Add(' -'+ IntToStr(GrNo));
       inc(GrNo);

    ActiveSesia:=Chart.SeriesCount-1;
    if ActiveSesia>=0 then begin
                    Label1.Caption:='   '+IntToStr(ActiveSesia+1);
                    Label1.Font.Color:=Chart.Series[ActiveSesia].SeriesColor;
                    if Panel2.Color<>Label1.Font.Color then
                     Label1.Color:=Panel2.Color else Label1.Color:=clWhite;
                 end
                      else Label1.Caption:='';
    Edit1.Enabled:=Chart.SeriesCount>0;
    mnVid.Enabled:=Edit1.Enabled;
    ResizeLegend;
end;

procedure TfmChart.FormShow(Sender: TObject);
begin
// fmMain.mnShowChart.Checked:=true;
end;

procedure TfmChart.mnExportClick(Sender: TObject);
  var SGPath, FullName: String;
      CommandLine :PChar;
      StartString: String;
       I: Integer;
begin
   SGPath:= ExtractFilePath(Application.ExeName);
   FullName:=SGPath+'SG.exe';
   if not FileExists(FullName) then
                                begin
                                ShowMessage(' '+FullName+#13#10+'  !!!');
                                Exit;
                                end;

   StartString:=FullName;

  for  I:=0 to Chart.SeriesCount-1 do
      begin
      SaveGRF('~00'+IntToStr(I),Chart.Series[I]);
      StartString:=StartString+' ~00'+IntToStr(I);
     end;

   CommandLine:=PChar(StartString);
      if WinExec(CommandLine,SW_SHOW) <= 31 then
             raise Exception.Create('   '+FullName);
end;

procedure TfmChart.ChartClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var I: Integer;
begin
    if ssCtrl in Shift then
     begin
         for  I:=0 to Chart.SeriesCount-1 do
           if  Chart.Series[i] = Series then
                      begin
                        ActiveSesia:=I;
                        Label1.Caption:='   '+IntToStr(ActiveSesia+1);
                        Label1.Font.Color:=Chart.Series[ActiveSesia].SeriesColor;
                        if Panel2.Color<>Label1.Font.Color then
                        Label1.Color:=Panel2.Color else Label1.Color:=clWhite;

                      end;
          MessageBeep(0);
     end;
end;

procedure TfmChart.mnIzmeritClick(Sender: TObject);
 var j, X, Y: Integer;
     Max, Min: Double;
     t10,t50begin,t50end,t90: Double;
     y10,y50begin,y50end,y90: Double;
     FindT10,FindT90,FindT50begin,FindT50end : boolean;
     Rect: TRect;
     ChartRect : TRect;
     Ampl: Double;
     RezIzm: String;
begin
 if (Sender is tMenuItem) then SpeedButton4.Down:=not SpeedButton4.Down;
      if (Sender <> nil) then begin
          Chart.Repaint;
          exit;
          end;
 if not SpeedButton4.Down then exit;

   RezIzm:='';
   Ampl:=0;
     t10:=0; t50begin:=0; t50end:=0; t90:=0;
     y10:=0; y50begin:=0; y50end:=0; y90:=0;

  if Chart.SeriesCount = 0 then exit;
  if ActiveSesia < 0 then exit;
  if ActiveSesia > (Chart.SeriesCount-1) then exit;
//   
   ChartRect := Chart.ChartRect; //   
   FindT10:=False;
   FindT50begin:=False;
   FindT50end:=False;
   FindT90:=False;
   Max:= Chart.Series[ActiveSesia].MaxYValue;
   Min:= Chart.Series[ActiveSesia].MinYValue;
   Chart.Canvas.Font.Color:=clBlue;

   if abs(Max)>abs(Min) then begin

   Y:= Chart.Series[ActiveSesia].CalcYPosValue(Max);
   Chart.Canvas.Pen.Color:= clBlue;
   Chart.Canvas.Pen.Width:= 1;
   Chart.Canvas.MoveTo(ChartRect.Left,Y);
   Chart.Canvas.LineTo(ChartRect.Right,Y);
  // Chart.Canvas.TextOut(ChartRect.Left,
  //                      Y-Chart.Canvas.TextHeight(''),
  //                      ' = '+FloatToStrF(Max,ffFixed,5,2));
   Ampl:=Max;
   if Chart.Series[ActiveSesia].YValue[0] <= (Max/10) then
     For J:=0 to Chart.Series[ActiveSesia].Count-1 do
       begin

        if not FindT10 then begin
           if Chart.Series[ActiveSesia].YValue[J] >= (Max/10)
             then begin
              t10:=
               ( Chart.Series[ActiveSesia].XValue[J]-Chart.Series[ActiveSesia].XValue[J-1])
               *( Max/10-Chart.Series[ActiveSesia].YValue[J-1])
               /(Chart.Series[ActiveSesia].YValue[J]-Chart.Series[ActiveSesia].YValue[J-1])
               +Chart.Series[ActiveSesia].XValue[J-1];

                  Chart.Series[ActiveSesia].XValue[J];
                  y10:=Max/10;
                  FindT10:=True;
                  end;
             end;

        if FindT10 then
         if not FindT50begin then begin
           if Chart.Series[ActiveSesia].YValue[J] >= (Max/2)
             then begin
                  t50begin:=
               ( Chart.Series[ActiveSesia].XValue[J]-Chart.Series[ActiveSesia].XValue[J-1])
               *( Max/2-Chart.Series[ActiveSesia].YValue[J-1])
               /(Chart.Series[ActiveSesia].YValue[J]-Chart.Series[ActiveSesia].YValue[J-1])
               +Chart.Series[ActiveSesia].XValue[J-1];

                  y50begin:=Max/2;
                  FindT50begin:=True;
                  end;
             end;

        if FindT50begin then
         if not FindT90 then begin
           if Chart.Series[ActiveSesia].YValue[J] >= (Max*9/10)
             then begin
                  t90:=
               ( Chart.Series[ActiveSesia].XValue[J]-Chart.Series[ActiveSesia].XValue[J-1])
               *( Max*9/10-Chart.Series[ActiveSesia].YValue[J-1])
               /(Chart.Series[ActiveSesia].YValue[J]-Chart.Series[ActiveSesia].YValue[J-1])
               +Chart.Series[ActiveSesia].XValue[J-1];

                  y90:=Max*9/10;
                  FindT90:=True;
                  end;
             end;

        if FindT90 then
         if not FindT50end then begin
           if Chart.Series[ActiveSesia].YValue[J] <= (Max/2)
             then begin
                  t50end:=
               ( Chart.Series[ActiveSesia].XValue[J]-Chart.Series[ActiveSesia].XValue[J-1])
               *( Max/2-Chart.Series[ActiveSesia].YValue[J-1])
               /(Chart.Series[ActiveSesia].YValue[J]-Chart.Series[ActiveSesia].YValue[J-1])
               +Chart.Series[ActiveSesia].XValue[J-1];
                  y50end:=Max/2;
                  FindT50end:=True;
                  break;
                  end;
             end;

         end;
     end;
   if abs(Max)<abs(Min) then begin
   Y:= Chart.Series[ActiveSesia].CalcYPosValue(Min);
   Chart.Canvas.Pen.Color:= clBlue;
   Chart.Canvas.Pen.Color:= clBlue;
   Chart.Canvas.Pen.Width:= 1;
   Chart.Canvas.MoveTo(ChartRect.Left,Y);
   Chart.Canvas.LineTo(ChartRect.Right,Y);
 //  Chart.Canvas.TextOut(ChartRect.Left,Y-Chart.Canvas.TextHeight(''),
 //                       ' = '+FloatToStrF(Min,ffFixed,5,2));
       Ampl:=Min;

    if Chart.Series[ActiveSesia].YValue[0] >= (Min/10) then
     For J:=0 to Chart.Series[ActiveSesia].Count-1 do
       begin

        if not FindT10 then begin
           if Chart.Series[ActiveSesia].YValue[J] <= (Min/10)
             then begin
                  t10:=
               ( Chart.Series[ActiveSesia].XValue[J]-Chart.Series[ActiveSesia].XValue[J-1])
               *( Min/10-Chart.Series[ActiveSesia].YValue[J-1])
               /(Chart.Series[ActiveSesia].YValue[J]-Chart.Series[ActiveSesia].YValue[J-1])
               +Chart.Series[ActiveSesia].XValue[J-1];

                  y10:=Min/10;
                  FindT10:=True;
                  end;
             end;

        if FindT10 then
         if not FindT50begin then begin
           if Chart.Series[ActiveSesia].YValue[J] <= (Min/2)
             then begin
                  t50begin:=
               ( Chart.Series[ActiveSesia].XValue[J]-Chart.Series[ActiveSesia].XValue[J-1])
               *( Min/2-Chart.Series[ActiveSesia].YValue[J-1])
               /(Chart.Series[ActiveSesia].YValue[J]-Chart.Series[ActiveSesia].YValue[J-1])
               +Chart.Series[ActiveSesia].XValue[J-1];

                  y50begin:=Min/2;
                  FindT50begin:=True;
                  end;
             end;

        if FindT50begin then
         if not FindT90 then begin
           if Chart.Series[ActiveSesia].YValue[J] <= (Min*9/10)
             then begin
                  t90:=
               ( Chart.Series[ActiveSesia].XValue[J]-Chart.Series[ActiveSesia].XValue[J-1])
               *( Min*9/10-Chart.Series[ActiveSesia].YValue[J-1])
               /(Chart.Series[ActiveSesia].YValue[J]-Chart.Series[ActiveSesia].YValue[J-1])
               +Chart.Series[ActiveSesia].XValue[J-1];

                  y90:=Min*9/10;
                  FindT90:=True;
                  end;
             end;

        if FindT90 then
         if not FindT50end then begin
           if Chart.Series[ActiveSesia].YValue[J] >= (Min/2)
             then begin
                  t50end:=
               ( Chart.Series[ActiveSesia].XValue[J]-Chart.Series[ActiveSesia].XValue[J-1])
               *( Min/2-Chart.Series[ActiveSesia].YValue[J-1])
               /(Chart.Series[ActiveSesia].YValue[J]-Chart.Series[ActiveSesia].YValue[J-1])
               +Chart.Series[ActiveSesia].XValue[J-1];

                  y50end:=Min/2;
                  FindT50end:=True;
                  break;
                  end;
             end;

        end;
     end;

     RezIzm:= 'A = '+FloatToStrF(Ampl,ffGeneral,3,2);

   if FindT90 then begin

  //  Chart.Canvas.TextOut(0,0,'. . = '+FloatToStrF(T90-T10,ffFixed,5,2));
    RezIzm:=RezIzm  + '; T = '+FloatToStrF(T90-T10,ffGeneral,3,2);
    Chart.Canvas.Pen.Color:= clBlue;
    Chart.Canvas.Pen.Width:= 1;

    X:= Chart.Series[ActiveSesia].CalcXPosValue(T10);
    Y:= Chart.Series[ActiveSesia].CalcYPosValue(y10);
    Chart.Canvas.MoveTo(ChartRect.Left,Y);
    Chart.Canvas.LineTo(ChartRect.Right,Y);
    Chart.Canvas.MoveTo(X,ChartRect.Top);
    Chart.Canvas.LineTo(X,ChartRect.Bottom);

    X:= Chart.Series[ActiveSesia].CalcXPosValue(T90);
    Y:= Chart.Series[ActiveSesia].CalcYPosValue(y90);
    Chart.Canvas.MoveTo(ChartRect.Left,Y);
    Chart.Canvas.LineTo(ChartRect.Right,Y);
    Chart.Canvas.MoveTo(X,ChartRect.Top);
    Chart.Canvas.LineTo(X,ChartRect.Bottom);
   end;
   if FindT50end then begin

    Chart.Canvas.Pen.Color:= clRed;
    Chart.Canvas.Pen.Width:= 1;

   Y:= Chart.Series[ActiveSesia].CalcYPosValue(y50begin);
   X:= Chart.Series[ActiveSesia].CalcXPosValue(t50begin);
//   Chart.Canvas.TextOut(X,Y-Chart.Canvas.TextHeight(''),
//                        '. . = '+FloatToStrF(t50end-t50begin,ffFixed,5,2));

    RezIzm:=RezIzm  + '; T = '+ FloatToStrF(t50end-t50begin,ffGeneral,3,2);

    Chart.Canvas.MoveTo(X,Y);
    Y:= Chart.Series[ActiveSesia].CalcYPosValue(y50end);
    X:= Chart.Series[ActiveSesia].CalcXPosValue(t50end);
    Chart.Canvas.LineTo(X,Y);
   end;
   Chart.Canvas.Font.Name:='Arial';
   Chart.Canvas.Font.Height:=14;
   Chart.Canvas.TextOut(ChartRect.Left,1,RezIzm);
end;

procedure TfmChart.N11Click(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='   ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       //
       For J:=0 to Chart.Series[i].Count-1 do begin
           Chart.Series[i].YValue[J]:= (Chart.Series[i].YValue[J]) * (-1);
           end;
     end;
       Inc(K);
   end;


end;

procedure TfmChart.SpeedButton5Click(Sender: TObject);
begin
 ResizeLegend;
end;

procedure TfmChart.ChartGetLegendText(Sender: TCustomAxisPanel;
  LegendStyle: TLegendStyle; Index: Integer; var LegendText: String);
begin
    LegendText:= IntToStr(Index+1)+'. '+LegendText;

end;

procedure TfmChart.ChartClickLegend(Sender: TCustomChart;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

  var YOtn: Integer;
       StrH: Integer;
       ItemNo, I: Integer;

begin
  YOtn:=Y - Chart.Legend.RectLegend.Top;
  StrH:=(Chart.Legend.RectLegend.Bottom-Chart.Legend.RectLegend.Top) div Chart.SeriesCount;
  ItemNo:= YOtn div StrH;
  ActiveSesia:=ItemNo;
  if  ActiveSesia>(Chart.SeriesCount-1)then ActiveSesia:=(Chart.SeriesCount-1);
   Label1.Caption:='   '+IntToStr(ActiveSesia+1);
                    Label1.Font.Color:=Chart.Series[ActiveSesia].SeriesColor;
                    if Panel2.Color<>Label1.Font.Color then
                     Label1.Color:=Panel2.Color else Label1.Color:=clWhite;
//  Chart.Legend.FirstValue:=ActiveSesia;
  for  I:=0 to Chart.SeriesCount-1 do  begin
     TFastLineSeries(fmChart.Chart.Series[I]).LinePen.Width:=1;
     end;
  TFastLineSeries(fmChart.Chart.Series[ActiveSesia]).LinePen.Width:=2;
  ResizeLegend;
end;

procedure TfmChart.FormActivate(Sender: TObject);
begin
    Edit1.Enabled:=Chart.SeriesCount>0;
    mnVid.Enabled:=Edit1.Enabled;
    ResizeLegend;

end;
  //###0,#######
procedure TfmChart.OpenFileGRF(FileName: String);
  var F: TextFile;
      St,S, Name: String;
      I, CurrentSeria: Integer;
      X,Y : Double;
      Er: Integer;

begin
       AssignFile(F,FileName);
       Name:= ExtractFileName(FileName);
       try
         Reset(F);
         except
         MessageDlg('  :'+ Name,mtError,[],0);
         Exit;
         end;
      NewSeries:=TFastLineSeries.Create(Self);

      NewSeries.LinePen.Style:=psSolid;
      NewSeries.LinePen.Width:= {Chart.SeriesCount+}1;
      Case Chart.SeriesCount of
            0:  NewSeries.SeriesColor:=clBlack;
            1:  NewSeries.SeriesColor:=clRed ;
            2:  NewSeries.SeriesColor:=clBlue ;
            3:  NewSeries.SeriesColor:=clGreen;
            4:  NewSeries.SeriesColor:=clYellow;
            5:  NewSeries.SeriesColor:=clAqua;
            6:  NewSeries.SeriesColor:=clFuchsia   ;
          end;

      NewSeries.ParentChart:=Chart;
      CurrentSeria:=Chart.SeriesCount-1;

       i:=1;
       Chart.Series[CurrentSeria].Clear;
       Chart.Series[CurrentSeria].Title:=Name;
       Chart.Foot.Text.Clear;
       while (not eof(F)) do  begin
            ReadLn(F,St);
            St:=MinProbel(St);
            if WordCount(St)<2 then continue;
            S:=SelectWord(St,1);
            Val(S,X,Er);
            if er<>0 then  begin
              MessageDlg(' '+S+'   '+inttostr(i)+ '   '+Name,mtError,[mbOk],0);
              Chart.Series[CurrentSeria].Free;
              CloseFile(F);
              Exit;
              end;
            S:=SelectWord(St,2);
            val(S,Y,Er);
            if er<>0 then  begin
              MessageDlg(' '+S+'   '+inttostr(i)+ '   '+Name,mtError,[mbOk],0);
              Chart.Series[CurrentSeria].Free;
              CloseFile(F);
              Exit;
              end;
            with Chart.Series[CurrentSeria] do begin
                AddXY(X,Y,'',Chart.Series[CurrentSeria].SeriesColor);

            end;
           if  i<6 then begin
             S:=SelectWord(St,3);
             if s<>'' then begin
                           delete(St,1,pos(s,st)-1);
                           Case I of
                             1: Chart.Series[CurrentSeria].Title:=WinFont(St);
                             3: Chart.LeftAxis.Title.Caption :=WinFont(St);
                             2: Chart.BottomAxis.Title.Caption :=WinFont(St);
                             4: begin
                                  Chart.Foot.Text.Add(WinFont(St));
                                end;
                             5: begin
                                  Chart.Foot.Text.Add(WinFont(St));
                                end;
                             end;
                           end ;
            end;
            inc(i);
             end;
       CloseFile(F);
       FileNames.Add(' -'+ IntToStr(GrNo));
       inc(GrNo);

    ActiveSesia:=Chart.SeriesCount-1;
    if ActiveSesia>=0 then begin
                    Label1.Caption:='   '+IntToStr(ActiveSesia+1);
                    Label1.Font.Color:=Chart.Series[ActiveSesia].SeriesColor;
                    if Panel2.Color<>Label1.Font.Color then
                     Label1.Color:=Panel2.Color else Label1.Color:=clWhite;
                 end
                      else Label1.Caption:='';
    Edit1.Enabled:=Chart.SeriesCount>0;
    mnVid.Enabled:=Edit1.Enabled;
  ResizeLegend;
end;
procedure TfmChart.mnDifferClick(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='    ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       // 

       For J:=0 to Chart.Series[i].Count-2 do begin
           try
           Chart.Series[i].YValue[J]:=
             (Chart.Series[i].YValue[J+1]-Chart.Series[i].YValue[J])/
             (Chart.Series[i].XValue[J+1]-Chart.Series[i].XValue[J]);
           Chart.Series[i].XValue[j]:=(Chart.Series[i].XValue[J+1]+Chart.Series[i].XValue[J])/2;
            except
              ShowMessage('   '+IntToStr(I)+'   ');
              break;
            end;
           end;
           Chart.Series[i].Delete(Chart.Series[i].Count-1);
           Chart.Series[i].Title:=Chart.Series[i].Title+'(.)';

     end;
       Inc(K);
   end;

end;

procedure TfmChart.N5Click(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='    ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       // 
           Chart.Series[i].YValue[0]:=0;
       For J:=1 to Chart.Series[i].Count-2 do begin
           Chart.Series[i].YValue[J]:=
            Chart.Series[i].YValue[J-1]+Chart.Series[i].YValue[J]*
            (Chart.Series[i].XValue[J+1]-Chart.Series[i].XValue[J]);
           end;
           Chart.Series[i].Delete(Chart.Series[i].Count-1);
//           Chart.Series[i].YValue[Chart.Series[i].Count-1]:=
//           Chart.Series[i].YValue[Chart.Series[i].Count-2];
           Chart.Series[i].Title:=Chart.Series[i].Title+'(.)';

     end;
    Inc(K);
   end;

end;

procedure TfmChart.RC2Click(Sender: TObject);
begin
  fmChartRC.ShowModal;
end;

procedure TfmChart.RC1Click(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
      dU: array of double;
      Uout: double;
      Max,Min, Step: double;
begin
  Kt:=1e-9;
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='    RC';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       //   dU
       SetLength(dU,Chart.Series[i].Count);
       dU[0]:=Chart.Series[i].YValue[0];
       For J:=1 to Chart.Series[i].Count-1 do begin
         dU[J]:= Chart.Series[i].YValue[J]-Chart.Series[i].YValue[J-1];
           end;
       //  RC
       Uout:=0;
       For J:=0 to Chart.Series[i].Count-1 do begin
           Uout:=Uout+ exp(Chart.Series[i].XValue[J]*Kt/(R*C))*dU[J];
           Chart.Series[i].YValue[J]:= Uout*exp(-Chart.Series[i].XValue[J]*Kt/(R*C));

           end;

           Chart.Series[i].Title:=Chart.Series[i].Title+'( RC)';
     //  
     if fmChartRC.cbRandomError.Checked then
       begin
           Max:=Chart.Series[i].MaxYValue;
           Min:=Chart.Series[i].MinYValue;
           Step:=(Max-Min)/fmChartRC.SpinEdit1.Value;
           Randomize;

       For J:=0 to Chart.Series[i].Count-1 do begin
           Chart.Series[i].YValue[J]:=
             Round(Chart.Series[i].YValue[J]/Step)*Step;
             if Random<0.2 then   Chart.Series[i].YValue[J]:=Chart.Series[i].YValue[J]-Step;
             if Random>0.8 then   Chart.Series[i].YValue[J]:=Chart.Series[i].YValue[J]+Step;

           end;
       end;
     end;
       Inc(K);
   end;


end;

procedure TfmChart.RC3Click(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
      dUKn: array of double;
      SummadUKn,Uin: double;

begin
  Kt:=1e-9;
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='    RC';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin

       //   dUKn
       SetLength(dUKn,Chart.Series[i].Count);

//       dU[0]:=Chart.Series[i].YValue[0];
       SummadUKn:=0;
       For J:=0 to Chart.Series[i].Count-1 do begin
         dUKn[J]:= Chart.Series[i].YValue[J]*exp(Chart.Series[i].XValue[J]*Kt/(R*C))
                  -SummadUKn;
            SummadUKn:=SummadUKn+dUKn[J];
           end;

       //  RC
       Uin:=0;
       For J:=0 to Chart.Series[i].Count-1 do begin
           Uin:=Uin+dUKn[J]*exp(-Chart.Series[i].XValue[J]*Kt/(R*C));
           Chart.Series[i].YValue[J]:= Uin;

           end;
           Chart.Series[i].Title:=Chart.Series[i].Title+'(.RC)';

     end;
       Inc(K);
   end;


end;

procedure TfmChart.ImpRectClick(Sender: TObject);
  var StringStreem: TMemoryStream;
      I : Integer;
      TimePoint, ValuePoint : Double;
      Line1,Line2,Line3,Line4,St,St1: String;
begin
 //  
     Line1:=' ';
     Line2:='t, ';
     Line3:='U, B';
     Line4:='';

     StringStreem:= TMemoryStream.Create;
   try
    For I:=1 to 255 do begin //   
         TimePoint:=I;
       if I<10 then ValuePoint:=0
        else
           if I>200 then ValuePoint:=0
        else
           ValuePoint:=1;

        Str(TimePoint,St);

        Str(ValuePoint,St1);

        St:= St+' '+St1;
         if i=1 then St:=St+' '+ Line1;
         if i=2 then St:=St+' '+ Line2;
         if i=3 then St:=St+' '+ Line3;
         if i=4 then St:=St+' '+ Line4;
        St:=MinProbel(St);
         St:=St+#13#10;
       StringStreem.SetSize(StringStreem.Size+Length(St));
       StringStreem.WriteBuffer(St[1],Length(St));
       end;//   

    StringStreem.SaveToFile('Streem.txt');
     ShowSRG7('Streem.txt');

   finally
   StringStreem. Free;
   end;

end;

procedure TfmChart.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfmChart.N15Click(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
      Value: Double;
  Label 1;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='   ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  fmValue.Caption:='  ';
1: if fmValue.ShowModal<>mrOk then exit;
  Value:=0;
  Active:=True;
  try  Value:=StrToFloat(fmValue.edValue.Text);
  except
     MessageDlg('   ',mtError,[mbOk],0);
     Active:=False;
  end;
   if not Active then   GoTo 1;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       // 
       For J:=0 to Chart.Series[i].Count-1 do
           Chart.Series[i].YValue[J]:=Chart.Series[i].YValue[J]/Value;
     end;
       Inc(K);
   end;


end;

procedure TfmChart.ChartAfterDraw(Sender: TObject);
begin
 mnIzmeritClick(Nil);
end;

procedure TfmChart.ChartGetAxisLabel(Sender: TChartAxis;
  Series: TChartSeries; ValueIndex: Integer; var LabelText: String);
  var CurrentValue: Double;
begin
        CurrentValue:=StrToFloat(LabelText);
        LabelText:=FloatToStrF(CurrentValue,ffGeneral,10,6);
        CurrentValue:=Abs(CurrentValue);
   if CurrentValue<1e-15 then LabelText:='0';

end;

procedure TfmChart.mnSpectrClick(Sender: TObject);
  var fmax, fmin, df, Koef: Real;
      I,J,K: Integer;
var ik:integer;
    h, m, ss, hund, N : Integer;
    omega,re,mni,dt,t,modul,Tall,d:real;
    CountOfTimeStep: Integer;
begin
  if ActiveSesia<0 then begin
     ShowMessage('   ');
     exit;
     end;
 if  Chart.Series[ActiveSesia].MaxYValue = Chart.Series[ActiveSesia].MinYValue
   then begin
     ShowMessage('  -   !!!');
     exit;
     end;
  if fmSpectr.ShowModal<>mrOk then exit;
  fMax:= StrToFloat(fmSpectr.edFMax.Text);
  fMin:= StrToFloat(fmSpectr.edFMin.Text);
  df:= StrToFloat(fmSpectr.eddF.Text);
               Koef:=1;
           Case fmSpectr.cbTime.ItemIndex of
              0: Koef:= 1e-9;  // 
              1: Koef:= 1e-6;   // 
              2: Koef:= 1e-3;   // 
               end;
   CountOfTimeStep:=Round(Chart.Series[ActiveSesia].MaxXValue*fMax*Koef*2);
   if CountOfTimeStep < 200 then CountOfTimeStep:=200;
//     
    NewSeries:=TFastLineSeries.Create(Self);
    Approx(Chart.Series[ActiveSesia], NewSeries,   CountOfTimeStep{Chart.Series[ActiveSesia].Count},
         Chart.Series[ActiveSesia].MaxXValue,Chart.Series[ActiveSesia].MinXValue);
//    FileNames.Add('');
    for i:=0 to NewSeries.Count-1 do
                    //    
            Case fmSpectr.cbTime.ItemIndex of
              0: NewSeries.XValue[i]:=NewSeries.XValue[i]* 1e-9;  // 
              1: NewSeries.XValue[i]:=NewSeries.XValue[i]* 1e-6;   // 
              2: NewSeries.XValue[i]:=NewSeries.XValue[i]* 1e-3;   // 
               end;

    NewSeries.ParentChart:=Chart;
    Chart.Series[Chart.SeriesCount-1].Title:='.';

//    
    NewSeries:=TFastLineSeries.Create(Self);
    NewSeries.ParentChart:=Chart;
    Chart.Series[Chart.SeriesCount-1].Title:=' ';
    FileNames.Add(' -'+ IntToStr(GrNo));
    inc(GrNo);
    NewSeries:=TFastLineSeries.Create(Self);
    NewSeries.ParentChart:=Chart;
    Chart.Series[Chart.SeriesCount-1].Title:=' ';
    FileNames.Add(' -'+ IntToStr(GrNo));
    inc(GrNo);
// 

  k:=Chart.Series[Chart.SeriesCount-3].Count;
  n:=round(fmax/df);
  ik:=round(fmin/df);

  for i:=ik to n-1 do begin {  }
      omega:=2*pi*i*df;
      re:=0; mni:=0;

      for j:=1 to k-1 do begin {  }
        t:=Chart.Series[Chart.SeriesCount-3].XValue[j];
        dt:=t-Chart.Series[Chart.SeriesCount-3].XValue[j-1];
        mni:=mni+Chart.Series[Chart.SeriesCount-3].YValue[j]*sin(omega*t)*dt;
        re:=re+Chart.Series[Chart.SeriesCount-3].YValue[j]*cos(omega*t)*dt;
        end; {  }

       with Chart.Series[Chart.SeriesCount-2] do
                AddXY(omega/2/pi,sqrt(mni*mni+re*re),'',Chart.Series[Chart.SeriesCount-2].SeriesColor);
       with Chart.Series[Chart.SeriesCount-1] do
                begin
                if re>0 then
                  AddXY(omega/2/pi,arcTan(-mni/re),'',Chart.Series[Chart.SeriesCount-2].SeriesColor)
                  else AddXY(omega/2/pi,arcTan(-mni/re)+pi,'',Chart.Series[Chart.SeriesCount-2].SeriesColor);
                end;

                   end; {  }

//  
     Repeat
      for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Title='.'
              then  begin Chart.Series[i].Free; break; end;
      until I>=Chart.SeriesCount;

 ResizeLegend;
end;

procedure TfmChart.N4Click(Sender: TObject);
begin
  if Chart.SeriesCount<1 then exit;
  Chart.ZoomPercent(85);
  Chart.BottomAxis.Minimum:= Chart.Series[ActiveSesia].MinXValue;
  Chart.BottomAxis.Maximum:= Chart.Series[ActiveSesia].MaxXValue;
  Chart.LeftAxis.Minimum:= Chart.Series[ActiveSesia].MinYValue;
  Chart.LeftAxis.Maximum:= Chart.Series[ActiveSesia].MaxYValue;
end;

procedure TfmChart.N17Click(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
    Shag, X,Y: double;
    N: Integer;


begin
  Chart.UndoZoom;
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='   ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  //     
  K:=0;
  N:=0;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then
     begin
     If fmSelectGr.ListBox1.Selected[K] then
          if Chart.Series[i].Count > N then N:=Chart.Series[i].Count;
       Inc(K);
   end;

    //     
  K:=0;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
           NewSeries:=TFastLineSeries.Create(Self);
           NewSeries.ParentChart:=Chart;
           Approx(Chart.Series[i],NewSeries, N,Chart.MaxXValue(Chart.BottomAxis),Chart.MinXValue(Chart.BottomAxis));
           Chart.Series[Chart.SeriesCount-1].Title:='.';
     end;
       Inc(K);
   end;
   // 

     Shag:= (Chart.MaxXValue(Chart.BottomAxis)-Chart.MinXValue(Chart.BottomAxis))/(N-1);
      NewSeries:=TFastLineSeries.Create(Self);
    For J:=0 to N-1 do begin
      Y:=1;
      X:=J*Shag+Chart.MinXValue(Chart.BottomAxis);
      for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Title='.' then begin
           Y:=Y* Chart.Series[i].YValue[J];
           end;
      NewSeries.AddXY(X,Y,'',NewSeries.SeriesColor);
      end;
    //  
     Repeat
      for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Title='.'
              then  begin Chart.Series[i].Free; break; end;
      until I>=Chart.SeriesCount;


    NewSeries.ParentChart:=Chart;
    Chart.Series[Chart.SeriesCount-1].Title:='';
    FileNames.Add(' -'+ IntToStr(GrNo));
    inc(GrNo);
    ResizeLegend;

end;

procedure TfmChart.Y1Y1Click(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='   Y=1/Y';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       // 1/Y
       J:=0;
       repeat
             if Chart.Series[i].YValue[J]<>0 then
              Chart.Series[i].YValue[J]:=1/Chart.Series[i].YValue[J]
               else  Chart.Series[i].Delete(J);
               J:=J+1;
       until   J> Chart.Series[i].Count-1;
     end;
       Inc(K);
   end;


end;

procedure TfmChart.N18Click(Sender: TObject);
var TMax, dt, df,
    Koef, Ampl,
    Faza, dw, w,
    t, modul: Real;
    I,J, NStep: Integer;

begin
  if ActiveSesia<0 then begin
     ShowMessage('   ');
     exit;
     end;
  if fmBackSpectr.ShowModal<>mrOk then exit;
  TMax:= StrToFloat(fmBackSpectr.edTMax.Text);
  NStep:=StrToInt(fmBackSpectr.edNPoint.Text);
  dT:=TMax / NStep;
  df:=Chart.Series[Chart.SeriesCount-1].XValue[1]-Chart.Series[Chart.SeriesCount-1].XValue[0];
  dw:=2*Pi*df;
  if df>1/2/tmax  then
       begin
        TMax:=1/2/df;
        dT:=TMax / NStep;
        ShowMessage('   '+ FloatToStr(dF)+
                    '  ,      '+FloatToStr(dt)+' c');
       end;
               Koef:=1;
           Case fmBackSpectr.cbTime.ItemIndex of
              0: Koef:= 1e9;  // 
              1: Koef:= 1e6;   // 
              2: Koef:= 1e3;   // 
               end;

//    
    NewSeries:=TFastLineSeries.Create(Self);
    NewSeries.ParentChart:=Chart;
    Chart.Series[Chart.SeriesCount-1].Title:='    ';
    FileNames.Add(' -'+ IntToStr(GrNo));
    inc(GrNo);

 //  

     for i:=0 to NStep do begin {  p}
        Ampl:=0;
        t:=i*dt;
        for j:=0 to Chart.Series[Chart.SeriesCount-3].Count-1 do begin {  }
           modul:=Chart.Series[Chart.SeriesCount-3].YValue[j];
           faza:=Chart.Series[Chart.SeriesCount-2].YValue[j];
           w:=Chart.Series[Chart.SeriesCount-2].XValue[j]*2*pi;
           if w=0 then modul:= modul/2; //(      )
           Ampl:=ampl+modul*Cos(w*t+faza)*dw;
           end; {  }
        Chart.Series[Chart.SeriesCount-1].AddXY(T*Koef,Ampl/pi,'',Chart.Series[Chart.SeriesCount-1].SeriesColor);
        end; {  p}

    ResizeLegend;
end;
{================================================================}

procedure TfmChart.N19Click(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
      MaxValue: Double;
begin
//    
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='   ';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;

  K:=0;
  MaxValue:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       //   
       For J:=0 to Chart.Series[i].Count-1 do
           if abs(Chart.Series[i].YValue[J])> MaxValue
                  then MaxValue:=abs(Chart.Series[i].YValue[J]);
     end;
       Inc(K);
   end;
  if MaxValue=0 then exit;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       //    
       For J:=0 to Chart.Series[i].Count-1 do
           Chart.Series[i].YValue[J]:=Chart.Series[i].YValue[J]/MaxValue;
     end;
       Inc(K);
   end;

end;

procedure TfmChart.N20Click(Sender: TObject);
 var I,K,J : integer;
      Active: boolean;
      Value: Double;
  Label 1;
begin
  Active:=False;
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then Active:=True;
  if not Active then exit;
  fmSelectGr.Caption:='     X';
  fmSelectGr.Enter;
  if fmSelectGr.ModalResult<>mrOk then exit;
  fmValue.Caption:='  ';
1: if fmValue.ShowModal<>mrOk then exit;
  Value:=0;
  Active:=True;
  try  Value:=StrToFloat(fmValue.edValue.Text);
  except
     MessageDlg('   ',mtError,[mbOk],0);
     Active:=False;
  end;
   if not Active then   GoTo 1;
  K:=0;
    //  
  for  I:=0 to Chart.SeriesCount-1 do if Chart.Series[i].Tag=0 then begin
     If fmSelectGr.ListBox1.Selected[K] then begin
       // 
       For J:=0 to Chart.Series[i].Count-1 do
           Chart.Series[i].XValue[J]:=Chart.Series[i].XValue[J]/Value;
     end;
       Inc(K);
   end;

end;

end.
