unit ChartOfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TfmEditComments = class(TForm)
    Label1: TLabel;
    edLeftAxis: TEdit;
    MemoTitle: TMemo;
    Label2: TLabel;
    MemoFoot: TMemo;
    Label3: TLabel;
    Label4: TLabel;
    edRightAxis: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    edTopAxis: TEdit;
    edBottomAxis: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SpeedButton1: TSpeedButton;
    FontD: TFontDialog;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    edLeftAngle: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    edRightAngle: TEdit;
    Label9: TLabel;
    edTopAngle: TEdit;
    Label10: TLabel;
    edBottomAngle: TEdit;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmEditComments: TfmEditComments;

implementation

uses ChartMy;

{$R *.DFM}





procedure TfmEditComments.SpeedButton1Click(Sender: TObject);
begin
  FontD.Font:= fmChart.Chart.LeftAxis.LabelsFont;
  if FontD.Execute then  fmChart.Chart.LeftAxis.LabelsFont := FontD.Font;
  fmChart.Chart.Repaint;
end;




procedure TfmEditComments.SpeedButton3Click(Sender: TObject);
begin
  FontD.Font:= fmChart.Chart.RightAxis.LabelsFont;
  if FontD.Execute then  fmChart.Chart.RightAxis.LabelsFont := FontD.Font;
  fmChart.Chart.Repaint;

end;

procedure TfmEditComments.SpeedButton4Click(Sender: TObject);
begin
  FontD.Font:= fmChart.Chart.TopAxis.LabelsFont;
  if FontD.Execute then  fmChart.Chart.TopAxis.LabelsFont := FontD.Font;
  fmChart.Chart.Repaint;

end;

procedure TfmEditComments.SpeedButton2Click(Sender: TObject);
begin
  FontD.Font:= fmChart.Chart.BottomAxis.LabelsFont;
  if FontD.Execute then  fmChart.Chart.BottomAxis.LabelsFont := FontD.Font;
  fmChart.Chart.Repaint;

end;



procedure TfmEditComments.SpeedButton6Click(Sender: TObject);
begin
  FontD.Font:=fmChart.Chart.Title.Font;
   if FontD.Execute then  fmChart.Chart.Title.Font := FontD.Font;
  fmChart.Chart.Repaint;

end;

procedure TfmEditComments.SpeedButton5Click(Sender: TObject);
begin
   FontD.Font:=fmChart.Chart.Foot.Font;
   if FontD.Execute then  fmChart.Chart.foot.Font := FontD.Font;
   fmChart.Chart.Repaint;

end;

procedure TfmEditComments.SpeedButton7Click(Sender: TObject);
begin
    FontD.Font:=fmChart.Chart.LeftAxis.Title.Font;
    if FontD.Execute then fmChart.Chart.LeftAxis.Title.Font:= FontD.Font;
    fmChart.Chart.Repaint;
end;

procedure TfmEditComments.SpeedButton8Click(Sender: TObject);
begin
    FontD.Font:=fmChart.Chart.TopAxis.Title.Font;
    if FontD.Execute then fmChart.Chart.TopAxis.Title.Font:= FontD.Font;
    fmChart.Chart.Repaint;

end;

procedure TfmEditComments.SpeedButton10Click(Sender: TObject);
begin
    FontD.Font:=fmChart.Chart.RightAxis.Title.Font;
    if FontD.Execute then fmChart.Chart.RightAxis.Title.Font:= FontD.Font;
    fmChart.Chart.Repaint;

end;

procedure TfmEditComments.SpeedButton9Click(Sender: TObject);
begin
    FontD.Font:=fmChart.Chart.BottomAxis.Title.Font;
    if FontD.Execute then fmChart.Chart.BottomAxis.Title.Font:= FontD.Font;
    fmChart.Chart.Repaint;

end;




end.
